c-------------------------------------------------------------------------
c f90gl Version 1.0 September 1996
c 
c William F. Mitchell
c Applied and Computational Mathematics Division
c National Institute of Standards and Technology
c Gaithersburg, MD 20899
c william.mitchell@nist.gov
c 
c This fortran interface for GLUT software and documentation have been produced
c as part of work done by the U.S. Government, and are not subject to copyright
c in the United States.
c 
c The mention of specific products, trademarks, or brand names in the
c documentation is for purposes of identification only.  Such mention is not to
c be interpreted in any way as an endorsement or certification of such products
c or brands by the National Institute of Standards and Technology.
c All trademarks mentioned herein belong to their respective owners.
c-------------------------------------------------------------------------

C  GLUT Fortran example; touches a reasonable amount of GLUT
C  callback functionality.

	subroutine display
       include "GL/fgl.h"
	call fglclear(GL_COLOR_BUFFER_BIT)
	call fglfinish
	end

	subroutine passive(x,y)
	integer x,y
	print *,'passive motion',x,y
	end

	subroutine submenu(value)
	integer value
	print *,'value is',value
	end

	subroutine mainmenu(value)
	integer value
	print *,'main menu value is',value
	end

	subroutine timer(value)
	integer value
	print *,'timer value',value
	end

	subroutine mouse(btn,state,x,y)
       include "GL/fglut.h"
	external timer
	integer btn,state,x,y
	print *,'mouse',btn,state,x,y
	call gluttimerfunc(1000,timer,25)
	end

	subroutine idle()
       include "GL/fglut.h"
	integer count
	print *,'idle called'
	call glutidlefunc(glutnull)
	end

	subroutine keyboard(key,x,y)
	external idle
	integer key,x,y
	print *,'keyboard',key,x,y
	call glutidlefunc(idle)
	end

	subroutine tablet(x,y)
	integer x,y
	print *,'tablet motion',x,y
	end

	subroutine tbutton(button,state)
	integer button,state
	print *,'tablet button',button,state
	end

	subroutine dials(dial,value)
	integer dial,value
	print *,'dial movement',dial,value
	end

	subroutine box(button,state)
	integer button,state
	print *,'button box',button,state
	end

	program main
       include "GL/fglut.h"
	external display
	external passive
	external submenu
	external mainmenu
	external mouse
	external keyboard
	external tablet
	external tbutton
	external dials
	external box
	call glutinit
	print *,glutcreatewindow('Fortran GLUT program')
	call glutdisplayfunc(display)
	call glutpassivemotionfunc(passive)
	call glutmousefunc(mouse)
	call glutkeyboardfunc(keyboard)
	call gluttabletmotionfunc(tablet)
	call gluttabletbuttonfunc(tbutton)
	call glutdialsfunc(dials)
	call glutbuttonboxfunc(box)
	i = glutcreatemenu(submenu)
	call glutaddmenuentry('something', 4)
	call glutaddmenuentry('another thing', 5)
	j = glutcreatemenu(mainmenu)
	call glutaddsubmenu('submenu', i)
	call glutaddmenuentry('quit', 666)
	call glutattachmenu(2)
	print *,'Number of button box buttons:',
     2    glutdeviceget(GLUT_NUM_BUTTON_BOX_BUTTONS)
	print *,'Number of dials:',glutdeviceget(GLUT_NUM_DIALS)
	print *,'Depth buffer size',glutget(GLUT_WINDOW_DEPTH_SIZE)
	call glutmainloop
	end

