c-------------------------------------------------------------------------
c f90gl Version 1.0 September 1996
c 
c William F. Mitchell
c Applied and Computational Mathematics Division
c National Institute of Standards and Technology
c Gaithersburg, MD 20899
c william.mitchell@nist.gov
c 
c This fortran interface for GLUT software and documentation have been produced
c as part of work done by the U.S. Government, and are not subject to copyright
c in the United States.
c 
c The mention of specific products, trademarks, or brand names in the
c documentation is for purposes of identification only.  Such mention is not to
c be interpreted in any way as an endorsement or certification of such products
c or brands by the National Institute of Standards and Technology.
c All trademarks mentioned herein belong to their respective owners.
c-------------------------------------------------------------------------

      subroutine display()
      include 'GL/fgl.h'
      call fglClear(ior(GL_COLOR_BUFFER_BIT,GL_DEPTH_BUFFER_BIT))
      call fglCallList(1)
      call fglFlush()
      return
      end
    
      program main
      include 'GL/fgl.h'
      include 'GL/fglu.h'
      include 'GL/fglut.h'
    
      real mat_red_diffuse(4),mat_green_diffuse(4),mat_blue_diffuse(4),
     .     mat_yellow_diffuse(4), mat_specular(4), mat_shininess(1),
     .     knots(8), pts1(3,4,4), pts2(3,4,4), pts3(3,4,4), pts4(3,4,4)
    
       data mat_red_diffuse / 0.7, 0.0, 0.1, 1.0 /
       data mat_green_diffuse / 0.0, 0.7, 0.1, 1.0 /
       data mat_blue_diffuse / 0.0, 0.1, 0.7, 1.0 /
       data mat_yellow_diffuse / 0.7, 0.8, 0.1, 1.0 /
       data mat_specular / 1.0, 1.0, 1.0, 1.0 /
       data mat_shininess / 100.0 /
       data knots / 0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, 1.0 /
    
      integer nurb
      integer u, v, wind
      external display
      real real_glu_fill
      integer fgluNewNurbsRenderer
      external glutCreateWindow, fgluNewNurbsRenderer
    
      call glutInit
      wind = glutCreateWindow("molehill")
      call fglMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular)
      call fglMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess)
      call fglEnable(GL_LIGHTING)
      call fglEnable(GL_LIGHT0)
      call fglEnable(GL_DEPTH_TEST)
      call fglEnable(GL_AUTO_NORMAL)
      call fglEnable(GL_NORMALIZE)
      nurb = fgluNewNurbsRenderer()
      call fgluNurbsProperty(nurb, GLU_SAMPLING_TOLERANCE, 25.0)
      real_glu_fill = GLU_FILL
      call fgluNurbsProperty(nurb, GLU_DISPLAY_MODE, real_glu_fill)
    
c Build control points for NURBS mole hills.
      do 20 u=1,4
        do 10 v=1,4
c Red.
          pts1(1,v,u) = 2.0*(u-1)
          pts1(2,v,u) = 2.0*(v-1)
          if((u.eq.2 .or. u .eq. 3) .and. (v .eq. 2 .or. v .eq. 3)) then
c Stretch up middle.
    	    pts1(3,v,u) = 6.0
          else
    	    pts1(3,v,u) = 0.0
          endif
    
c Green.
          pts2(1,v,u) = 2.0*(u - 4)
          pts2(2,v,u) = 2.0*(v - 4)
          if((u.eq.2 .or. u .eq. 3) .and. (v .eq. 2 .or. v .eq. 3)) then
    	    if(u .eq. 2 .and. v .eq. 2) then
c Pull hard on single middle square.
    	      pts2(3,v,u) = 15.0
    	    else
c Push down on other middle squares.
    	      pts2(3,v,u) = -2.0
            endif
          else
    	    pts2(3,v,u) = 0.0
          endif
    
c Blue.
          pts3(1,v,u) = 2.0*(u - 4)
          pts3(2,v,u) = 2.0*(v-1)
          if((u.eq.2 .or. u .eq. 3) .and. (v .eq. 2 .or. v .eq. 3)) then
    	    if(u .eq. 2 .and. v .eq. 3) then
c Pull up on single middple square.
    	      pts3(3,v,u) = 11.0
    	    else
c Pull up slightly on other middle squares.
    	      pts3(3,v,u) = 2.0
            endif
          else
    	    pts3(3,v,u) = 0.0
          endif
    
c Yellow.
          pts4(1,v,u) = 2.0*(u-1)
          pts4(2,v,u) = 2.0*(v - 4)
          if((u .eq. 2 .or. u .eq. 3 .or. u .eq. 4) .and.
     .       (v .eq. 2 .or. v .eq. 3)) then
    	    if(v .eq. 2) then
c Push down front middle and right squares.
    	      pts4(3,v,u) = -2.0
    	    else
c Pull up back middle and right squares.
    	      pts4(3,v,u) = 5.0
            endif
          else
    	    pts4(3,v,u) = 0.0
          endif
   10   continue
   20 continue
c Stretch up red's far right corner.
      pts1(3,4,4) = 6
c Pull down green's near left corner a little.
      pts2(3,1,1) = -2
c Turn up meeting of four corners.
      pts1(3,1,1) = 1
      pts2(3,4,4) = 1
      pts3(3,1,4) = 1
      pts4(3,4,1) = 1
    
      call fglMatrixMode(GL_PROJECTION)
      call fgluPerspective(55.0d0, 1.0d0, 2.0d0, 24.0d0)
      call fglMatrixMode(GL_MODELVIEW)
      call fglTranslatef(0.0, 0.0, -15.0)
      call fglRotatef(330.0, 1.0, 0.0, 0.0)
    
      call fglNewList(1, GL_COMPILE)
c Render red hill.
        call fglMaterialfv(GL_FRONT, GL_DIFFUSE, mat_red_diffuse)
        call fgluBeginSurface(nurb)
          call fgluNurbsSurface(nurb, 8, knots, 8, knots, 
     .      4 * 3, 3, pts1, 
     .      4, 4, GL_MAP2_VERTEX_3)
        call fgluEndSurface(nurb)
    
c Render green hill.
        call fglMaterialfv(GL_FRONT, GL_DIFFUSE, mat_green_diffuse)
        call fgluBeginSurface(nurb)
          call fgluNurbsSurface(nurb, 8, knots, 8, knots, 
     .      4 * 3, 3, pts2, 
     .      4, 4, GL_MAP2_VERTEX_3)
        call fgluEndSurface(nurb)
    
c Render blue hill.
        call fglMaterialfv(GL_FRONT, GL_DIFFUSE, mat_blue_diffuse)
        call fgluBeginSurface(nurb)
          call fgluNurbsSurface(nurb, 8, knots, 8, knots, 
     .      4 * 3, 3, pts3, 
     .      4, 4, GL_MAP2_VERTEX_3)
        call fgluEndSurface(nurb)
    
c Render yellow hill.
        call fglMaterialfv(GL_FRONT, GL_DIFFUSE, mat_yellow_diffuse)
        call fgluBeginSurface(nurb)
          call fgluNurbsSurface(nurb, 8, knots, 8, knots, 
     .      4 * 3, 3, pts4, 
     .      4, 4, GL_MAP2_VERTEX_3)
        call fgluEndSurface(nurb)
      call fglEndList()
    
      call glutDisplayFunc(display)
      call glutMainLoop
      end
