c-------------------------------------------------------------------------
c f90gl Version 1.0 September 1996
c 
c William F. Mitchell
c Applied and Computational Mathematics Division
c National Institute of Standards and Technology
c Gaithersburg, MD 20899
c william.mitchell@nist.gov
c 
c This fortran interface for GLUT software and documentation have been produced
c as part of work done by the U.S. Government, and are not subject to copyright
c in the United States.
c 
c The mention of specific products, trademarks, or brand names in the
c documentation is for purposes of identification only.  Such mention is not to
c be interpreted in any way as an endorsement or certification of such products
c or brands by the National Institute of Standards and Technology.
c All trademarks mentioned herein belong to their respective owners.
c-------------------------------------------------------------------------

C  GLUT Fortran program to draw red light sphere.

	subroutine display
       include "GL/fgl.h"
	call fglclear(GL_COLOR_BUFFER_BIT + GL_DEPTH_BUFFER_BIT)
	call fglcalllist(1)
	call glutswapbuffers
	end

	subroutine gfxinit
       include "GL/fgl.h"
	real diffuse(4),pos(4)
	data diffuse /1.0, 0.0, 0.0, 1.0/
	data pos /1.0, 1.0, 1.0, 0.0/
	call fglnewlist(1, GL_COMPILE)
	call glutsolidsphere(dble(1.0), 20, 20)
	call fglendlist
	call fgllightfv(GL_LIGHT0, GL_DIFFUSE, diffuse)
	call fgllightfv(GL_LIGHT0, GL_POSITION, pos)
	call fglenable(GL_LIGHTING)
	call fglenable(GL_LIGHT0)
	call fglenable(GL_DEPTH_TEST)
	call fglmatrixmode(GL_PROJECTION)
	call fgluperspective(dble(40.0), dble(1.0),
     2                       dble(1.0), dble(10.0))
	call fglmatrixmode(GL_MODELVIEW)
	call fglulookat(dble(0.0), dble(0.0), dble(5.0),
     2                  dble(0.0), dble(0.0), dble(0.0),
     3                  dble(0.0), dble(1.0), dble(1.0))
	call fgltranslatef(0.0, 0.0, -1.0)
	end

	program main
       include "GL/fglut.h"
	external display
	external reshape
	external submenu
	external mainmenu
	call glutinit
	call glutinitdisplaymode(GLUT_DOUBLE+GLUT_RGB+GLUT_DEPTH)
	i = glutcreatewindow('Fortran GLUT sphere')
	call gfxinit
	call glutdisplayfunc(display)
	call glutmainloop
	end

