/*-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for GLUT software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------*/

#ifdef FBIND


#include <string.h>
#include <GL/gl.h>
#include <GL/glut.h>

/* equalence of types

 OpenGL          description              C     extended fortan 77

GLboolean   8-bit unsigned integer  unsigned char  logical*1
GLbyte      8-bit integer           signed char    integer*1
GLubyte     8-bit unsigned integer  unsigned char  integer*1
GLshort    16-bit integer           short          integer*2
GLushort   16-bit unsigned integer  unsigned short integer*2
GLint      32-bit integer           long           integer*4
GLuint     32-bit unsigned integer  unsigned long  integer*4
GLenum     32-bit unsigned integer  unsigned long  integer*4
GLbitfield 32-bit unsigned integer  unsigned long  integer*4
GLsizei    32-bit integer           long           integer*4
GLfloat    32-bit floating point    float          real*4
GLclampf   32-bit floating point    float          real*4
GLdouble   64-bit floating point    double         real*8
GLclampd   64-bit floating point    double         real*8
GLvoid     generic pointer GLvoid*  void           any array


   f90gl            fortran 90

f90glboolean    logical(kind=k) where k gives a 1 byte logical, if possible
f90glbyte       selected_int_kind(2)
f90glubyte      selected_int_kind(2)
f90glshort      selected_int_kind(4)
f90glushort     selected_int_kind(4)
f90glint        selected_int_kind(9)
f90gluint       selected_int_kind(9)
f90glenum       selected_int_kind(9)
f90glbitfield   selected_int_kind(9)
f90glsizei      selected_int_kind(9)
f90glfloat      selected_real_kind(6)
f90glclampf     selected_real_kind(6)
f90gldouble     selected_real_kind(15)
f90glclampd     selected_real_kind(15)
f90glvoid       any array

f90glcint       selected_real_kind(9)
f90glcuint      selected_real_kind(9)

*/

/*
 * Mapping of Fortran types to C types:
 */

#define f90glboolean  unsigned char *
#define f90glbyte     signed char *
#define f90glubyte    unsigned char *
#define f90glshort    short *
#define f90glushort   unsigned short *
#define f90glint      long *
#define f90gluint     unsigned long *
#define f90glenum     unsigned long *
#define f90glbitfield unsigned long *
#define f90glsizei    long *
#define f90glfloat    float *
#define f90glclampf   float *
#define f90gldouble   double *
#define f90glclampd   double *
#define f90glvoid     long *
#define f90glcint     int *
#define f90glcuint    unsigned int *

#define end_of_string '\0'

/* procedure name mangling */

#if FBIND==1
#define f9yglutCreateWindow            f9yglutcreatewindow
#define f9yglutSetWindowTitle          f9yglutsetwindowtitle
#define f9yglutSetIconTitle            f9yglutseticontitle
#define f9yglutAddMenuEntry            f9yglutaddmenuentry
#define f9yglutAddSubMenu              f9yglutaddsubmenu
#define f9yglutChangeToMenuEntry       f9yglutchangetomenuentry
#define f9yglutChangeToSubMenu         f9yglutchangetosubmenu
#define f9yglutExtensionSupported      f9yglutextensionsupported
#elif FBIND==2
#define f9yglutCreateWindow            f9yglutcreatewindow_
#define f9yglutSetWindowTitle          f9yglutsetwindowtitle_
#define f9yglutSetIconTitle            f9yglutseticontitle_
#define f9yglutAddMenuEntry            f9yglutaddmenuentry_
#define f9yglutAddSubMenu              f9yglutaddsubmenu_
#define f9yglutChangeToMenuEntry       f9yglutchangetomenuentry_
#define f9yglutChangeToSubMenu         f9yglutchangetosubmenu_
#define f9yglutExtensionSupported      f9yglutextensionsupported_
#elif FBIND==3
#define f9yglutCreateWindow            F9YGLUTCREATEWINDOW
#define f9yglutSetWindowTitle          F9YGLUTSETWINDOWTITLE
#define f9yglutSetIconTitle            F9YGLUTSETICONTITLE
#define f9yglutAddMenuEntry            F9YGLUTADDMENUENTRY
#define f9yglutAddSubMenu              F9YGLUTADDSUBMENU
#define f9yglutChangeToMenuEntry       F9YGLUTCHANGETOMENUENTRY
#define f9yglutChangeToSubMenu         F9YGLUTCHANGETOSUBMENU
#define f9yglutExtensionSupported      F9YGLUTEXTENSIONSUPPORTED
#endif

/* wrapper functions that change types */

int f9yglutCreateWindow(f90gluint title, f90glint size_title )
{
   unsigned char *char_title = (unsigned char *)malloc((*size_title+1)*sizeof(unsigned char));
   int i;
   for (i=0;i<*size_title;i++) char_title[i]=(unsigned char) title[i];
   char_title[*size_title] = end_of_string;
   return (int) glutCreateWindow( char_title);
}

void f9yglutSetWindowTitle(f90gluint title, f90glint size_title )
{
   unsigned char *char_title = (unsigned char *)malloc((*size_title+1)*sizeof(unsigned char));
   int i;
   for (i=0;i<*size_title;i++) char_title[i]=(unsigned char) title[i];
   char_title[*size_title] = end_of_string;
   glutSetWindowTitle( char_title);
}

void f9yglutSetIconTitle(f90gluint title, f90glint size_title )
{
   unsigned char *char_title = (unsigned char *)malloc((*size_title+1)*sizeof(unsigned char));
   int i;
   for (i=0;i<*size_title;i++) char_title[i]=(unsigned char) title[i];
   char_title[*size_title] = end_of_string;
   glutSetIconTitle( char_title);
}

void f9yglutAddMenuEntry(f90gluint label, f90glint size_label,f90glcint value )
{
   unsigned char *char_label = (unsigned char *)malloc((*size_label+1)*sizeof(unsigned char));
   int i;
   for (i=0;i<*size_label;i++) char_label[i]=(unsigned char) label[i];
   char_label[*size_label] = end_of_string;
   glutAddMenuEntry( char_label, (int) *value);
}

void f9yglutAddSubMenu(f90gluint label, f90glint size_label,f90glcint submenu )
{
   unsigned char *char_label = (unsigned char *)malloc((*size_label+1)*sizeof(unsigned char));
   int i;
   for (i=0;i<*size_label;i++) char_label[i]=(unsigned char) label[i];
   char_label[*size_label] = end_of_string;
   glutAddSubMenu( char_label, (int) *submenu);
}

void f9yglutChangeToMenuEntry(f90glcint item,f90gluint label,
    f90glint size_label,f90glcint value )
{
   unsigned char *char_label = (unsigned char *)malloc((*size_label+1)*sizeof(unsigned char));
   int i;
   for (i=0;i<*size_label;i++) char_label[i]=(unsigned char) label[i];
   char_label[*size_label] = end_of_string;
   glutChangeToMenuEntry( (int) *item, char_label, (int) *value);
}

void f9yglutChangeToSubMenu(f90glcint item,f90gluint label, f90glint size_label,
   f90glcint submenu )
{
   unsigned char *char_label = (unsigned char *)malloc((*size_label+1)*sizeof(unsigned char));
   int i;
   for (i=0;i<*size_label;i++) char_label[i]=(unsigned char) label[i];
   char_label[*size_label] = end_of_string;
   glutChangeToSubMenu( (int) *item, char_label, (int) *submenu);
}

int f9yglutExtensionSupported(f90gluint name, f90glint size_name )
{
   unsigned char *char_name = (unsigned char *)malloc((*size_name+1)*sizeof(unsigned char));
   int i;
   for (i=0;i<*size_name;i++) char_name[i]=(unsigned char) name[i];
   char_name[*size_name] = end_of_string;
   return (int) glutExtensionSupported( char_name);
}


#else /*ifdef FBIND*/



/* If FBIND is not defined, Fortran bindings aren't made.  Need this
 * dummy function for some picky compilers.
 */
static void dummy()
{
   return;
}

 
 
#endif /*ifdef FBIND*/
