/*-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for GLUT software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------*/

#ifdef FBIND


#include <string.h>
#include <GL/gl.h>
#include <GL/glut.h>

/* equalence of types

 OpenGL          description              C     extended fortan 77

GLboolean   8-bit unsigned integer  unsigned char  logical*1
GLbyte      8-bit integer           signed char    integer*1
GLubyte     8-bit unsigned integer  unsigned char  integer*1
GLshort    16-bit integer           short          integer*2
GLushort   16-bit unsigned integer  unsigned short integer*2
GLint      32-bit integer           long           integer*4
GLuint     32-bit unsigned integer  unsigned long  integer*4
GLenum     32-bit unsigned integer  unsigned long  integer*4
GLbitfield 32-bit unsigned integer  unsigned long  integer*4
GLsizei    32-bit integer           long           integer*4
GLfloat    32-bit floating point    float          real*4
GLclampf   32-bit floating point    float          real*4
GLdouble   64-bit floating point    double         real*8
GLclampd   64-bit floating point    double         real*8
GLvoid     generic pointer GLvoid*  void           any array


   f90gl            fortran 90

f90glboolean    logical(kind=k) where k gives a 1 byte logical, if possible
f90glbyte       selected_int_kind(2)
f90glubyte      selected_int_kind(2)
f90glshort      selected_int_kind(4)
f90glushort     selected_int_kind(4)
f90glint        selected_int_kind(9)
f90gluint       selected_int_kind(9)
f90glenum       selected_int_kind(9)
f90glbitfield   selected_int_kind(9)
f90glsizei      selected_int_kind(9)
f90glfloat      selected_real_kind(6)
f90glclampf     selected_real_kind(6)
f90gldouble     selected_real_kind(15)
f90glclampd     selected_real_kind(15)
f90glvoid       any array

f90glcint       selected_real_kind(9)
f90glcuint      selected_real_kind(9)
f90glcchar      void *
f90glculong     selected_int_kind(9)

*/

/*
 * Mapping of Fortran types to C types:
 */

#define f90glboolean  unsigned char *
#define f90glbyte     signed char *
#define f90glubyte    unsigned char *
#define f90glshort    short *
#define f90glushort   unsigned short *
#define f90glint      long *
#define f90gluint     unsigned long *
#define f90glenum     unsigned long *
#define f90glbitfield unsigned long *
#define f90glsizei    long *
#define f90glfloat    float *
#define f90glclampf   float *
#define f90gldouble   double *
#define f90glclampd   double *
#define f90glvoid     long *
#define f90glcint     int *
#define f90glcuint    unsigned int *
#define f90glcchar    void *
#define f90glculong   unsigned long *

#define end_of_string '\0'

/* procedure name mangling */

#if FBIND==1
#define fglutInitDisplayMode            glutinitdisplaymode
#define fglutInitWindowPosition         glutinitwindowposition
#define fglutInitWindowSize             glutinitwindowsize
#define fglutMainLoop                   glutmainloop
#define fglutCreateWindow               glutcreatewindow
#define fglutCreateSubWindow            glutcreatesubwindow
#define fglutDestroyWindow              glutdestroywindow
#define fglutPostRedisplay              glutpostredisplay
#define fglutSwapBuffers                glutswapbuffers
#define fglutGetWindow                  glutgetwindow
#define fglutSetWindow                  glutsetwindow
#define fglutSetWindowTitle             glutsetwindowtitle
#define fglutSetIconTitle               glutseticontitle
#define fglutPositionWindow             glutpositionwindow
#define fglutReshapeWindow              glutreshapewindow
#define fglutPopWindow                  glutpopwindow
#define fglutPushWindow                 glutpushwindow
#define fglutIconifyWindow              gluticonifywindow
#define fglutShowWindow                 glutshowwindow
#define fglutHideWindow                 gluthidewindow
#define fglutFullScreen                 glutfullscreen
#define fglutSetCursor                  glutsetcursor
#define fglutEstablishOverlay           glutestablishoverlay
#define fglutRemoveOverlay              glutremoveoverlay
#define fglutUseLayer                   glutuselayer
#define fglutPostOverlayRedisplay       glutpostoverlayredisplay
#define fglutShowOverlay                glutshowoverlay
#define fglutHideOverlay                gluthideoverlay
#define fglutDestroyMenu                glutdestroymenu
#define fglutGetMenu                    glutgetmenu
#define fglutSetMenu                    glutsetmenu
#define fglutAddMenuEntry               glutaddmenuentry
#define fglutAddSubMenu                 glutaddsubmenu
#define fglutChangeToMenuEntry          glutchangetomenuentry
#define fglutChangeToSubMenu            glutchangetosubmenu
#define fglutRemoveMenuItem             glutremovemenuitem
#define fglutAttachMenu                 glutattachmenu
#define fglutDetachMenu                 glutdetachmenu
#define fglutSetColor                   glutsetcolor
#define fglutGetColor                   glutgetcolor
#define fglutCopyColormap               glutcopycolormap
#define fglutGet                        glutget
#define fglutDeviceGet                  glutdeviceget
#define fglutExtensionSupported         glutextensionsupported
#define fglutGetModifiers               glutgetmodifiers
#define fglutLayerGet                   glutlayerget
#define fglutBitmapWidth                glutbitmapwidth
#define fglutStrokeWidth                glutstrokewidth
#define fglutWireSphere                 glutwiresphere
#define fglutSolidSphere                glutsolidsphere
#define fglutWireCone                   glutwirecone
#define fglutSolidCone                  glutsolidcone
#define fglutWireCube                   glutwirecube
#define fglutSolidCube                  glutsolidcube
#define fglutWireTorus                  glutwiretorus
#define fglutSolidTorus                 glutsolidtorus
#define fglutWireDodecahedron           glutwiredodecahedron
#define fglutSolidDodecahedron          glutsoliddodecahedron
#define fglutWireTeapot                 glutwireteapot
#define fglutSolidTeapot                glutsolidteapot
#define fglutWireOctahedron             glutwireoctahedron
#define fglutSolidOctahedron            glutsolidoctahedron
#define fglutWireTetrahedron            glutwiretetrahedron
#define fglutSolidTetrahedron           glutsolidtetrahedron
#define fglutWireIcosahedron            glutwireicosahedron
#define fglutSolidIcosahedron           glutsolidicosahedron
#elif FBIND==2
#define fglutInitDisplayMode            glutinitdisplaymode_
#define fglutInitWindowPosition         glutinitwindowposition_
#define fglutInitWindowSize             glutinitwindowsize_
#define fglutMainLoop                   glutmainloop_
#define fglutCreateWindow               glutcreatewindow_
#define fglutCreateSubWindow            glutcreatesubwindow_
#define fglutDestroyWindow              glutdestroywindow_
#define fglutPostRedisplay              glutpostredisplay_
#define fglutSwapBuffers                glutswapbuffers_
#define fglutGetWindow                  glutgetwindow_
#define fglutSetWindow                  glutsetwindow_
#define fglutSetWindowTitle             glutsetwindowtitle_
#define fglutSetIconTitle               glutseticontitle_
#define fglutPositionWindow             glutpositionwindow_
#define fglutReshapeWindow              glutreshapewindow_
#define fglutPopWindow                  glutpopwindow_
#define fglutPushWindow                 glutpushwindow_
#define fglutIconifyWindow              gluticonifywindow_
#define fglutShowWindow                 glutshowwindow_
#define fglutHideWindow                 gluthidewindow_
#define fglutFullScreen                 glutfullscreen_
#define fglutSetCursor                  glutsetcursor_
#define fglutEstablishOverlay           glutestablishoverlay_
#define fglutRemoveOverlay              glutremoveoverlay_
#define fglutUseLayer                   glutuselayer_
#define fglutPostOverlayRedisplay       glutpostoverlayredisplay_
#define fglutShowOverlay                glutshowoverlay_
#define fglutHideOverlay                gluthideoverlay_
#define fglutDestroyMenu                glutdestroymenu_
#define fglutGetMenu                    glutgetmenu_
#define fglutSetMenu                    glutsetmenu_
#define fglutAddMenuEntry               glutaddmenuentry_
#define fglutAddSubMenu                 glutaddsubmenu_
#define fglutChangeToMenuEntry          glutchangetomenuentry_
#define fglutChangeToSubMenu            glutchangetosubmenu_
#define fglutRemoveMenuItem             glutremovemenuitem_
#define fglutAttachMenu                 glutattachmenu_
#define fglutDetachMenu                 glutdetachmenu_
#define fglutSetColor                   glutsetcolor_
#define fglutGetColor                   glutgetcolor_
#define fglutCopyColormap               glutcopycolormap_
#define fglutGet                        glutget_
#define fglutDeviceGet                  glutdeviceget_
#define fglutExtensionSupported         glutextensionsupported_
#define fglutGetModifiers               glutgetmodifiers_
#define fglutLayerGet                   glutlayerget_
#define fglutBitmapWidth                glutbitmapwidth_
#define fglutStrokeWidth                glutstrokewidth_
#define fglutWireSphere                 glutwiresphere_
#define fglutSolidSphere                glutsolidsphere_
#define fglutWireCone                   glutwirecone_
#define fglutSolidCone                  glutsolidcone_
#define fglutWireCube                   glutwirecube_
#define fglutSolidCube                  glutsolidcube_
#define fglutWireTorus                  glutwiretorus_
#define fglutSolidTorus                 glutsolidtorus_
#define fglutWireDodecahedron           glutwiredodecahedron_
#define fglutSolidDodecahedron          glutsoliddodecahedron_
#define fglutWireTeapot                 glutwireteapot_
#define fglutSolidTeapot                glutsolidteapot_
#define fglutWireOctahedron             glutwireoctahedron_
#define fglutSolidOctahedron            glutsolidoctahedron_
#define fglutWireTetrahedron            glutwiretetrahedron_
#define fglutSolidTetrahedron           glutsolidtetrahedron_
#define fglutWireIcosahedron            glutwireicosahedron_
#define fglutSolidIcosahedron           glutsolidicosahedron_
#elif FBIND==3
#define fglutInitDisplayMode            GLUTINITDISPLAYMODE
#define fglutInitWindowPosition         GLUTINITWINDOWPOSITION
#define fglutInitWindowSize             GLUTINITWINDOWSIZE
#define fglutMainLoop                   GLUTMAINLOOP
#define fglutCreateWindow               GLUTCREATEWINDOW
#define fglutCreateSubWindow            GLUTCREATESUBWINDOW
#define fglutDestroyWindow              GLUTDESTROYWINDOW
#define fglutPostRedisplay              GLUTPOSTREDISPLAY
#define fglutSwapBuffers                GLUTSWAPBUFFERS
#define fglutGetWindow                  GLUTGETWINDOW
#define fglutSetWindow                  GLUTSETWINDOW
#define fglutSetWindowTitle             GLUTSETWINDOWTITLE
#define fglutSetIconTitle               GLUTSETICONTITLE
#define fglutPositionWindow             GLUTPOSITIONWINDOW
#define fglutReshapeWindow              GLUTRESHAPEWINDOW
#define fglutPopWindow                  GLUTPOPWINDOW
#define fglutPushWindow                 GLUTPUSHWINDOW
#define fglutIconifyWindow              GLUTICONIFYWINDOW
#define fglutShowWindow                 GLUTSHOWWINDOW
#define fglutHideWindow                 GLUTHIDEWINDOW
#define fglutFullScreen                 GLUTFULLSCREEN
#define fglutSetCursor                  GLUTSETCURSOR
#define fglutEstablishOverlay           GLUTESTABLISHOVERLAY
#define fglutRemoveOverlay              GLUTREMOVEOVERLAY
#define fglutUseLayer                   GLUTUSELAYER
#define fglutPostOverlayRedisplay       GLUTPOSTOVERLAYREDISPLAY
#define fglutShowOverlay                GLUTSHOWOVERLAY
#define fglutHideOverlay                GLUTHIDEOVERLAY
#define fglutDestroyMenu                GLUTDESTROYMENU
#define fglutGetMenu                    GLUTGETMENU
#define fglutSetMenu                    GLUTSETMENU
#define fglutAddMenuEntry               GLUTADDMENUENTRY
#define fglutAddSubMenu                 GLUTADDSUBMENU
#define fglutChangeToMenuEntry          GLUTCHANGETOMENUENTRY
#define fglutChangeToSubMenu            GLUTCHANGETOSUBMENU
#define fglutRemoveMenuItem             GLUTREMOVEMENUITEM
#define fglutAttachMenu                 GLUTATTACHMENU
#define fglutDetachMenu                 GLUTDETACHMENU
#define fglutSetColor                   GLUTSETCOLOR
#define fglutGetColor                   GLUTGETCOLOR
#define fglutCopyColormap               GLUTCOPYCOLORMAP
#define fglutGet                        GLUTGET
#define fglutDeviceGet                  GLUTDEVICEGET
#define fglutExtensionSupported         GLUTEXTENSIONSUPPORTED
#define fglutGetModifiers               GLUTGETMODIFIERS
#define fglutLayerGet                   GLUTLAYERGET
#define fglutBitmapWidth                GLUTBITMAPWIDTH
#define fglutStrokeWidth                GLUTSTROKEWIDTH
#define fglutWireSphere                 GLUTWIRESPHERE
#define fglutSolidSphere                GLUTSOLIDSPHERE
#define fglutWireCone                   GLUTWIRECONE
#define fglutSolidCone                  GLUTSOLIDCONE
#define fglutWireCube                   GLUTWIRECUBE
#define fglutSolidCube                  GLUTSOLIDCUBE
#define fglutWireTorus                  GLUTWIRETORUS
#define fglutSolidTorus                 GLUTSOLIDTORUS
#define fglutWireDodecahedron           GLUTWIREDODECAHEDRON
#define fglutSolidDodecahedron          GLUTSOLIDDODECAHEDRON
#define fglutWireTeapot                 GLUTWIRETEAPOT
#define fglutSolidTeapot                GLUTSOLIDTEAPOT
#define fglutWireOctahedron             GLUTWIREOCTAHEDRON
#define fglutSolidOctahedron            GLUTSOLIDOCTAHEDRON
#define fglutWireTetrahedron            GLUTWIRETETRAHEDRON
#define fglutSolidTetrahedron           GLUTSOLIDTETRAHEDRON
#define fglutWireIcosahedron            GLUTWIREICOSAHEDRON
#define fglutSolidIcosahedron           GLUTSOLIDICOSAHEDRON
#endif
#if FBIND==1
#define f90glutGlutNull              glutnull
#define fglutInit                    glutinit
#define fglutReshapeFunc             glutreshapefunc
#define fglutKeyboardFunc            glutkeyboardfunc
#define fglutMouseFunc               glutmousefunc
#define fglutMotionFunc              glutmotionfunc
#define fglutEntryFunc               glutentryfunc
#define fglutVisibilityFunc          glutvisibilityfunc
#define fglutSpecialFunc             glutspecialfunc
#define fglutDialsFunc               glutdialsfunc
#define fglutDisplayFunc             glutdisplayfunc
#define fglutPassiveMotionFunc       glutpassivemotionfunc
#define fglutSpaceMotionFunc         glutspacemotionfunc
#define fglutSpaceRotateFunc         glutspacerotatefunc
#define fglutSpaceButtonFunc         glutspacebuttonfunc
#define fglutButtonBoxFunc           glutbuttonboxfunc
#define fglutTabletMotionFunc        gluttabletmotionfunc
#define fglutTabletButtonFunc        gluttabletbuttonfunc
#define fglutCreateMenu              glutcreatemenu
#define fglutTimerFunc               gluttimerfunc
#define fglutIdleFunc                glutidlefunc
#define fglutMenuStateFunc           glutmenustatefunc
#define fglutBitmapCharacter         glutbitmapcharacter
#define fglutStrokeCharacter         glutstrokecharacter
#define fglutMenuStatusFunc          glutmenustatusfunc
#define fglutOverlayDisplayFunc      glutoverlaydisplayfunc
#elif FBIND==2
#define f90glutGlutNull              glutnull_
#define fglutInit                    glutinit_
#define fglutReshapeFunc             glutreshapefunc_
#define fglutKeyboardFunc            glutkeyboardfunc_
#define fglutMouseFunc               glutmousefunc_
#define fglutMotionFunc              glutmotionfunc_
#define fglutEntryFunc               glutentryfunc_
#define fglutVisibilityFunc          glutvisibilityfunc_
#define fglutSpecialFunc             glutspecialfunc_
#define fglutDialsFunc               glutdialsfunc_
#define fglutDisplayFunc             glutdisplayfunc_
#define fglutPassiveMotionFunc       glutpassivemotionfunc_
#define fglutSpaceMotionFunc         glutspacemotionfunc_
#define fglutSpaceRotateFunc         glutspacerotatefunc_
#define fglutSpaceButtonFunc         glutspacebuttonfunc_
#define fglutButtonBoxFunc           glutbuttonboxfunc_
#define fglutTabletMotionFunc        gluttabletmotionfunc_
#define fglutTabletButtonFunc        gluttabletbuttonfunc_
#define fglutCreateMenu              glutcreatemenu_
#define fglutTimerFunc               gluttimerfunc_
#define fglutIdleFunc                glutidlefunc_
#define fglutMenuStateFunc           glutmenustatefunc_
#define fglutBitmapCharacter         glutbitmapcharacter_
#define fglutStrokeCharacter         glutstrokecharacter_
#define fglutMenuStatusFunc          glutmenustatusfunc_
#define fglutOverlayDisplayFunc      glutoverlaydisplayfunc_
#elif FBIND==3
#define f90glutGlutNull              GLUTNULL
#define fglutInit                    GLUTINIT
#define fglutReshapeFunc             GLUTRESHAPEFUNC
#define fglutKeyboardFunc            GLUTKEYBOARDFUNC
#define fglutMouseFunc               GLUTMOUSEFUNC
#define fglutMotionFunc              GLUTMOTIONFUNC
#define fglutEntryFunc               GLUTENTRYFUNC
#define fglutVisibilityFunc          GLUTVISIBILITYFUNC
#define fglutSpecialFunc             GLUTSPECIALFUNC
#define fglutDialsFunc               GLUTDIALSFUNC
#define fglutDisplayFunc             GLUTDISPLAYFUNC
#define fglutPassiveMotionFunc       GLUTPASSIVEMOTIONFUNC
#define fglutSpaceMotionFunc         GLUTSPACEMOTIONFUNC
#define fglutSpaceRotateFunc         GLUTSPACEROTATEFUNC
#define fglutSpaceButtonFunc         GLUTSPACEBUTTONFUNC
#define fglutButtonBoxFunc           GLUTBUTTONBOXFUNC
#define fglutTabletMotionFunc        GLUTTABLETMOTIONFUNC
#define fglutTabletButtonFunc        GLUTTABLETBUTTONFUNC
#define fglutCreateMenu              GLUTCREATEMENU
#define fglutTimerFunc               GLUTTIMERFUNC
#define fglutIdleFunc                GLUTIDLEFUNC
#define fglutMenuStateFunc           GLUTMENUSTATEFUNC
#define fglutBitmapCharacter         GLUTBITMAPCHARACTER
#define fglutStrokeCharacter         GLUTSTROKECHARACTER
#define fglutMenuStatusFunc          GLUTMENUSTATUSFUNC
#define fglutOverlayDisplayFunc      GLUTOVERLAYDISPLAYFUNC
#endif

/* wrapper functions */

void fglutInitDisplayMode( f90glcuint mode )
{
   glutInitDisplayMode( (unsigned int) *mode );
}

void fglutInitWindowPosition( f90glcint x, f90glcint y )
{
   glutInitWindowPosition( (int) *x, (int) *y );
}

void fglutInitWindowSize( f90glcint width, f90glcint height )
{
   glutInitWindowSize( (int) *width, (int) *height );
}

void fglutMainLoop( void )
{
   glutMainLoop();
}

int fglutCreateWindow( f90glcchar title )
{
   return (int) glutCreateWindow( (char *) title );
}

int fglutCreateSubWindow( f90glcint win, f90glcint x, f90glcint y, f90glcint width,
    f90glcint height )
{
   return (int) glutCreateSubWindow( (int) *win, (int) *x, (int) *y,
    (int) *width, (int) *height );
}

void fglutDestroyWindow( f90glcint win )
{
   glutDestroyWindow( (int) *win );
}

void fglutPostRedisplay( void )
{
   glutPostRedisplay();
}

void fglutSwapBuffers( void )
{
   glutSwapBuffers();
}

int fglutGetWindow( void )
{
   return (int) glutGetWindow();
}

void fglutSetWindow( f90glcint win )
{
   glutSetWindow( (int) *win );
}

void fglutSetWindowTitle( f90glcchar title )
{
   glutSetWindowTitle( (char *) title );
}

void fglutSetIconTitle( f90glcchar title )
{
   glutSetIconTitle( (char *) title );
}

void fglutPositionWindow( f90glcint x, f90glcint y )
{
   glutPositionWindow( (int) *x, (int) *y );
}

void fglutReshapeWindow( f90glcint width, f90glcint height )
{
   glutReshapeWindow( (int) *width, (int) *height );
}

void fglutPopWindow( void )
{
   glutPopWindow();
}

void fglutPushWindow( void )
{
   glutPushWindow();
}

void fglutIconifyWindow( void )
{
   glutIconifyWindow();
}

void fglutShowWindow( void )
{
   glutShowWindow();
}

void fglutHideWindow( void )
{
   glutHideWindow();
}

void fglutFullScreen( void )
{
   glutFullScreen();
}

void fglutSetCursor( f90glcint cursor )
{
   glutSetCursor( (int) *cursor );
}

void fglutEstablishOverlay( void )
{
   glutEstablishOverlay();
}

void fglutRemoveOverlay( void )
{
   glutRemoveOverlay();
}

void fglutUseLayer( f90glenum layer )
{
   glutUseLayer( (GLenum) *layer );
}

void fglutPostOverlayRedisplay( void )
{
   glutPostOverlayRedisplay();
}

void fglutShowOverlay( void )
{
   glutShowOverlay();
}

void fglutHideOverlay( void )
{
   glutHideOverlay();
}

void fglutDestroyMenu( f90glcint menu )
{
   glutDestroyMenu( (int) *menu );
}

int fglutGetMenu( void )
{
   return (int) glutGetMenu();
}

void fglutSetMenu( f90glcint menu )
{
   glutSetMenu( (int) *menu );
}

void fglutAddMenuEntry( f90glcchar label, f90glcint value )
{
   glutAddMenuEntry( (char *) label, (int) *value );
}

void fglutAddSubMenu( f90glcchar label, f90glcint submenu )
{
   glutAddSubMenu( (char *) label, (int) *submenu );
}

void fglutChangeToMenuEntry( f90glcint item, f90glcchar label, f90glcint value )
{
   glutChangeToMenuEntry( (int) *item, (char *) label, (int) *value );
}

void fglutChangeToSubMenu( f90glcint item, f90glcchar label, f90glcint submenu )
{
   glutChangeToSubMenu( (int) *item, (char *) label, (int) *submenu );
}

void fglutRemoveMenuItem( f90glcint item )
{
   glutRemoveMenuItem( (int) *item );
}

void fglutAttachMenu( f90glcint button )
{
   glutAttachMenu( (int) *button );
}

void fglutDetachMenu( f90glcint button )
{
   glutDetachMenu( (int) *button );
}

void fglutSetColor( f90glcint ndx, f90glfloat red, f90glfloat green,
    f90glfloat blue )
{
   glutSetColor( (int) *ndx, (GLfloat) *red, (GLfloat) *green,
    (GLfloat) *blue );
}

GLfloat fglutGetColor( f90glcint ndx, f90glcint component )
{
   return (GLfloat) glutGetColor( (int) *ndx, (int) *component );
}

void fglutCopyColormap( f90glcint win )
{
   glutCopyColormap( (int) *win );
}

int fglutGet( f90glenum type )
{
   return (int) glutGet( (GLenum) *type );
}

int fglutDeviceGet( f90glenum type )
{
   return (int) glutDeviceGet( (GLenum) *type );
}

int fglutExtensionSupported( f90glcchar name )
{
   return (int) glutExtensionSupported( (char *) name );
}

int fglutGetModifiers( void )
{
   return (int) glutGetModifiers();
}

int fglutLayerGet( f90glenum type )
{
   return (int) glutLayerGet( (GLenum) *type );
}

int fglutBitmapWidth( void * font, f90glcint character )
{
   return (int) glutBitmapWidth( (void *) font, (int) *character );
}

int fglutStrokeWidth( void * font, f90glcint character )
{
   return (int) glutStrokeWidth( (void *) font, (int) *character );
}

void fglutWireSphere( f90gldouble radius, f90glint slices, f90glint stacks )
{
   glutWireSphere( (GLdouble) *radius, (GLint) *slices, (GLint) *stacks );
}

void fglutSolidSphere( f90gldouble radius, f90glint slices, f90glint stacks )
{
   glutSolidSphere( (GLdouble) *radius, (GLint) *slices, (GLint) *stacks );
}

void fglutWireCone( f90gldouble base, f90gldouble height, f90glint slices,
    f90glint stacks )
{
   glutWireCone( (GLdouble) *base, (GLdouble) *height, (GLint) *slices,
    (GLint) *stacks );
}

void fglutSolidCone( f90gldouble base, f90gldouble height, f90glint slices,
    f90glint stacks )
{
   glutSolidCone( (GLdouble) *base, (GLdouble) *height, (GLint) *slices,
    (GLint) *stacks );
}

void fglutWireCube( f90gldouble size )
{
   glutWireCube( (GLdouble) *size );
}

void fglutSolidCube( f90gldouble size )
{
   glutSolidCube( (GLdouble) *size );
}

void fglutWireTorus( f90gldouble innerRadius, f90gldouble outerRadius,
    f90glint sides, f90glint rings )
{
   glutWireTorus( (GLdouble) *innerRadius, (GLdouble) *outerRadius,
    (GLint) *sides, (GLint) *rings );
}

void fglutSolidTorus( f90gldouble innerRadius, f90gldouble outerRadius,
    f90glint sides, f90glint rings )
{
   glutSolidTorus( (GLdouble) *innerRadius, (GLdouble) *outerRadius,
    (GLint) *sides, (GLint) *rings );
}

void fglutWireDodecahedron( void )
{
   glutWireDodecahedron();
}

void fglutSolidDodecahedron( void )
{
   glutSolidDodecahedron();
}

void fglutWireTeapot( f90gldouble size )
{
   glutWireTeapot( (GLdouble) *size );
}

void fglutSolidTeapot( f90gldouble size )
{
   glutSolidTeapot( (GLdouble) *size );
}

void fglutWireOctahedron( void )
{
   glutWireOctahedron();
}

void fglutSolidOctahedron( void )
{
   glutSolidOctahedron();
}

void fglutWireTetrahedron( void )
{
   glutWireTetrahedron();
}

void fglutSolidTetrahedron( void )
{
   glutSolidTetrahedron();
}

void fglutWireIcosahedron( void )
{
   glutWireIcosahedron();
}

void fglutSolidIcosahedron( void )
{
   glutSolidIcosahedron();
}


/* The following code segment comes from Mark Kilgard's original fglut.c
   with these modifications by William Mitchell:
   1) wrapper function names changed from glutroutinename to fglutRoutineName
      which are #defined above to system specific name mangling.
   2) explicitly wrote out functions that were defined by macro glutfunc
      to allow preprocessing in (1)
   3) set __Argc and __Argv to look like 'no arguments'
   4) changed glutnull_ to f90glutGlutNull which is #defined as in (1)
*/

/* Copyright (c) Mark J. Kilgard, 1994. */

/* This program is freely distributable without licensing fees
   and is provided without guarantee or warrantee expressed or
   implied. This program is -not- in the public domain. */

#ifndef WRAPPERS_ONLY

#include "glutint.h"

int __Argc = 1;
char *__Argv[2];

static GLUTmenuStateFCB fortranMenuStateFunc;

void
f90glutGlutNull(void)
{
}

void
fglutInit(void)
{
  __Argv[0] = "noname\n";
  __Argv[1] = NULL;
  glutInit(&__Argc, __Argv);
}

static void
fortranMenuStateWrapper(int value)
{
  fortranMenuStateFunc(&value);
}

static void
fortranReshapeWrapper(int w, int h)
{
  (*__glutCurrentWindow->freshape) (&w, &h);
}

static void
fortranKeyboardWrapper(unsigned char ch, int x, int y)
{
  int chi = ch;

  (*__glutCurrentWindow->fkeyboard) (&chi, &x, &y);
}

static void
fortranMouseWrapper(int btn, int state, int x, int y)
{
  (*__glutCurrentWindow->fmouse) (&btn, &state, &x, &y);
}

static void
fortranMotionWrapper(int x, int y)
{
  (*__glutCurrentWindow->fmotion) (&x, &y);
}

static void
fortranPassiveMotionWrapper(int x, int y)
{
  (*__glutCurrentWindow->fpassive) (&x, &y);
}

static void
fortranEntryWrapper(int state)
{
  (*__glutCurrentWindow->fentry) (&state);
}

static void
fortranVisibilityWrapper(int state)
{
  (*__glutCurrentWindow->fvisibility) (&state);
}

static void
fortranTimerWrapper(int value)
{
  /* relies on special knowledge that __glutTimerList points to 
     the GLUTtimer* currently being processed! */
  (*__glutTimerList->ffunc) (&value);
}

static void
fortranSelectWrapper(int value)
{
  (*__glutItemSelected->menu->fselect) (&value);
}

static void
fortranSpecialWrapper(int key, int x, int y)
{
  (*__glutCurrentWindow->fspecial) (&key, &x, &y);
}

static void
fortranSpaceballMotionWrapper(int x, int y, int z)
{
  (*__glutCurrentWindow->fspaceMotion) (&x, &y, &z);
}

static void
fortranSpaceballRotateWrapper(int x, int y, int z)
{
  (*__glutCurrentWindow->fspaceRotate) (&x, &y, &z);
}

static void
fortranSpaceballButtonWrapper(int button, int state)
{
  (*__glutCurrentWindow->fspaceButton) (&button, &state);
}

static void
fortranTabletMotionWrapper(int x, int y)
{
  (*__glutCurrentWindow->ftabletMotion) (&x, &y);
}

static void
fortranTabletButtonWrapper(int button, int state, int x, int y)
{
  (*__glutCurrentWindow->ftabletButton) (&button, &state, &x, &y);
}

static void
fortranDialsWrapper(int dial, int value)
{
  (*__glutCurrentWindow->fdials) (&dial, &value);
}

static void
fortranButtonBoxWrapper(int button, int state)
{
  (*__glutCurrentWindow->fbuttonBox) (&button, &state);
}

#endif /* WRAPPERS_ONLY */

#define glutfunc(Name,name) \
void \
glut##name##func(GLUT##name##FCB name) \
{ \
    if(name == (GLUT##name ## FCB) f90glutGlutNull) { \
	glut##Name ## Func(NULL); \
    } else { \
	glut ## Name ## Func(fortran ## Name ## Wrapper); \
	__glutCurrentWindow->f ## name = name; \
    } \
}

/* WFM -- have to explicitly write out these functions because the name
mangling from the #defines inside the #if FBIND= construct doesn't seem to
carry through the glutfunc macro.

glutfunc(Reshape, reshape, fglutReshapeFunc)
glutfunc(Keyboard, keyboard, fglutKeyboardFunc)
glutfunc(Mouse, mouse, fglutMouseFunc)
glutfunc(Motion, motion, fglutMotionFunc)
glutfunc(Entry, entry, fglutEntryFunc)
glutfunc(Visibility, visibility, fglutVisibilityFunc)
glutfunc(Special, special, fglutSpecialFunc)
glutfunc(Dials, dials, fglutDialsFunc)

*/

void
fglutReshapeFunc(GLUTreshapeFCB reshape)
{
  if (reshape == (GLUTreshapeFCB) f90glutGlutNull) {
    glutReshapeFunc(NULL);
  } else {
    glutReshapeFunc(fortranReshapeWrapper);
    __glutCurrentWindow->freshape = reshape;
  }
}

void
fglutKeyboardFunc(GLUTkeyboardFCB keyboard)
{
  if (keyboard == (GLUTkeyboardFCB) f90glutGlutNull) {
    glutKeyboardFunc(NULL);
  } else {
    glutKeyboardFunc(fortranKeyboardWrapper);
    __glutCurrentWindow->fkeyboard = keyboard;
  }
}

void
fglutMouseFunc(GLUTmouseFCB mouse)
{
  if (mouse == (GLUTmouseFCB) f90glutGlutNull) {
    glutMouseFunc(NULL);
  } else {
    glutMouseFunc(fortranMouseWrapper);
    __glutCurrentWindow->fmouse = mouse;
  }
}

void
fglutMotionFunc(GLUTmotionFCB motion)
{
  if (motion == (GLUTmotionFCB) f90glutGlutNull) {
    glutMotionFunc(NULL);
  } else {
    glutMotionFunc(fortranMotionWrapper);
    __glutCurrentWindow->fmotion = motion;
  }
}

void
fglutEntryFunc(GLUTentryFCB entry)
{
  if (entry == (GLUTentryFCB) f90glutGlutNull) {
    glutEntryFunc(NULL);
  } else {
    glutEntryFunc(fortranEntryWrapper);
    __glutCurrentWindow->fentry = entry;
  }
}

void
fglutVisibilityFunc(GLUTvisibilityFCB visibility)
{
  if (visibility == (GLUTvisibilityFCB) f90glutGlutNull) {
    glutVisibilityFunc(NULL);
  } else {
    glutVisibilityFunc(fortranVisibilityWrapper);
    __glutCurrentWindow->fvisibility = visibility;
  }
}

void
fglutSpecialFunc(GLUTspecialFCB special)
{
  if (special == (GLUTspecialFCB) f90glutGlutNull) {
    glutSpecialFunc(NULL);
  } else {
    glutSpecialFunc(fortranSpecialWrapper);
    __glutCurrentWindow->fspecial = special;
  }
}

void
fglutDialsFunc(GLUTdialsFCB dials)
{
  if (dials == (GLUTdialsFCB) f90glutGlutNull) {
    glutDialsFunc(NULL);
  } else {
    glutDialsFunc(fortranDialsWrapper);
    __glutCurrentWindow->fdials = dials;
  }
}

/* WFM -- end of expanded routines */

/* special callback cases */

/* The display has no parameters passed so no need for wrapper. */
void
fglutDisplayFunc(GLUTdisplayFCB display)
{
  glutDisplayFunc((GLUTdisplayCB) display);
}

void
fglutPassiveMotionFunc(GLUTpassiveFCB passive)
{
  if (passive == (GLUTpassiveFCB) f90glutGlutNull) {
    glutPassiveMotionFunc(NULL);
  } else {
    glutPassiveMotionFunc(fortranPassiveMotionWrapper);
    __glutCurrentWindow->fpassive = passive;
  }
}

void
fglutSpaceMotionFunc(GLUTspaceMotionFCB spaceMotion)
{
  if (spaceMotion == (GLUTspaceMotionFCB) f90glutGlutNull) {
    glutSpaceballMotionFunc(NULL);
  } else {
    glutSpaceballMotionFunc(fortranSpaceballMotionWrapper);
    __glutCurrentWindow->fspaceMotion = spaceMotion;
  }
}

void
fglutSpaceRotateFunc(GLUTspaceRotateFCB spaceRotate)
{
  if (spaceRotate == (GLUTspaceRotateFCB) f90glutGlutNull) {
    glutSpaceballRotateFunc(NULL);
  } else {
    glutSpaceballRotateFunc(fortranSpaceballRotateWrapper);
    __glutCurrentWindow->fspaceRotate = spaceRotate;
  }
}

void
fglutSpaceButtonFunc(GLUTspaceButtonFCB spaceButton)
{
  if (spaceButton == (GLUTspaceButtonFCB) f90glutGlutNull) {
    glutSpaceballButtonFunc(NULL);
  } else {
    glutSpaceballButtonFunc(fortranSpaceballButtonWrapper);
    __glutCurrentWindow->fspaceButton = spaceButton;
  }
}

void
fglutButtonBoxFunc(GLUTbuttonBoxFCB buttonBox)
{
  if (buttonBox == (GLUTbuttonBoxFCB) f90glutGlutNull) {
    glutButtonBoxFunc(NULL);
  } else {
    glutButtonBoxFunc(fortranButtonBoxWrapper);
    __glutCurrentWindow->fbuttonBox = buttonBox;
  }
}

void
fglutTabletMotionFunc(GLUTtabletMotionFCB tabletMotion)
{
  if (tabletMotion == (GLUTtabletMotionFCB) f90glutGlutNull) {
    glutTabletMotionFunc(NULL);
  } else {
    glutTabletMotionFunc(fortranTabletMotionWrapper);
    __glutCurrentWindow->ftabletMotion = tabletMotion;
  }
}

void
fglutTabletButtonFunc(GLUTtabletButtonFCB tabletButton)
{
  if (tabletButton == (GLUTtabletButtonFCB) f90glutGlutNull) {
    glutTabletButtonFunc(NULL);
  } else {
    glutTabletButtonFunc(fortranTabletButtonWrapper);
    __glutCurrentWindow->ftabletButton = tabletButton;
  }
}

int
fglutCreateMenu(GLUTselectFCB selectFunc)
{
  int menu;

  menu = glutCreateMenu(fortranSelectWrapper);
  __glutCurrentMenu->fselect = selectFunc;
  return menu;
}

void
fglutTimerFunc(f90glculong interval, GLUTtimerFCB timerFunc, f90glcint value)
{
  glutTimerFunc(*interval, fortranTimerWrapper, *value);
  /* relies on special __glutNewTimer variable side effect to
     establish Fortran timer func! */
  __glutNewTimer->ffunc = timerFunc;
}

void
fglutIdleFunc(GLUTidleFCB idleFunc)
{
  if (idleFunc == (GLUTidleFCB) f90glutGlutNull) {
    glutIdleFunc(NULL);
  } else {
    glutIdleFunc(idleFunc);
  }
}

void
fglutMenuStateFunc(GLUTmenuStateFCB menuStateFunc)
{
  if (menuStateFunc == (GLUTmenuStateFCB) f90glutGlutNull) {
    glutMenuStateFunc(NULL);
  } else {
    glutMenuStateFunc(fortranMenuStateWrapper);
    fortranMenuStateFunc = menuStateFunc;
  }
}

/* WFM changed int ch to int *ch in the following two routines */

void
fglutBitmapCharacter(int *font, int *ch)
{
  /* 
   * mkf2c gets confused by double pointers and void* pointers.
   * So mkf2c does not complain, we consider the font handle to
   * be an int*.  But we really get an int** since Fortran
   * passes by reference.  So to "pedantically decode" the 
   * pointer, cast it first to int**, then dereference it,
   * then cast the result to a void*.
   */
  void *trueFont = (void *) *((int **) font);

  glutBitmapCharacter(trueFont, *ch);
}

void
fglutStrokeCharacter(int *font, int *ch)
{
  /* 
   * mkf2c gets confused by double pointers and void* pointers.
   * So mkf2c does not complain, we consider the font handle to
   * be an int*.  But we really get an int** since Fortran
   * passes by reference.  So to "pedantically decode" the 
   * pointer, cast it first to int**, then dereference it,
   * then cast the result to a void*.
   */
  void *trueFont = (void *) *((int **) font);

  glutStrokeCharacter(trueFont, *ch);
}

/* end of Copyright (c) Mark J. Kilgard, 1994. */

static GLUTmenuStatusFCB fortranMenuStatusFunc;

static void
fortranMenuStatusWrapper(int status, int x, int y)
{
  fortranMenuStatusFunc(&status, &x, &y);
}

void
fglutMenuStatusFunc(GLUTmenuStatusFCB menuStatusFunc)
{
  if (menuStatusFunc == (GLUTmenuStatusFCB) f90glutGlutNull) {
    glutMenuStatusFunc(NULL);
  } else {
    glutMenuStatusFunc(fortranMenuStatusWrapper);
    fortranMenuStatusFunc = menuStatusFunc;
  }
}

void
fglutOverlayDisplayFunc(GLUTdisplayFCB display)
{
  glutOverlayDisplayFunc((GLUTdisplayCB) display);
}

/* fonts */

#if FBIND==1
void *glut_bitmap_8_by_13 = &glutBitmap8By13;
void *glut_bitmap_9_by_15 = &glutBitmap9By15;
void *glut_bitmap_helvetica_10 = &glutBitmapHelvetica10;
void *glut_bitmap_helvetica_12 = &glutBitmapHelvetica12;
void *glut_bitmap_helvetica_18 = &glutBitmapHelvetica18;
void *glut_stroke_mono_roman = &glutStrokeMonoRoman;
void *glut_stroke_roman = &glutStrokeRoman;
void *glut_bitmap_times_roman_10 = &glutBitmapTimesRoman10;
void *glut_bitmap_times_roman_24 = &glutBitmapTimesRoman24;
#elif FBIND==2
void *glut_bitmap_8_by_13_ = &glutBitmap8By13;
void *glut_bitmap_9_by_15_ = &glutBitmap9By15;
void *glut_bitmap_helvetica_10_ = &glutBitmapHelvetica10;
void *glut_bitmap_helvetica_12_ = &glutBitmapHelvetica12;
void *glut_bitmap_helvetica_18 = &glutBitmapHelvetica18;
void *glut_stroke_mono_roman_ = &glutStrokeMonoRoman;
void *glut_stroke_roman_ = &glutStrokeRoman;
void *glut_bitmap_times_roman_10_ = &glutBitmapTimesRoman10;
void *glut_bitmap_times_roman_24_ = &glutBitmapTimesRoman24;
#elif FBIND==3
void *GLUT_BITMAP_8_BY_13 = &glutBitmap8By13;
void *GLUT_BITMAP_9_BY_15 = &glutBitmap9By15;
void *GLUT_BITMAP_HELVETICA_10 = &glutBitmapHelvetica10;
void *GLUT_BITMAP_HELVETICA_12 = &glutBitmapHelvetica12;
void *GLUT_BITMAP_HELVETICA_18 = &glutBitmapHelvetica18;
void *GLUT_STROKE_MONO_ROMAN = &glutStrokeMonoRoman;
void *GLUT_STROKE_ROMAN = &glutStrokeRoman;
void *GLUT_BITMAP_TIMES_ROMAN_10 = &glutBitmapTimesRoman10;
void *GLUT_BITMAP_TIMES_ROMAN_24 = &glutBitmapTimesRoman24;
#endif

#else /*ifdef FBIND*/



/* If FBIND is not defined, Fortran bindings aren't made.  Need this
 * dummy function for some picky compilers.
 */
static void dummy()
{
   return;
}

 
 
#endif /*ifdef FBIND*/
