c-------------------------------------------------------------------------
c f90gl Version 1.0 September 1996
c 
c William F. Mitchell
c Applied and Computational Mathematics Division
c National Institute of Standards and Technology
c Gaithersburg, MD 20899
c william.mitchell@nist.gov
c 
c This fortran interface for Mesa software and documentation have been produced
c as part of work done by the U.S. Government, and are not subject to copyright
c in the United States.
c 
c The mention of specific products, trademarks, or brand names in the
c documentation is for purposes of identification only.  Such mention is not to
c be interpreted in any way as an endorsement or certification of such products
c or brands by the National Institute of Standards and Technology.
c All trademarks mentioned herein belong to their respective owners.
c-------------------------------------------------------------------------

      integer function make_ball()
      include "GL/fgl.h"
      include "ftk.h"
      common /ints/ Ball, Mode
      common /floats/ Zrot, Zstep, Xpos, Ypos, Xvel, Yvel, Xmin, Xmax,
     1                Ymin, Ymax, G
      integer Ball, Mode
      real Zrot, Zstep, Xpos, Ypos, Xvel, Yvel, Xmin, Xmax,
     1     Ymin, Ymax, G

      integer list
      real a, b
      real da, db
      real radius
      integer color
      real x, y, z

      da = 18.0
      db = 18.0
      radius = 1.0

      list = fglGenLists( 1 )

      call fglNewList( list, GL_COMPILE )

      color = 0
      do a=-90.,90.,da

         call fglBegin( GL_QUAD_STRIP )

         do b=0.,360.,db

	    if (color.ne.0) then
	       call fTK_SETCOLOR( Mode, TK_RED )
	    else
	       call fTK_SETCOLOR( Mode, TK_WHITE )
	    endif

	    x = COS(b* 3.14159/180.0) * COS(a* 3.14159/180.0)
	    y = SIN(b* 3.14159/180.0) * COS(a* 3.14159/180.0)
	    z = SIN(a* 3.14159/180.0)
	    call fglVertex3f( x, y, z )

            x = radius*COS(b*3.14159/180.0) * COS((a+da)*3.14159/180.0)
	    y = radius*SIN(b*3.14159/180.0) * COS((a+da)*3.14159/180.0)
	    z = radius*SIN((a+da)*3.14159/180.0)
	    call fglVertex3f( x, y, z )

	    color = 1-color
         end do
         call fglEnd()

      end do

      call fglEndList()

      make_ball = list
      return
      end



      subroutine reshape(width, height )
      include "GL/fgl.h"
      include "ftk.h"
      common /ints/ Ball, Mode
      common /floats/ Zrot, Zstep, Xpos, Ypos, Xvel, Yvel, Xmin, Xmax,
     1                Ymin, Ymax, G
      integer Ball, Mode
      real Zrot, Zstep, Xpos, Ypos, Xvel, Yvel, Xmin, Xmax,
     1     Ymin, Ymax, G

      integer width, height
      call fglViewport(0, 0, width, height)
      call fglMatrixMode(GL_PROJECTION)
      call fglLoadIdentity()
      call fglOrtho( -6.0d0, 6.0d0, -6.0d0, 6.0d0, -6.0d0, 6.0d0 )
      call fglMatrixMode(GL_MODELVIEW)
      return
      end


      integer function key(k, mask)
      include "GL/fgl.h"
      include "ftk.h"
      common /ints/ Ball, Mode
      common /floats/ Zrot, Zstep, Xpos, Ypos, Xvel, Yvel, Xmin, Xmax,
     1                Ymin, Ymax, G
      integer Ball, Mode
      real Zrot, Zstep, Xpos, Ypos, Xvel, Yvel, Xmin, Xmax,
     1     Ymin, Ymax, G

      integer k, mask
      if (k.eq.TK_ESCAPE) then
         call ftkQuit()
      endif
      key = GL_FALSE
      return
      end


      subroutine draw()
      include "GL/fgl.h"
      include "ftk.h"
      common /ints/ Ball, Mode
      common /floats/ Zrot, Zstep, Xpos, Ypos, Xvel, Yvel, Xmin, Xmax,
     1                Ymin, Ymax, G
      integer Ball, Mode
      real Zrot, Zstep, Xpos, Ypos, Xvel, Yvel, Xmin, Xmax,
     1     Ymin, Ymax, G

      integer i,j

      call fglClear( GL_COLOR_BUFFER_BIT )

      call fTK_SETCOLOR( Mode, TK_CYAN )
      call fglBegin( GL_LINES )
      do i=-5,5
         call fglVertex2i( i, -5 )
         call fglVertex2i( i, 5 )
      end do
      do i=-5,5
         call fglVertex2i( -5,i )
         call fglVertex2i( 5,i )
      end do
      do i=-5,5
         call fglVertex2i( i, -5 )
         call fglVertex2f( i*1.15, -5.9 )
      end do
      call fglVertex2f( -5.3, -5.35 )
      call fglVertex2f( 5.3, -5.35 )
      call fglVertex2f( -5.75, -5.9 )
      call fglVertex2f( 5.75, -5.9 )
      call fglEnd()


      call fglPushMatrix()
      call fglTranslatef( Xpos, Ypos, 0.0 )
      call fglScalef( 2.0, 2.0, 2.0 )
      call fglRotatef( 8.0, 0.0, 0.0, 1.0 )
      call fglRotatef( 90.0, 1.0, 0.0, 0.0 )
      call fglRotatef( Zrot, 0.0, 0.0, 1.0 )


      call fglCallList( Ball )

      call fglPopMatrix()

      call fglFlush()
      call ftkSwapBuffers()
      return
      end


      subroutine idle()
      include "GL/fgl.h"
      include "ftk.h"
      common /ints/ Ball, Mode
      common /floats/ Zrot, Zstep, Xpos, Ypos, Xvel, Yvel, Xmin, Xmax,
     1                Ymin, Ymax, G
      integer Ball, Mode
      real Zrot, Zstep, Xpos, Ypos, Xvel, Yvel, Xmin, Xmax,
     1     Ymin, Ymax, G

      real vel0
      save vel0
      data vel0/-100.0/

      Zrot = Zrot + Zstep

      Xpos = Xpos + Xvel
      if (Xpos.ge.Xmax) then
         Xpos = Xmax
         Xvel = -Xvel
         Zstep = -Zstep
      endif
      if (Xpos.le.Xmin) then
         Xpos = Xmin
         Xvel = -Xvel
         Zstep = -Zstep
      endif

      Ypos = Ypos + Yvel
      Yvel = Yvel + G
      if (Ypos.lt.Ymin) then
         Ypos = Ymin
         if (vel0.eq.-100.0)  vel0 = abs(Yvel)
         Yvel = vel0
      endif
      call draw()
      return
      end



      program main

      include "GL/fgl.h"
      include "ftk.h"
      common /ints/ Ball, Mode
      common /floats/ Zrot, Zstep, Xpos, Ypos, Xvel, Yvel, Xmin, Xmax,
     1                Ymin, Ymax, G
      integer Ball, Mode
      real Zrot, Zstep, Xpos, Ypos, Xvel, Yvel, Xmin, Xmax,
     1     Ymin, Ymax, G

      external reshape, key, idle, draw

      Zrot = 0.0
      Zstep = 6.0
      Xpos = 0.0
      Ypos = 1.0
      Xvel = 0.2
      Yvel = 0.0
      Xmin=-4.0
      Xmax=4.0
      Ymin=-3.8
      Ymax=4.0
      G = -0.1

      call ftkInitPosition(0, 0, 300, 300)

      Mode =  TK_INDEX + TK_DOUBLE + TK_DIRECT
      call ftkInitDisplayMode(Mode)

      if (ftkInitWindow("Bounce") .eq. GL_FALSE) then
         call ftkQuit()
      endif

      Ball = make_ball()
      call fglCullFace( GL_BACK )
      call fglEnable( GL_CULL_FACE )
      call fglDisable( GL_DITHER )
      call fglShadeModel( GL_FLAT )

      call ftkExposeFunc( reshape )
      call ftkReshapeFunc( reshape )
      call ftkKeyDownFunc( key )
      call ftkIdleFunc( idle )
      call ftkDisplayFunc( draw )
      call ftkExec()

      end
