/*-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for Mesa software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------*/

#ifdef FBIND


#include <string.h>
#include <GL/gl.h>
#include <GL/glu.h>
#define MIN2( A, B )   ( (A)<(B) ? (A) : (B) )

/* equalence of types

 OpenGL          description              C     extended fortan 77

GLboolean   8-bit unsigned integer  unsigned char  logical*1
GLbyte      8-bit integer           signed char    integer*1
GLubyte     8-bit unsigned integer  unsigned char  integer*1
GLshort    16-bit integer           short          integer*2
GLushort   16-bit unsigned integer  unsigned short integer*2
GLint      32-bit integer           long           integer*4
GLuint     32-bit unsigned integer  unsigned long  integer*4
GLenum     32-bit unsigned integer  unsigned long  integer*4
GLbitfield 32-bit unsigned integer  unsigned long  integer*4
GLsizei    32-bit integer           long           integer*4
GLfloat    32-bit floating point    float          real*4
GLclampf   32-bit floating point    float          real*4
GLdouble   64-bit floating point    double         real*8
GLclampd   64-bit floating point    double         real*8
GLvoid     generic pointer GLvoid*  void           any array


   f90gl            fortran 90

f90glboolean    logical(kind=k) where k gives a 1 byte logical, if possible
f90glbyte       selected_int_kind(2)
f90glubyte      selected_int_kind(2)
f90glshort      selected_int_kind(4)
f90glushort     selected_int_kind(4)
f90glint        selected_int_kind(9)
f90gluint       selected_int_kind(9)
f90glenum       selected_int_kind(9)
f90glbitfield   selected_int_kind(9)
f90glsizei      selected_int_kind(9)
f90glfloat      selected_real_kind(6)
f90glclampf     selected_real_kind(6)
f90gldouble     selected_real_kind(15)
f90glclampd     selected_real_kind(15)
f90glvoid       any array

*/

/*
 * Mapping of Fortran types to C types:
 */

#define f90glboolean  unsigned char *
#define f90glbyte     signed char *
#define f90glubyte    unsigned char *
#define f90glshort    short *
#define f90glushort   unsigned short *
#define f90glint      long *
#define f90gluint     unsigned long *
#define f90glenum     unsigned long *
#define f90glbitfield unsigned long *
#define f90glsizei    long *
#define f90glfloat    float *
#define f90glclampf   float *
#define f90gldouble   double *
#define f90glclampd   double *
#define f90glvoid     long *

/* procedure name mangling */

#if FBIND==1
#define fglClearIndex                  fglclearindex
#define fglClearColor                  fglclearcolor
#define fglClear                       fglclear
#define fglIndexMask                   fglindexmask
#define fglColorMask                   fglcolormask
#define fglAlphaFunc                   fglalphafunc
#define fglBlendFunc                   fglblendfunc
#define fglLogicOp                     fgllogicop
#define fglCullFace                    fglcullface
#define fglFrontFace                   fglfrontface
#define fglPointSize                   fglpointsize
#define fglLineWidth                   fgllinewidth
#define fglLineStipple                 fgllinestipple
#define fglPolygonMode                 fglpolygonmode
#define fglPolygonStipple              fglpolygonstipple
#define fglGetPolygonStipple           fglgetpolygonstipple
#define fglEdgeFlag                    fgledgeflag
#define fglEdgeFlagv                   fgledgeflagv
#define fglScissor                     fglscissor
#define fglClipPlane                   fglclipplane
#define fglGetClipPlane                fglgetclipplane
#define fglDrawBuffer                  fgldrawbuffer
#define fglReadBuffer                  fglreadbuffer
#define fglEnable                      fglenable
#define fglDisable                     fgldisable
#define fglIsEnabled                   fglisenabled
#define fglGetBooleanv                 fglgetbooleanv
#define fglGetDoublev                  fglgetdoublev
#define fglGetFloatv                   fglgetfloatv
#define fglGetIntegerv                 fglgetintegerv
#define fglPushAttrib                  fglpushattrib
#define fglPopAttrib                   fglpopattrib
#define fglRenderMode                  fglrendermode
#define fglGetError                    fglgeterror
#define fglGetString                   fglgetstring
#define fglFinish                      fglfinish
#define fglFlush                       fglflush
#define fglHint                        fglhint
#define fglClearDepth                  fglcleardepth
#define fglDepthFunc                   fgldepthfunc
#define fglDepthMask                   fgldepthmask
#define fglDepthRange                  fgldepthrange
#define fglClearAccum                  fglclearaccum
#define fglAccum                       fglaccum
#define fglMatrixMode                  fglmatrixmode
#define fglOrtho                       fglortho
#define fglFrustum                     fglfrustum
#define fglViewport                    fglviewport
#define fglPushMatrix                  fglpushmatrix
#define fglPopMatrix                   fglpopmatrix
#define fglLoadIdentity                fglloadidentity
#define fglLoadMatrixd                 fglloadmatrixd
#define fglLoadMatrixf                 fglloadmatrixf
#define fglMultMatrixd                 fglmultmatrixd
#define fglMultMatrixf                 fglmultmatrixf
#define fglRotated                     fglrotated
#define fglRotatef                     fglrotatef
#define fglScaled                      fglscaled
#define fglScalef                      fglscalef
#define fglTranslated                  fgltranslated
#define fglTranslatef                  fgltranslatef
#define fglIsList                      fglislist
#define fglDeleteLists                 fgldeletelists
#define fglGenLists                    fglgenlists
#define fglNewList                     fglnewlist
#define fglEndList                     fglendlist
#define fglCallList                    fglcalllist
#define fglCallLists                   fglcalllists
#define fglListBase                    fgllistbase
#define fglBegin                       fglbegin
#define fglEnd                         fglend
#define fglVertex2d                    fglvertex2d
#define fglVertex2f                    fglvertex2f
#define fglVertex2i                    fglvertex2i
#define fglVertex2s                    fglvertex2s
#define fglVertex3d                    fglvertex3d
#define fglVertex3f                    fglvertex3f
#define fglVertex3i                    fglvertex3i
#define fglVertex3s                    fglvertex3s
#define fglVertex4d                    fglvertex4d
#define fglVertex4f                    fglvertex4f
#define fglVertex4i                    fglvertex4i
#define fglVertex4s                    fglvertex4s
#define fglVertex2dv                   fglvertex2dv
#define fglVertex2fv                   fglvertex2fv
#define fglVertex2iv                   fglvertex2iv
#define fglVertex2sv                   fglvertex2sv
#define fglVertex3dv                   fglvertex3dv
#define fglVertex3fv                   fglvertex3fv
#define fglVertex3iv                   fglvertex3iv
#define fglVertex3sv                   fglvertex3sv
#define fglVertex4dv                   fglvertex4dv
#define fglVertex4fv                   fglvertex4fv
#define fglVertex4iv                   fglvertex4iv
#define fglVertex4sv                   fglvertex4sv
#define fglNormal3b                    fglnormal3b
#define fglNormal3d                    fglnormal3d
#define fglNormal3f                    fglnormal3f
#define fglNormal3i                    fglnormal3i
#define fglNormal3s                    fglnormal3s
#define fglNormal3bv                   fglnormal3bv
#define fglNormal3dv                   fglnormal3dv
#define fglNormal3fv                   fglnormal3fv
#define fglNormal3iv                   fglnormal3iv
#define fglNormal3sv                   fglnormal3sv
#define fglIndexd                      fglindexd
#define fglIndexf                      fglindexf
#define fglIndexi                      fglindexi
#define fglIndexs                      fglindexs
#define fglIndexdv                     fglindexdv
#define fglIndexfv                     fglindexfv
#define fglIndexiv                     fglindexiv
#define fglIndexsv                     fglindexsv
#define fglColor3b                     fglcolor3b
#define fglColor3d                     fglcolor3d
#define fglColor3f                     fglcolor3f
#define fglColor3i                     fglcolor3i
#define fglColor3s                     fglcolor3s
#define fglColor3ub                    fglcolor3ub
#define fglColor3ui                    fglcolor3ui
#define fglColor3us                    fglcolor3us
#define fglColor4b                     fglcolor4b
#define fglColor4d                     fglcolor4d
#define fglColor4f                     fglcolor4f
#define fglColor4i                     fglcolor4i
#define fglColor4s                     fglcolor4s
#define fglColor4ub                    fglcolor4ub
#define fglColor4ui                    fglcolor4ui
#define fglColor4us                    fglcolor4us
#define fglColor3bv                    fglcolor3bv
#define fglColor3dv                    fglcolor3dv
#define fglColor3fv                    fglcolor3fv
#define fglColor3iv                    fglcolor3iv
#define fglColor3sv                    fglcolor3sv
#define fglColor3ubv                   fglcolor3ubv
#define fglColor3uiv                   fglcolor3uiv
#define fglColor3usv                   fglcolor3usv
#define fglColor4bv                    fglcolor4bv
#define fglColor4dv                    fglcolor4dv
#define fglColor4fv                    fglcolor4fv
#define fglColor4iv                    fglcolor4iv
#define fglColor4sv                    fglcolor4sv
#define fglColor4ubv                   fglcolor4ubv
#define fglColor4uiv                   fglcolor4uiv
#define fglColor4usv                   fglcolor4usv
#define fglTexCoord1d                  fgltexcoord1d
#define fglTexCoord1f                  fgltexcoord1f
#define fglTexCoord1i                  fgltexcoord1i
#define fglTexCoord1s                  fgltexcoord1s
#define fglTexCoord2d                  fgltexcoord2d
#define fglTexCoord2f                  fgltexcoord2f
#define fglTexCoord2i                  fgltexcoord2i
#define fglTexCoord2s                  fgltexcoord2s
#define fglTexCoord3d                  fgltexcoord3d
#define fglTexCoord3f                  fgltexcoord3f
#define fglTexCoord3i                  fgltexcoord3i
#define fglTexCoord3s                  fgltexcoord3s
#define fglTexCoord4d                  fgltexcoord4d
#define fglTexCoord4f                  fgltexcoord4f
#define fglTexCoord4i                  fgltexcoord4i
#define fglTexCoord4s                  fgltexcoord4s
#define fglTexCoord1dv                 fgltexcoord1dv
#define fglTexCoord1fv                 fgltexcoord1fv
#define fglTexCoord1iv                 fgltexcoord1iv
#define fglTexCoord1sv                 fgltexcoord1sv
#define fglTexCoord2dv                 fgltexcoord2dv
#define fglTexCoord2fv                 fgltexcoord2fv
#define fglTexCoord2iv                 fgltexcoord2iv
#define fglTexCoord2sv                 fgltexcoord2sv
#define fglTexCoord3dv                 fgltexcoord3dv
#define fglTexCoord3fv                 fgltexcoord3fv
#define fglTexCoord3iv                 fgltexcoord3iv
#define fglTexCoord3sv                 fgltexcoord3sv
#define fglTexCoord4dv                 fgltexcoord4dv
#define fglTexCoord4fv                 fgltexcoord4fv
#define fglTexCoord4iv                 fgltexcoord4iv
#define fglTexCoord4sv                 fgltexcoord4sv
#define fglRasterPos2d                 fglrasterpos2d
#define fglRasterPos2f                 fglrasterpos2f
#define fglRasterPos2i                 fglrasterpos2i
#define fglRasterPos2s                 fglrasterpos2s
#define fglRasterPos3d                 fglrasterpos3d
#define fglRasterPos3f                 fglrasterpos3f
#define fglRasterPos3i                 fglrasterpos3i
#define fglRasterPos3s                 fglrasterpos3s
#define fglRasterPos4d                 fglrasterpos4d
#define fglRasterPos4f                 fglrasterpos4f
#define fglRasterPos4i                 fglrasterpos4i
#define fglRasterPos4s                 fglrasterpos4s
#define fglRasterPos2dv                fglrasterpos2dv
#define fglRasterPos2fv                fglrasterpos2fv
#define fglRasterPos2iv                fglrasterpos2iv
#define fglRasterPos2sv                fglrasterpos2sv
#define fglRasterPos3dv                fglrasterpos3dv
#define fglRasterPos3fv                fglrasterpos3fv
#define fglRasterPos3iv                fglrasterpos3iv
#define fglRasterPos3sv                fglrasterpos3sv
#define fglRasterPos4dv                fglrasterpos4dv
#define fglRasterPos4fv                fglrasterpos4fv
#define fglRasterPos4iv                fglrasterpos4iv
#define fglRasterPos4sv                fglrasterpos4sv
#define fglRectd                       fglrectd
#define fglRectf                       fglrectf
#define fglRecti                       fglrecti
#define fglRects                       fglrects
#define fglRectdv                      fglrectdv
#define fglRectfv                      fglrectfv
#define fglRectiv                      fglrectiv
#define fglRectsv                      fglrectsv
#define fglShadeModel                  fglshademodel
#define fglLightf                      fgllightf
#define fglLighti                      fgllighti
#define fglLightfv                     fgllightfv
#define fglLightiv                     fgllightiv
#define fglGetLightfv                  fglgetlightfv
#define fglGetLightiv                  fglgetlightiv
#define fglLightModelf                 fgllightmodelf
#define fglLightModeli                 fgllightmodeli
#define fglLightModelfv                fgllightmodelfv
#define fglLightModeliv                fgllightmodeliv
#define fglMaterialf                   fglmaterialf
#define fglMateriali                   fglmateriali
#define fglMaterialfv                  fglmaterialfv
#define fglMaterialiv                  fglmaterialiv
#define fglGetMaterialfv               fglgetmaterialfv
#define fglGetMaterialiv               fglgetmaterialiv
#define fglColorMaterial               fglcolormaterial
#define fglPixelZoom                   fglpixelzoom
#define fglPixelStoref                 fglpixelstoref
#define fglPixelStorei                 fglpixelstorei
#define fglPixelTransferf              fglpixeltransferf
#define fglPixelTransferi              fglpixeltransferi
#define fglPixelMapfv                  fglpixelmapfv
#define fglPixelMapuiv                 fglpixelmapuiv
#define fglPixelMapusv                 fglpixelmapusv
#define fglGetPixelMapfv               fglgetpixelmapfv
#define fglGetPixelMapuiv              fglgetpixelmapuiv
#define fglGetPixelMapusv              fglgetpixelmapusv
#define fglBitmap                      fglbitmap
#define fglReadPixels                  fglreadpixels
#define fglDrawPixels                  fgldrawpixels
#define fglCopyPixels                  fglcopypixels
#define fglStencilFunc                 fglstencilfunc
#define fglStencilMask                 fglstencilmask
#define fglStencilOp                   fglstencilop
#define fglClearStencil                fglclearstencil
#define fglTexGend                     fgltexgend
#define fglTexGenf                     fgltexgenf
#define fglTexGeni                     fgltexgeni
#define fglTexGendv                    fgltexgendv
#define fglTexGenfv                    fgltexgenfv
#define fglTexGeniv                    fgltexgeniv
#define fglGetTexGendv                 fglgettexgendv
#define fglGetTexGenfv                 fglgettexgenfv
#define fglGetTexGeniv                 fglgettexgeniv
#define fglTexEnvf                     fgltexenvf
#define fglTexEnvi                     fgltexenvi
#define fglTexEnvfv                    fgltexenvfv
#define fglTexEnviv                    fgltexenviv
#define fglGetTexEnvfv                 fglgettexenvfv
#define fglGetTexEnviv                 fglgettexenviv
#define fglTexParameterf               fgltexparameterf
#define fglTexParameteri               fgltexparameteri
#define fglTexParameterfv              fgltexparameterfv
#define fglTexParameteriv              fgltexparameteriv
#define fglGetTexParameterfv           fglgettexparameterfv
#define fglGetTexParameteriv           fglgettexparameteriv
#define fglGetTexLevelParameterfv      fglgettexlevelparameterfv
#define fglGetTexLevelParameteriv      fglgettexlevelparameteriv
#define fglTexImage1D                  fglteximage1d
#define fglTexImage2D                  fglteximage2d
#define fglGetTexImage                 fglgetteximage
#define fglMap1d                       fglmap1d
#define fglMap1f                       fglmap1f
#define fglMap2d                       fglmap2d
#define fglMap2f                       fglmap2f
#define fglGetMapdv                    fglgetmapdv
#define fglGetMapfv                    fglgetmapfv
#define fglGetMapiv                    fglgetmapiv
#define fglEvalCoord1d                 fglevalcoord1d
#define fglEvalCoord1f                 fglevalcoord1f
#define fglEvalCoord1dv                fglevalcoord1dv
#define fglEvalCoord1fv                fglevalcoord1fv
#define fglEvalCoord2d                 fglevalcoord2d
#define fglEvalCoord2f                 fglevalcoord2f
#define fglEvalCoord2dv                fglevalcoord2dv
#define fglEvalCoord2fv                fglevalcoord2fv
#define fglMapGrid1d                   fglmapgrid1d
#define fglMapGrid1f                   fglmapgrid1f
#define fglMapGrid2d                   fglmapgrid2d
#define fglMapGrid2f                   fglmapgrid2f
#define fglEvalPoint1                  fglevalpoint1
#define fglEvalPoint2                  fglevalpoint2
#define fglEvalMesh1                   fglevalmesh1
#define fglEvalMesh2                   fglevalmesh2
#define fglFogf                        fglfogf
#define fglFogi                        fglfogi
#define fglFogfv                       fglfogfv
#define fglFogiv                       fglfogiv
#define fglFeedbackBuffer              fglfeedbackbuffer
#define fglPassThrough                 fglpassthrough
#define fglSelectBuffer                fglselectbuffer
#define fglInitNames                   fglinitnames
#define fglLoadName                    fglloadname
#define fglPushName                    fglpushname
#define fglPopName                     fglpopname
#define fglBlendEquationEXT            fglblendequationext
#define fglBlendColorEXT               fglblendcolorext
/*#define fglPolygonOffsetEXT            fglpolygonoffsetext*/
#define fglWindowPos2iMESA             fglwindowpos2imesa
#define fglWindowPos2sMESA             fglwindowpos2smesa
#define fglWindowPos2fMESA             fglwindowpos2fmesa
#define fglWindowPos2dMESA             fglwindowpos2dmesa
#define fglWindowPos2ivMESA            fglwindowpos2ivmesa
#define fglWindowPos2svMESA            fglwindowpos2svmesa
#define fglWindowPos2fvMESA            fglwindowpos2fvmesa
#define fglWindowPos2dvMESA            fglwindowpos2dvmesa
#define fglWindowPos3iMESA             fglwindowpos3imesa
#define fglWindowPos3sMESA             fglwindowpos3smesa
#define fglWindowPos3fMESA             fglwindowpos3fmesa
#define fglWindowPos3dMESA             fglwindowpos3dmesa
#define fglWindowPos3ivMESA            fglwindowpos3ivmesa
#define fglWindowPos3svMESA            fglwindowpos3svmesa
#define fglWindowPos3fvMESA            fglwindowpos3fvmesa
#define fglWindowPos3dvMESA            fglwindowpos3dvmesa
#define fglWindowPos4iMESA             fglwindowpos4imesa
#define fglWindowPos4sMESA             fglwindowpos4smesa
#define fglWindowPos4fMESA             fglwindowpos4fmesa
#define fglWindowPos4dMESA             fglwindowpos4dmesa
#define fglWindowPos4ivMESA            fglwindowpos4ivmesa
#define fglWindowPos4svMESA            fglwindowpos4svmesa
#define fglWindowPos4fvMESA            fglwindowpos4fvmesa
#define fglWindowPos4dvMESA            fglwindowpos4dvmesa
#elif FBIND==2
#define fglClearIndex                  fglclearindex_
#define fglClearColor                  fglclearcolor_
#define fglClear                       fglclear_
#define fglIndexMask                   fglindexmask_
#define fglColorMask                   fglcolormask_
#define fglAlphaFunc                   fglalphafunc_
#define fglBlendFunc                   fglblendfunc_
#define fglLogicOp                     fgllogicop_
#define fglCullFace                    fglcullface_
#define fglFrontFace                   fglfrontface_
#define fglPointSize                   fglpointsize_
#define fglLineWidth                   fgllinewidth_
#define fglLineStipple                 fgllinestipple_
#define fglPolygonMode                 fglpolygonmode_
#define fglPolygonStipple              fglpolygonstipple_
#define fglGetPolygonStipple           fglgetpolygonstipple_
#define fglEdgeFlag                    fgledgeflag_
#define fglEdgeFlagv                   fgledgeflagv_
#define fglScissor                     fglscissor_
#define fglClipPlane                   fglclipplane_
#define fglGetClipPlane                fglgetclipplane_
#define fglDrawBuffer                  fgldrawbuffer_
#define fglReadBuffer                  fglreadbuffer_
#define fglEnable                      fglenable_
#define fglDisable                     fgldisable_
#define fglIsEnabled                   fglisenabled_
#define fglGetBooleanv                 fglgetbooleanv_
#define fglGetDoublev                  fglgetdoublev_
#define fglGetFloatv                   fglgetfloatv_
#define fglGetIntegerv                 fglgetintegerv_
#define fglPushAttrib                  fglpushattrib_
#define fglPopAttrib                   fglpopattrib_
#define fglRenderMode                  fglrendermode_
#define fglGetError                    fglgeterror_
#define fglGetString                   fglgetstring_
#define fglFinish                      fglfinish_
#define fglFlush                       fglflush_
#define fglHint                        fglhint_
#define fglClearDepth                  fglcleardepth_
#define fglDepthFunc                   fgldepthfunc_
#define fglDepthMask                   fgldepthmask_
#define fglDepthRange                  fgldepthrange_
#define fglClearAccum                  fglclearaccum_
#define fglAccum                       fglaccum_
#define fglMatrixMode                  fglmatrixmode_
#define fglOrtho                       fglortho_
#define fglFrustum                     fglfrustum_
#define fglViewport                    fglviewport_
#define fglPushMatrix                  fglpushmatrix_
#define fglPopMatrix                   fglpopmatrix_
#define fglLoadIdentity                fglloadidentity_
#define fglLoadMatrixd                 fglloadmatrixd_
#define fglLoadMatrixf                 fglloadmatrixf_
#define fglMultMatrixd                 fglmultmatrixd_
#define fglMultMatrixf                 fglmultmatrixf_
#define fglRotated                     fglrotated_
#define fglRotatef                     fglrotatef_
#define fglScaled                      fglscaled_
#define fglScalef                      fglscalef_
#define fglTranslated                  fgltranslated_
#define fglTranslatef                  fgltranslatef_
#define fglIsList                      fglislist_
#define fglDeleteLists                 fgldeletelists_
#define fglGenLists                    fglgenlists_
#define fglNewList                     fglnewlist_
#define fglEndList                     fglendlist_
#define fglCallList                    fglcalllist_
#define fglCallLists                   fglcalllists_
#define fglListBase                    fgllistbase_
#define fglBegin                       fglbegin_
#define fglEnd                         fglend_
#define fglVertex2d                    fglvertex2d_
#define fglVertex2f                    fglvertex2f_
#define fglVertex2i                    fglvertex2i_
#define fglVertex2s                    fglvertex2s_
#define fglVertex3d                    fglvertex3d_
#define fglVertex3f                    fglvertex3f_
#define fglVertex3i                    fglvertex3i_
#define fglVertex3s                    fglvertex3s_
#define fglVertex4d                    fglvertex4d_
#define fglVertex4f                    fglvertex4f_
#define fglVertex4i                    fglvertex4i_
#define fglVertex4s                    fglvertex4s_
#define fglVertex2dv                   fglvertex2dv_
#define fglVertex2fv                   fglvertex2fv_
#define fglVertex2iv                   fglvertex2iv_
#define fglVertex2sv                   fglvertex2sv_
#define fglVertex3dv                   fglvertex3dv_
#define fglVertex3fv                   fglvertex3fv_
#define fglVertex3iv                   fglvertex3iv_
#define fglVertex3sv                   fglvertex3sv_
#define fglVertex4dv                   fglvertex4dv_
#define fglVertex4fv                   fglvertex4fv_
#define fglVertex4iv                   fglvertex4iv_
#define fglVertex4sv                   fglvertex4sv_
#define fglNormal3b                    fglnormal3b_
#define fglNormal3d                    fglnormal3d_
#define fglNormal3f                    fglnormal3f_
#define fglNormal3i                    fglnormal3i_
#define fglNormal3s                    fglnormal3s_
#define fglNormal3bv                   fglnormal3bv_
#define fglNormal3dv                   fglnormal3dv_
#define fglNormal3fv                   fglnormal3fv_
#define fglNormal3iv                   fglnormal3iv_
#define fglNormal3sv                   fglnormal3sv_
#define fglIndexd                      fglindexd_
#define fglIndexf                      fglindexf_
#define fglIndexi                      fglindexi_
#define fglIndexs                      fglindexs_
#define fglIndexdv                     fglindexdv_
#define fglIndexfv                     fglindexfv_
#define fglIndexiv                     fglindexiv_
#define fglIndexsv                     fglindexsv_
#define fglColor3b                     fglcolor3b_
#define fglColor3d                     fglcolor3d_
#define fglColor3f                     fglcolor3f_
#define fglColor3i                     fglcolor3i_
#define fglColor3s                     fglcolor3s_
#define fglColor3ub                    fglcolor3ub_
#define fglColor3ui                    fglcolor3ui_
#define fglColor3us                    fglcolor3us_
#define fglColor4b                     fglcolor4b_
#define fglColor4d                     fglcolor4d_
#define fglColor4f                     fglcolor4f_
#define fglColor4i                     fglcolor4i_
#define fglColor4s                     fglcolor4s_
#define fglColor4ub                    fglcolor4ub_
#define fglColor4ui                    fglcolor4ui_
#define fglColor4us                    fglcolor4us_
#define fglColor3bv                    fglcolor3bv_
#define fglColor3dv                    fglcolor3dv_
#define fglColor3fv                    fglcolor3fv_
#define fglColor3iv                    fglcolor3iv_
#define fglColor3sv                    fglcolor3sv_
#define fglColor3ubv                   fglcolor3ubv_
#define fglColor3uiv                   fglcolor3uiv_
#define fglColor3usv                   fglcolor3usv_
#define fglColor4bv                    fglcolor4bv_
#define fglColor4dv                    fglcolor4dv_
#define fglColor4fv                    fglcolor4fv_
#define fglColor4iv                    fglcolor4iv_
#define fglColor4sv                    fglcolor4sv_
#define fglColor4ubv                   fglcolor4ubv_
#define fglColor4uiv                   fglcolor4uiv_
#define fglColor4usv                   fglcolor4usv_
#define fglTexCoord1d                  fgltexcoord1d_
#define fglTexCoord1f                  fgltexcoord1f_
#define fglTexCoord1i                  fgltexcoord1i_
#define fglTexCoord1s                  fgltexcoord1s_
#define fglTexCoord2d                  fgltexcoord2d_
#define fglTexCoord2f                  fgltexcoord2f_
#define fglTexCoord2i                  fgltexcoord2i_
#define fglTexCoord2s                  fgltexcoord2s_
#define fglTexCoord3d                  fgltexcoord3d_
#define fglTexCoord3f                  fgltexcoord3f_
#define fglTexCoord3i                  fgltexcoord3i_
#define fglTexCoord3s                  fgltexcoord3s_
#define fglTexCoord4d                  fgltexcoord4d_
#define fglTexCoord4f                  fgltexcoord4f_
#define fglTexCoord4i                  fgltexcoord4i_
#define fglTexCoord4s                  fgltexcoord4s_
#define fglTexCoord1dv                 fgltexcoord1dv_
#define fglTexCoord1fv                 fgltexcoord1fv_
#define fglTexCoord1iv                 fgltexcoord1iv_
#define fglTexCoord1sv                 fgltexcoord1sv_
#define fglTexCoord2dv                 fgltexcoord2dv_
#define fglTexCoord2fv                 fgltexcoord2fv_
#define fglTexCoord2iv                 fgltexcoord2iv_
#define fglTexCoord2sv                 fgltexcoord2sv_
#define fglTexCoord3dv                 fgltexcoord3dv_
#define fglTexCoord3fv                 fgltexcoord3fv_
#define fglTexCoord3iv                 fgltexcoord3iv_
#define fglTexCoord3sv                 fgltexcoord3sv_
#define fglTexCoord4dv                 fgltexcoord4dv_
#define fglTexCoord4fv                 fgltexcoord4fv_
#define fglTexCoord4iv                 fgltexcoord4iv_
#define fglTexCoord4sv                 fgltexcoord4sv_
#define fglRasterPos2d                 fglrasterpos2d_
#define fglRasterPos2f                 fglrasterpos2f_
#define fglRasterPos2i                 fglrasterpos2i_
#define fglRasterPos2s                 fglrasterpos2s_
#define fglRasterPos3d                 fglrasterpos3d_
#define fglRasterPos3f                 fglrasterpos3f_
#define fglRasterPos3i                 fglrasterpos3i_
#define fglRasterPos3s                 fglrasterpos3s_
#define fglRasterPos4d                 fglrasterpos4d_
#define fglRasterPos4f                 fglrasterpos4f_
#define fglRasterPos4i                 fglrasterpos4i_
#define fglRasterPos4s                 fglrasterpos4s_
#define fglRasterPos2dv                fglrasterpos2dv_
#define fglRasterPos2fv                fglrasterpos2fv_
#define fglRasterPos2iv                fglrasterpos2iv_
#define fglRasterPos2sv                fglrasterpos2sv_
#define fglRasterPos3dv                fglrasterpos3dv_
#define fglRasterPos3fv                fglrasterpos3fv_
#define fglRasterPos3iv                fglrasterpos3iv_
#define fglRasterPos3sv                fglrasterpos3sv_
#define fglRasterPos4dv                fglrasterpos4dv_
#define fglRasterPos4fv                fglrasterpos4fv_
#define fglRasterPos4iv                fglrasterpos4iv_
#define fglRasterPos4sv                fglrasterpos4sv_
#define fglRectd                       fglrectd_
#define fglRectf                       fglrectf_
#define fglRecti                       fglrecti_
#define fglRects                       fglrects_
#define fglRectdv                      fglrectdv_
#define fglRectfv                      fglrectfv_
#define fglRectiv                      fglrectiv_
#define fglRectsv                      fglrectsv_
#define fglShadeModel                  fglshademodel_
#define fglLightf                      fgllightf_
#define fglLighti                      fgllighti_
#define fglLightfv                     fgllightfv_
#define fglLightiv                     fgllightiv_
#define fglGetLightfv                  fglgetlightfv_
#define fglGetLightiv                  fglgetlightiv_
#define fglLightModelf                 fgllightmodelf_
#define fglLightModeli                 fgllightmodeli_
#define fglLightModelfv                fgllightmodelfv_
#define fglLightModeliv                fgllightmodeliv_
#define fglMaterialf                   fglmaterialf_
#define fglMateriali                   fglmateriali_
#define fglMaterialfv                  fglmaterialfv_
#define fglMaterialiv                  fglmaterialiv_
#define fglGetMaterialfv               fglgetmaterialfv_
#define fglGetMaterialiv               fglgetmaterialiv_
#define fglColorMaterial               fglcolormaterial_
#define fglPixelZoom                   fglpixelzoom_
#define fglPixelStoref                 fglpixelstoref_
#define fglPixelStorei                 fglpixelstorei_
#define fglPixelTransferf              fglpixeltransferf_
#define fglPixelTransferi              fglpixeltransferi_
#define fglPixelMapfv                  fglpixelmapfv_
#define fglPixelMapuiv                 fglpixelmapuiv_
#define fglPixelMapusv                 fglpixelmapusv_
#define fglGetPixelMapfv               fglgetpixelmapfv_
#define fglGetPixelMapuiv              fglgetpixelmapuiv_
#define fglGetPixelMapusv              fglgetpixelmapusv_
#define fglBitmap                      fglbitmap_
#define fglReadPixels                  fglreadpixels_
#define fglDrawPixels                  fgldrawpixels_
#define fglCopyPixels                  fglcopypixels_
#define fglStencilFunc                 fglstencilfunc_
#define fglStencilMask                 fglstencilmask_
#define fglStencilOp                   fglstencilop_
#define fglClearStencil                fglclearstencil_
#define fglTexGend                     fgltexgend_
#define fglTexGenf                     fgltexgenf_
#define fglTexGeni                     fgltexgeni_
#define fglTexGendv                    fgltexgendv_
#define fglTexGenfv                    fgltexgenfv_
#define fglTexGeniv                    fgltexgeniv_
#define fglGetTexGendv                 fglgettexgendv_
#define fglGetTexGenfv                 fglgettexgenfv_
#define fglGetTexGeniv                 fglgettexgeniv_
#define fglTexEnvf                     fgltexenvf_
#define fglTexEnvi                     fgltexenvi_
#define fglTexEnvfv                    fgltexenvfv_
#define fglTexEnviv                    fgltexenviv_
#define fglGetTexEnvfv                 fglgettexenvfv_
#define fglGetTexEnviv                 fglgettexenviv_
#define fglTexParameterf               fgltexparameterf_
#define fglTexParameteri               fgltexparameteri_
#define fglTexParameterfv              fgltexparameterfv_
#define fglTexParameteriv              fgltexparameteriv_
#define fglGetTexParameterfv           fglgettexparameterfv_
#define fglGetTexParameteriv           fglgettexparameteriv_
#define fglGetTexLevelParameterfv      fglgettexlevelparameterfv_
#define fglGetTexLevelParameteriv      fglgettexlevelparameteriv_
#define fglTexImage1D                  fglteximage1d_
#define fglTexImage2D                  fglteximage2d_
#define fglGetTexImage                 fglgetteximage_
#define fglMap1d                       fglmap1d_
#define fglMap1f                       fglmap1f_
#define fglMap2d                       fglmap2d_
#define fglMap2f                       fglmap2f_
#define fglGetMapdv                    fglgetmapdv_
#define fglGetMapfv                    fglgetmapfv_
#define fglGetMapiv                    fglgetmapiv_
#define fglEvalCoord1d                 fglevalcoord1d_
#define fglEvalCoord1f                 fglevalcoord1f_
#define fglEvalCoord1dv                fglevalcoord1dv_
#define fglEvalCoord1fv                fglevalcoord1fv_
#define fglEvalCoord2d                 fglevalcoord2d_
#define fglEvalCoord2f                 fglevalcoord2f_
#define fglEvalCoord2dv                fglevalcoord2dv_
#define fglEvalCoord2fv                fglevalcoord2fv_
#define fglMapGrid1d                   fglmapgrid1d_
#define fglMapGrid1f                   fglmapgrid1f_
#define fglMapGrid2d                   fglmapgrid2d_
#define fglMapGrid2f                   fglmapgrid2f_
#define fglEvalPoint1                  fglevalpoint1_
#define fglEvalPoint2                  fglevalpoint2_
#define fglEvalMesh1                   fglevalmesh1_
#define fglEvalMesh2                   fglevalmesh2_
#define fglFogf                        fglfogf_
#define fglFogi                        fglfogi_
#define fglFogfv                       fglfogfv_
#define fglFogiv                       fglfogiv_
#define fglFeedbackBuffer              fglfeedbackbuffer_
#define fglPassThrough                 fglpassthrough_
#define fglSelectBuffer                fglselectbuffer_
#define fglInitNames                   fglinitnames_
#define fglLoadName                    fglloadname_
#define fglPushName                    fglpushname_
#define fglPopName                     fglpopname_
#define fglBlendEquationEXT            fglblendequationext_
#define fglBlendColorEXT               fglblendcolorext_
/*#define fglPolygonOffsetEXT            fglpolygonoffsetext_*/
#define fglWindowPos2iMESA             fglwindowpos2imesa_
#define fglWindowPos2sMESA             fglwindowpos2smesa_
#define fglWindowPos2fMESA             fglwindowpos2fmesa_
#define fglWindowPos2dMESA             fglwindowpos2dmesa_
#define fglWindowPos2ivMESA            fglwindowpos2ivmesa_
#define fglWindowPos2svMESA            fglwindowpos2svmesa_
#define fglWindowPos2fvMESA            fglwindowpos2fvmesa_
#define fglWindowPos2dvMESA            fglwindowpos2dvmesa_
#define fglWindowPos3iMESA             fglwindowpos3imesa_
#define fglWindowPos3sMESA             fglwindowpos3smesa_
#define fglWindowPos3fMESA             fglwindowpos3fmesa_
#define fglWindowPos3dMESA             fglwindowpos3dmesa_
#define fglWindowPos3ivMESA            fglwindowpos3ivmesa_
#define fglWindowPos3svMESA            fglwindowpos3svmesa_
#define fglWindowPos3fvMESA            fglwindowpos3fvmesa_
#define fglWindowPos3dvMESA            fglwindowpos3dvmesa_
#define fglWindowPos4iMESA             fglwindowpos4imesa_
#define fglWindowPos4sMESA             fglwindowpos4smesa_
#define fglWindowPos4fMESA             fglwindowpos4fmesa_
#define fglWindowPos4dMESA             fglwindowpos4dmesa_
#define fglWindowPos4ivMESA            fglwindowpos4ivmesa_
#define fglWindowPos4svMESA            fglwindowpos4svmesa_
#define fglWindowPos4fvMESA            fglwindowpos4fvmesa_
#define fglWindowPos4dvMESA            fglwindowpos4dvmesa_
#elif FBIND==3
#define fglClearIndex                  FGLCLEARINDEX
#define fglClearColor                  FGLCLEARCOLOR
#define fglClear                       FGLCLEAR
#define fglIndexMask                   FGLINDEXMASK
#define fglColorMask                   FGLCOLORMASK
#define fglAlphaFunc                   FGLALPHAFUNC
#define fglBlendFunc                   FGLBLENDFUNC
#define fglLogicOp                     FGLLOGICOP
#define fglCullFace                    FGLCULLFACE
#define fglFrontFace                   FGLFRONTFACE
#define fglPointSize                   FGLPOINTSIZE
#define fglLineWidth                   FGLLINEWIDTH
#define fglLineStipple                 FGLLINESTIPPLE
#define fglPolygonMode                 FGLPOLYGONMODE
#define fglPolygonStipple              FGLPOLYGONSTIPPLE
#define fglGetPolygonStipple           FGLGETPOLYGONSTIPPLE
#define fglEdgeFlag                    FGLEDGEFLAG
#define fglEdgeFlagv                   FGLEDGEFLAGV
#define fglScissor                     FGLSCISSOR
#define fglClipPlane                   FGLCLIPPLANE
#define fglGetClipPlane                FGLGETCLIPPLANE
#define fglDrawBuffer                  FGLDRAWBUFFER
#define fglReadBuffer                  FGLREADBUFFER
#define fglEnable                      FGLENABLE
#define fglDisable                     FGLDISABLE
#define fglIsEnabled                   FGLISENABLED
#define fglGetBooleanv                 FGLGETBOOLEANV
#define fglGetDoublev                  FGLGETDOUBLEV
#define fglGetFloatv                   FGLGETFLOATV
#define fglGetIntegerv                 FGLGETINTEGERV
#define fglPushAttrib                  FGLPUSHATTRIB
#define fglPopAttrib                   FGLPOPATTRIB
#define fglRenderMode                  FGLRENDERMODE
#define fglGetError                    FGLGETERROR
#define fglGetString                   FGLGETSTRING
#define fglFinish                      FGLFINISH
#define fglFlush                       FGLFLUSH
#define fglHint                        FGLHINT
#define fglClearDepth                  FGLCLEARDEPTH
#define fglDepthFunc                   FGLDEPTHFUNC
#define fglDepthMask                   FGLDEPTHMASK
#define fglDepthRange                  FGLDEPTHRANGE
#define fglClearAccum                  FGLCLEARACCUM
#define fglAccum                       FGLACCUM
#define fglMatrixMode                  FGLMATRIXMODE
#define fglOrtho                       FGLORTHO
#define fglFrustum                     FGLFRUSTUM
#define fglViewport                    FGLVIEWPORT
#define fglPushMatrix                  FGLPUSHMATRIX
#define fglPopMatrix                   FGLPOPMATRIX
#define fglLoadIdentity                FGLLOADIDENTITY
#define fglLoadMatrixd                 FGLLOADMATRIXD
#define fglLoadMatrixf                 FGLLOADMATRIXF
#define fglMultMatrixd                 FGLMULTMATRIXD
#define fglMultMatrixf                 FGLMULTMATRIXF
#define fglRotated                     FGLROTATED
#define fglRotatef                     FGLROTATEF
#define fglScaled                      FGLSCALED
#define fglScalef                      FGLSCALEF
#define fglTranslated                  FGLTRANSLATED
#define fglTranslatef                  FGLTRANSLATEF
#define fglIsList                      FGLISLIST
#define fglDeleteLists                 FGLDELETELISTS
#define fglGenLists                    FGLGENLISTS
#define fglNewList                     FGLNEWLIST
#define fglEndList                     FGLENDLIST
#define fglCallList                    FGLCALLLIST
#define fglCallLists                   FGLCALLLISTS
#define fglListBase                    FGLLISTBASE
#define fglBegin                       FGLBEGIN
#define fglEnd                         FGLEND
#define fglVertex2d                    FGLVERTEX2D
#define fglVertex2f                    FGLVERTEX2F
#define fglVertex2i                    FGLVERTEX2I
#define fglVertex2s                    FGLVERTEX2S
#define fglVertex3d                    FGLVERTEX3D
#define fglVertex3f                    FGLVERTEX3F
#define fglVertex3i                    FGLVERTEX3I
#define fglVertex3s                    FGLVERTEX3S
#define fglVertex4d                    FGLVERTEX4D
#define fglVertex4f                    FGLVERTEX4F
#define fglVertex4i                    FGLVERTEX4I
#define fglVertex4s                    FGLVERTEX4S
#define fglVertex2dv                   FGLVERTEX2DV
#define fglVertex2fv                   FGLVERTEX2FV
#define fglVertex2iv                   FGLVERTEX2IV
#define fglVertex2sv                   FGLVERTEX2SV
#define fglVertex3dv                   FGLVERTEX3DV
#define fglVertex3fv                   FGLVERTEX3FV
#define fglVertex3iv                   FGLVERTEX3IV
#define fglVertex3sv                   FGLVERTEX3SV
#define fglVertex4dv                   FGLVERTEX4DV
#define fglVertex4fv                   FGLVERTEX4FV
#define fglVertex4iv                   FGLVERTEX4IV
#define fglVertex4sv                   FGLVERTEX4SV
#define fglNormal3b                    FGLNORMAL3B
#define fglNormal3d                    FGLNORMAL3D
#define fglNormal3f                    FGLNORMAL3F
#define fglNormal3i                    FGLNORMAL3I
#define fglNormal3s                    FGLNORMAL3S
#define fglNormal3bv                   FGLNORMAL3BV
#define fglNormal3dv                   FGLNORMAL3DV
#define fglNormal3fv                   FGLNORMAL3FV
#define fglNormal3iv                   FGLNORMAL3IV
#define fglNormal3sv                   FGLNORMAL3SV
#define fglIndexd                      FGLINDEXD
#define fglIndexf                      FGLINDEXF
#define fglIndexi                      FGLINDEXI
#define fglIndexs                      FGLINDEXS
#define fglIndexdv                     FGLINDEXDV
#define fglIndexfv                     FGLINDEXFV
#define fglIndexiv                     FGLINDEXIV
#define fglIndexsv                     FGLINDEXSV
#define fglColor3b                     FGLCOLOR3B
#define fglColor3d                     FGLCOLOR3D
#define fglColor3f                     FGLCOLOR3F
#define fglColor3i                     FGLCOLOR3I
#define fglColor3s                     FGLCOLOR3S
#define fglColor3ub                    FGLCOLOR3UB
#define fglColor3ui                    FGLCOLOR3UI
#define fglColor3us                    FGLCOLOR3US
#define fglColor4b                     FGLCOLOR4B
#define fglColor4d                     FGLCOLOR4D
#define fglColor4f                     FGLCOLOR4F
#define fglColor4i                     FGLCOLOR4I
#define fglColor4s                     FGLCOLOR4S
#define fglColor4ub                    FGLCOLOR4UB
#define fglColor4ui                    FGLCOLOR4UI
#define fglColor4us                    FGLCOLOR4US
#define fglColor3bv                    FGLCOLOR3BV
#define fglColor3dv                    FGLCOLOR3DV
#define fglColor3fv                    FGLCOLOR3FV
#define fglColor3iv                    FGLCOLOR3IV
#define fglColor3sv                    FGLCOLOR3SV
#define fglColor3ubv                   FGLCOLOR3UBV
#define fglColor3uiv                   FGLCOLOR3UIV
#define fglColor3usv                   FGLCOLOR3USV
#define fglColor4bv                    FGLCOLOR4BV
#define fglColor4dv                    FGLCOLOR4DV
#define fglColor4fv                    FGLCOLOR4FV
#define fglColor4iv                    FGLCOLOR4IV
#define fglColor4sv                    FGLCOLOR4SV
#define fglColor4ubv                   FGLCOLOR4UBV
#define fglColor4uiv                   FGLCOLOR4UIV
#define fglColor4usv                   FGLCOLOR4USV
#define fglTexCoord1d                  FGLTEXCOORD1D
#define fglTexCoord1f                  FGLTEXCOORD1F
#define fglTexCoord1i                  FGLTEXCOORD1I
#define fglTexCoord1s                  FGLTEXCOORD1S
#define fglTexCoord2d                  FGLTEXCOORD2D
#define fglTexCoord2f                  FGLTEXCOORD2F
#define fglTexCoord2i                  FGLTEXCOORD2I
#define fglTexCoord2s                  FGLTEXCOORD2S
#define fglTexCoord3d                  FGLTEXCOORD3D
#define fglTexCoord3f                  FGLTEXCOORD3F
#define fglTexCoord3i                  FGLTEXCOORD3I
#define fglTexCoord3s                  FGLTEXCOORD3S
#define fglTexCoord4d                  FGLTEXCOORD4D
#define fglTexCoord4f                  FGLTEXCOORD4F
#define fglTexCoord4i                  FGLTEXCOORD4I
#define fglTexCoord4s                  FGLTEXCOORD4S
#define fglTexCoord1dv                 FGLTEXCOORD1DV
#define fglTexCoord1fv                 FGLTEXCOORD1FV
#define fglTexCoord1iv                 FGLTEXCOORD1IV
#define fglTexCoord1sv                 FGLTEXCOORD1SV
#define fglTexCoord2dv                 FGLTEXCOORD2DV
#define fglTexCoord2fv                 FGLTEXCOORD2FV
#define fglTexCoord2iv                 FGLTEXCOORD2IV
#define fglTexCoord2sv                 FGLTEXCOORD2SV
#define fglTexCoord3dv                 FGLTEXCOORD3DV
#define fglTexCoord3fv                 FGLTEXCOORD3FV
#define fglTexCoord3iv                 FGLTEXCOORD3IV
#define fglTexCoord3sv                 FGLTEXCOORD3SV
#define fglTexCoord4dv                 FGLTEXCOORD4DV
#define fglTexCoord4fv                 FGLTEXCOORD4FV
#define fglTexCoord4iv                 FGLTEXCOORD4IV
#define fglTexCoord4sv                 FGLTEXCOORD4SV
#define fglRasterPos2d                 FGLRASTERPOS2D
#define fglRasterPos2f                 FGLRASTERPOS2F
#define fglRasterPos2i                 FGLRASTERPOS2I
#define fglRasterPos2s                 FGLRASTERPOS2S
#define fglRasterPos3d                 FGLRASTERPOS3D
#define fglRasterPos3f                 FGLRASTERPOS3F
#define fglRasterPos3i                 FGLRASTERPOS3I
#define fglRasterPos3s                 FGLRASTERPOS3S
#define fglRasterPos4d                 FGLRASTERPOS4D
#define fglRasterPos4f                 FGLRASTERPOS4F
#define fglRasterPos4i                 FGLRASTERPOS4I
#define fglRasterPos4s                 FGLRASTERPOS4S
#define fglRasterPos2dv                FGLRASTERPOS2DV
#define fglRasterPos2fv                FGLRASTERPOS2FV
#define fglRasterPos2iv                FGLRASTERPOS2IV
#define fglRasterPos2sv                FGLRASTERPOS2SV
#define fglRasterPos3dv                FGLRASTERPOS3DV
#define fglRasterPos3fv                FGLRASTERPOS3FV
#define fglRasterPos3iv                FGLRASTERPOS3IV
#define fglRasterPos3sv                FGLRASTERPOS3SV
#define fglRasterPos4dv                FGLRASTERPOS4DV
#define fglRasterPos4fv                FGLRASTERPOS4FV
#define fglRasterPos4iv                FGLRASTERPOS4IV
#define fglRasterPos4sv                FGLRASTERPOS4SV
#define fglRectd                       FGLRECTD
#define fglRectf                       FGLRECTF
#define fglRecti                       FGLRECTI
#define fglRects                       FGLRECTS
#define fglRectdv                      FGLRECTDV
#define fglRectfv                      FGLRECTFV
#define fglRectiv                      FGLRECTIV
#define fglRectsv                      FGLRECTSV
#define fglShadeModel                  FGLSHADEMODEL
#define fglLightf                      FGLLIGHTF
#define fglLighti                      FGLLIGHTI
#define fglLightfv                     FGLLIGHTFV
#define fglLightiv                     FGLLIGHTIV
#define fglGetLightfv                  FGLGETLIGHTFV
#define fglGetLightiv                  FGLGETLIGHTIV
#define fglLightModelf                 FGLLIGHTMODELF
#define fglLightModeli                 FGLLIGHTMODELI
#define fglLightModelfv                FGLLIGHTMODELFV
#define fglLightModeliv                FGLLIGHTMODELIV
#define fglMaterialf                   FGLMATERIALF
#define fglMateriali                   FGLMATERIALI
#define fglMaterialfv                  FGLMATERIALFV
#define fglMaterialiv                  FGLMATERIALIV
#define fglGetMaterialfv               FGLGETMATERIALFV
#define fglGetMaterialiv               FGLGETMATERIALIV
#define fglColorMaterial               FGLCOLORMATERIAL
#define fglPixelZoom                   FGLPIXELZOOM
#define fglPixelStoref                 FGLPIXELSTOREF
#define fglPixelStorei                 FGLPIXELSTOREI
#define fglPixelTransferf              FGLPIXELTRANSFERF
#define fglPixelTransferi              FGLPIXELTRANSFERI
#define fglPixelMapfv                  FGLPIXELMAPFV
#define fglPixelMapuiv                 FGLPIXELMAPUIV
#define fglPixelMapusv                 FGLPIXELMAPUSV
#define fglGetPixelMapfv               FGLGETPIXELMAPFV
#define fglGetPixelMapuiv              FGLGETPIXELMAPUIV
#define fglGetPixelMapusv              FGLGETPIXELMAPUSV
#define fglBitmap                      FGLBITMAP
#define fglReadPixels                  FGLREADPIXELS
#define fglDrawPixels                  FGLDRAWPIXELS
#define fglCopyPixels                  FGLCOPYPIXELS
#define fglStencilFunc                 FGLSTENCILFUNC
#define fglStencilMask                 FGLSTENCILMASK
#define fglStencilOp                   FGLSTENCILOP
#define fglClearStencil                FGLCLEARSTENCIL
#define fglTexGend                     FGLTEXGEND
#define fglTexGenf                     FGLTEXGENF
#define fglTexGeni                     FGLTEXGENI
#define fglTexGendv                    FGLTEXGENDV
#define fglTexGenfv                    FGLTEXGENFV
#define fglTexGeniv                    FGLTEXGENIV
#define fglGetTexGendv                 FGLGETTEXGENDV
#define fglGetTexGenfv                 FGLGETTEXGENFV
#define fglGetTexGeniv                 FGLGETTEXGENIV
#define fglTexEnvf                     FGLTEXENVF
#define fglTexEnvi                     FGLTEXENVI
#define fglTexEnvfv                    FGLTEXENVFV
#define fglTexEnviv                    FGLTEXENVIV
#define fglGetTexEnvfv                 FGLGETTEXENVFV
#define fglGetTexEnviv                 FGLGETTEXENVIV
#define fglTexParameterf               FGLTEXPARAMETERF
#define fglTexParameteri               FGLTEXPARAMETERI
#define fglTexParameterfv              FGLTEXPARAMETERFV
#define fglTexParameteriv              FGLTEXPARAMETERIV
#define fglGetTexParameterfv           FGLGETTEXPARAMETERFV
#define fglGetTexParameteriv           FGLGETTEXPARAMETERIV
#define fglGetTexLevelParameterfv      FGLGETTEXLEVELPARAMETERFV
#define fglGetTexLevelParameteriv      FGLGETTEXLEVELPARAMETERIV
#define fglTexImage1D                  FGLTEXIMAGE1D
#define fglTexImage2D                  FGLTEXIMAGE2D
#define fglGetTexImage                 FGLGETTEXIMAGE
#define fglMap1d                       FGLMAP1D
#define fglMap1f                       FGLMAP1F
#define fglMap2d                       FGLMAP2D
#define fglMap2f                       FGLMAP2F
#define fglGetMapdv                    FGLGETMAPDV
#define fglGetMapfv                    FGLGETMAPFV
#define fglGetMapiv                    FGLGETMAPIV
#define fglEvalCoord1d                 FGLEVALCOORD1D
#define fglEvalCoord1f                 FGLEVALCOORD1F
#define fglEvalCoord1dv                FGLEVALCOORD1DV
#define fglEvalCoord1fv                FGLEVALCOORD1FV
#define fglEvalCoord2d                 FGLEVALCOORD2D
#define fglEvalCoord2f                 FGLEVALCOORD2F
#define fglEvalCoord2dv                FGLEVALCOORD2DV
#define fglEvalCoord2fv                FGLEVALCOORD2FV
#define fglMapGrid1d                   FGLMAPGRID1D
#define fglMapGrid1f                   FGLMAPGRID1F
#define fglMapGrid2d                   FGLMAPGRID2D
#define fglMapGrid2f                   FGLMAPGRID2F
#define fglEvalPoint1                  FGLEVALPOINT1
#define fglEvalPoint2                  FGLEVALPOINT2
#define fglEvalMesh1                   FGLEVALMESH1
#define fglEvalMesh2                   FGLEVALMESH2
#define fglFogf                        FGLFOGF
#define fglFogi                        FGLFOGI
#define fglFogfv                       FGLFOGFV
#define fglFogiv                       FGLFOGIV
#define fglFeedbackBuffer              FGLFEEDBACKBUFFER
#define fglPassThrough                 FGLPASSTHROUGH
#define fglSelectBuffer                FGLSELECTBUFFER
#define fglInitNames                   FGLINITNAMES
#define fglLoadName                    FGLLOADNAME
#define fglPushName                    FGLPUSHNAME
#define fglPopName                     FGLPOPNAME
#define fglBlendEquationEXT            FGLBLENDEQUATIONEXT
#define fglBlendColorEXT               FGLBLENDCOLOREXT
/*#define fglPolygonOffsetEXT            FGLPOLYGONOFFSETEXT*/
#define fglWindowPos2iMESA             FGLWINDOWPOS2IMESA
#define fglWindowPos2sMESA             FGLWINDOWPOS2SMESA
#define fglWindowPos2fMESA             FGLWINDOWPOS2FMESA
#define fglWindowPos2dMESA             FGLWINDOWPOS2DMESA
#define fglWindowPos2ivMESA            FGLWINDOWPOS2IVMESA
#define fglWindowPos2svMESA            FGLWINDOWPOS2SVMESA
#define fglWindowPos2fvMESA            FGLWINDOWPOS2FVMESA
#define fglWindowPos2dvMESA            FGLWINDOWPOS2DVMESA
#define fglWindowPos3iMESA             FGLWINDOWPOS3IMESA
#define fglWindowPos3sMESA             FGLWINDOWPOS3SMESA
#define fglWindowPos3fMESA             FGLWINDOWPOS3FMESA
#define fglWindowPos3dMESA             FGLWINDOWPOS3DMESA
#define fglWindowPos3ivMESA            FGLWINDOWPOS3IVMESA
#define fglWindowPos3svMESA            FGLWINDOWPOS3SVMESA
#define fglWindowPos3fvMESA            FGLWINDOWPOS3FVMESA
#define fglWindowPos3dvMESA            FGLWINDOWPOS3DVMESA
#define fglWindowPos4iMESA             FGLWINDOWPOS4IMESA
#define fglWindowPos4sMESA             FGLWINDOWPOS4SMESA
#define fglWindowPos4fMESA             FGLWINDOWPOS4FMESA
#define fglWindowPos4dMESA             FGLWINDOWPOS4DMESA
#define fglWindowPos4ivMESA            FGLWINDOWPOS4IVMESA
#define fglWindowPos4svMESA            FGLWINDOWPOS4SVMESA
#define fglWindowPos4fvMESA            FGLWINDOWPOS4FVMESA
#define fglWindowPos4dvMESA            FGLWINDOWPOS4DVMESA
#endif

/* wrapper functions */

#ifndef MESA

void glBlendEquationEXT( GLenum mode ) { }
void glBlendColorEXT( GLclampf r, GLclampf g, GLclampf b, GLclampf alpha ) { }
/*void glPolygonOffsetEXT( GLfloat factor, GLfloat bias ) { }*/
void glWindowPos2iMESA( GLint x, GLint y ) { }
void glWindowPos2sMESA( GLshort x, GLshort y ) { }
void glWindowPos2fMESA( GLfloat x, GLfloat y ) { }
void glWindowPos2dMESA( GLdouble x, GLdouble y ) { }
void glWindowPos2ivMESA( const GLint* p ) { }
void glWindowPos2svMESA( const GLshort* p ) { }
void glWindowPos2fvMESA( const GLfloat* p ) { }
void glWindowPos2dvMESA( const GLdouble* p ) { }
void glWindowPos3iMESA( GLint x, GLint y, GLint z ) { }
void glWindowPos3sMESA( GLshort x, GLshort y, GLshort z ) { }
void glWindowPos3fMESA( GLfloat x, GLfloat y, GLfloat z ) { }
void glWindowPos3dMESA( GLdouble x, GLdouble y, GLdouble z ){ }
void glWindowPos3ivMESA( const GLint* p ) { }
void glWindowPos3svMESA( const GLshort* p ) { }
void glWindowPos3fvMESA( const GLfloat* p ) { }
void glWindowPos3dvMESA( const GLdouble* p ) { }
void glWindowPos4iMESA( GLint x, GLint y, GLint z, GLint w ) { }
void glWindowPos4sMESA( GLshort x, GLshort y, GLshort z, GLshort w ) { }
void glWindowPos4fMESA( GLfloat x, GLfloat y, GLfloat z, GLfloat w ) { }
void glWindowPos4dMESA( GLdouble x, GLdouble y, GLdouble z, GLdouble w ) { }
void glWindowPos4ivMESA( const GLint* p ) { }
void glWindowPos4svMESA( const GLshort* p ) { }
void glWindowPos4fvMESA( const GLfloat* p ) { }
void glWindowPos4dvMESA( const GLdouble* p ) { }

#endif /*ifndef MESA */

void fglClearIndex( f90glfloat c )
{
   glClearIndex( (GLfloat) *c );
}

void fglClearColor( f90glclampf red, f90glclampf green, f90glclampf blue,
    f90glclampf alpha )
{
   glClearColor( (GLclampf) *red, (GLclampf) *green, (GLclampf) *blue,
    (GLclampf) *alpha );
}

void fglClear( f90glbitfield mask )
{
   glClear( (GLbitfield) *mask );
}

void fglIndexMask( f90gluint mask )
{
   glIndexMask( (GLuint) *mask );
}

void fglColorMask( f90glboolean red, f90glboolean green, f90glboolean blue,
    f90glboolean alpha )
{
   glColorMask( (GLboolean) *red, (GLboolean) *green, (GLboolean) *blue,
    (GLboolean) *alpha );
}

void fglAlphaFunc( f90glenum func, f90glclampf ref )
{
   glAlphaFunc( (GLenum) *func, (GLclampf) *ref );
}

void fglBlendFunc( f90glenum sfactor, f90glenum dfactor )
{
   glBlendFunc( (GLenum) *sfactor, (GLenum) *dfactor );
}

void fglLogicOp( f90glenum opcode )
{
   glLogicOp( (GLenum) *opcode );
}

void fglCullFace( f90glenum mode )
{
   glCullFace( (GLenum) *mode );
}

void fglFrontFace( f90glenum mode )
{
   glFrontFace( (GLenum) *mode );
}

void fglPointSize( f90glfloat size )
{
   glPointSize( (GLfloat) *size );
}

void fglLineWidth( f90glfloat width )
{
   glLineWidth( (GLfloat) *width );
}

void fglLineStipple( f90glint factor, f90glushort pattern )
{
   glLineStipple( (GLint) *factor, (GLushort) *pattern );
}

void fglPolygonMode( f90glenum face, f90glenum mode )
{
   glPolygonMode( (GLenum) *face, (GLenum) *mode );
}

void fglPolygonStipple( f90glubyte mask )
{
   glPolygonStipple( (GLubyte *) mask );
}

void fglGetPolygonStipple( f90glubyte mask )
{
   glGetPolygonStipple( (GLubyte *) mask );
}

void fglEdgeFlag( f90glboolean flag )
{
   glEdgeFlag( (GLboolean) *flag );
}

void fglEdgeFlagv( f90glboolean flag )
{
   glEdgeFlagv( (GLboolean *) flag );
}

void fglScissor( f90glint x, f90glint y, f90glsizei width,
    f90glsizei height )
{
   glScissor( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height );
}

void fglClipPlane( f90glenum plane, f90gldouble equation )
{
   glClipPlane( (GLenum) *plane, (GLdouble *) equation );
}

void fglGetClipPlane( f90glenum plane, f90gldouble equation )
{
   glGetClipPlane( (GLenum) *plane, (GLdouble *) equation );
}

void fglDrawBuffer( f90glenum mode )
{
   glDrawBuffer( (GLenum) *mode );
}

void fglReadBuffer( f90glenum mode )
{
   glReadBuffer( (GLenum) *mode );
}

void fglEnable( f90glenum cap )
{
   glEnable( (GLenum) *cap );
}

void fglDisable( f90glenum cap )
{
   glDisable( (GLenum) *cap );
}

GLboolean fglIsEnabled( f90glenum cap )
{
   return (GLboolean) glIsEnabled( (GLenum) *cap );
}

void fglGetBooleanv( f90glenum pname, f90glboolean params )
{
   glGetBooleanv( (GLenum) *pname, (GLboolean *) params );
}

void fglGetDoublev( f90glenum pname, f90gldouble params )
{
   glGetDoublev( (GLenum) *pname, (GLdouble *) params );
}

void fglGetFloatv( f90glenum pname, f90glfloat params )
{
   glGetFloatv( (GLenum) *pname, (GLfloat *) params );
}

void fglGetIntegerv( f90glenum pname, f90glint params )
{
   glGetIntegerv( (GLenum) *pname, (GLint *) params );
}

void fglPushAttrib( f90glbitfield mask )
{
   glPushAttrib( (GLbitfield) *mask );
}

void fglPopAttrib( void )
{
   glPopAttrib();
}

GLint fglRenderMode( f90glenum mode )
{
   return (GLint) glRenderMode( (GLenum) *mode );
}

GLenum fglGetError( void )
{
   return (GLenum) glGetError();
}

/*
 * Implementing a C function which returns a characters string via a
 * Fortran invokation is tricky.  This solution works on IRIX according
   to Brian Paul.
 */
void fglGetString( char result[], int length, f90glenum name )
{
   int i;
   char *str;

   for (i=0;i<length;i++) {
      result[i] = ' ';
   }
   str = (char *) glGetString( (GLenum) *name );
   if (str) {
      int len = strlen(str);
      if (len>0) {
         strncpy( result, str, MIN2(len,length) );
      }  
   }   
}

void fglFinish( void )
{
   glFinish();
}

void fglFlush( void )
{
   glFlush();
}

void fglHint( f90glenum target, f90glenum mode )
{
   glHint( (GLenum) *target, (GLenum) *mode );
}

void fglClearDepth( f90glclampd depth )
{
   glClearDepth( (GLclampd) *depth );
}

void fglDepthFunc( f90glenum func )
{
   glDepthFunc( (GLenum) *func );
}

void fglDepthMask( f90glboolean flag )
{
   glDepthMask( (GLboolean) *flag );
}

void fglDepthRange( f90glclampd near_val, f90glclampd far_val )
{
   glDepthRange( (GLclampd) *near_val, (GLclampd) *far_val );
}

void fglClearAccum( f90glfloat red, f90glfloat green, f90glfloat blue,
    f90glfloat alpha )
{
   glClearAccum( (GLfloat) *red, (GLfloat) *green, (GLfloat) *blue,
    (GLfloat) *alpha );
}

void fglAccum( f90glenum op, f90glfloat value )
{
   glAccum( (GLenum) *op, (GLfloat) *value );
}

void fglMatrixMode( f90glenum mode )
{
   glMatrixMode( (GLenum) *mode );
}

void fglOrtho( f90gldouble left, f90gldouble right, f90gldouble bottom,
    f90gldouble top, f90gldouble near_val, f90gldouble far_val )
{
   glOrtho( (GLdouble) *left, (GLdouble) *right, (GLdouble) *bottom,
    (GLdouble) *top, (GLdouble) *near_val, (GLdouble) *far_val );
}

void fglFrustum( f90gldouble left, f90gldouble right, f90gldouble bottom,
    f90gldouble top, f90gldouble near_val, f90gldouble far_val )
{
   glFrustum( (GLdouble) *left, (GLdouble) *right, (GLdouble) *bottom,
    (GLdouble) *top, (GLdouble) *near_val, (GLdouble) *far_val );
}

void fglViewport( f90glint x, f90glint y, f90glsizei width,
    f90glsizei height )
{
   glViewport( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height );
}

void fglPushMatrix( void )
{
   glPushMatrix();
}

void fglPopMatrix( void )
{
   glPopMatrix();
}

void fglLoadIdentity( void )
{
   glLoadIdentity();
}

void fglLoadMatrixd( f90gldouble m )
{
   glLoadMatrixd( (GLdouble *) m );
}

void fglLoadMatrixf( f90glfloat m )
{
   glLoadMatrixf( (GLfloat *) m );
}

void fglMultMatrixd( f90gldouble m )
{
   glMultMatrixd( (GLdouble *) m );
}

void fglMultMatrixf( f90glfloat m )
{
   glMultMatrixf( (GLfloat *) m );
}

void fglRotated( f90gldouble angle, f90gldouble x, f90gldouble y,
    f90gldouble z )
{
   glRotated( (GLdouble) *angle, (GLdouble) *x, (GLdouble) *y,
    (GLdouble) *z );
}

void fglRotatef( f90glfloat angle, f90glfloat x, f90glfloat y, f90glfloat z )
{
   glRotatef( (GLfloat) *angle, (GLfloat) *x, (GLfloat) *y, (GLfloat) *z );
}

void fglScaled( f90gldouble x, f90gldouble y, f90gldouble z )
{
   glScaled( (GLdouble) *x, (GLdouble) *y, (GLdouble) *z );
}

void fglScalef( f90glfloat x, f90glfloat y, f90glfloat z )
{
   glScalef( (GLfloat) *x, (GLfloat) *y, (GLfloat) *z );
}

void fglTranslated( f90gldouble x, f90gldouble y, f90gldouble z )
{
   glTranslated( (GLdouble) *x, (GLdouble) *y, (GLdouble) *z );
}

void fglTranslatef( f90glfloat x, f90glfloat y, f90glfloat z )
{
   glTranslatef( (GLfloat) *x, (GLfloat) *y, (GLfloat) *z );
}

GLboolean fglIsList( f90gluint list )
{
   return (GLboolean) glIsList( (GLuint) *list );
}

void fglDeleteLists( f90gluint list, f90glsizei range )
{
   glDeleteLists( (GLuint) *list, (GLsizei) *range );
}

GLuint fglGenLists( f90glsizei range )
{
   return (GLuint) glGenLists( (GLsizei) *range );
}

void fglNewList( f90gluint list, f90glenum mode )
{
   glNewList( (GLuint) *list, (GLenum) *mode );
}

void fglEndList( void )
{
   glEndList();
}

void fglCallList( f90gluint list )
{
   glCallList( (GLuint) *list );
}

void fglCallLists( f90glsizei n, f90glenum type, f90glvoid lists )
{
   glCallLists( (GLsizei) *n, (GLenum) *type, (GLvoid *) lists );
}

void fglListBase( f90gluint base )
{
   glListBase( (GLuint) *base );
}

void fglBegin( f90glenum mode )
{
   glBegin( (GLenum) *mode );
}

void fglEnd( void )
{
   glEnd();
}

void fglVertex2d( f90gldouble x, f90gldouble y )
{
   glVertex2d( (GLdouble) *x, (GLdouble) *y );
}

void fglVertex2f( f90glfloat x, f90glfloat y )
{
   glVertex2f( (GLfloat) *x, (GLfloat) *y );
}

void fglVertex2i( f90glint x, f90glint y )
{
   glVertex2i( (GLint) *x, (GLint) *y );
}

void fglVertex2s( f90glshort x, f90glshort y )
{
   glVertex2s( (GLshort) *x, (GLshort) *y );
}

void fglVertex3d( f90gldouble x, f90gldouble y, f90gldouble z )
{
   glVertex3d( (GLdouble) *x, (GLdouble) *y, (GLdouble) *z );
}

void fglVertex3f( f90glfloat x, f90glfloat y, f90glfloat z )
{
   glVertex3f( (GLfloat) *x, (GLfloat) *y, (GLfloat) *z );
}

void fglVertex3i( f90glint x, f90glint y, f90glint z )
{
   glVertex3i( (GLint) *x, (GLint) *y, (GLint) *z );
}

void fglVertex3s( f90glshort x, f90glshort y, f90glshort z )
{
   glVertex3s( (GLshort) *x, (GLshort) *y, (GLshort) *z );
}

void fglVertex4d( f90gldouble x, f90gldouble y, f90gldouble z,
    f90gldouble w )
{
   glVertex4d( (GLdouble) *x, (GLdouble) *y, (GLdouble) *z, (GLdouble) *w );
}

void fglVertex4f( f90glfloat x, f90glfloat y, f90glfloat z, f90glfloat w )
{
   glVertex4f( (GLfloat) *x, (GLfloat) *y, (GLfloat) *z, (GLfloat) *w );
}

void fglVertex4i( f90glint x, f90glint y, f90glint z, f90glint w )
{
   glVertex4i( (GLint) *x, (GLint) *y, (GLint) *z, (GLint) *w );
}

void fglVertex4s( f90glshort x, f90glshort y, f90glshort z, f90glshort w )
{
   glVertex4s( (GLshort) *x, (GLshort) *y, (GLshort) *z, (GLshort) *w );
}

void fglVertex2dv( f90gldouble v )
{
   glVertex2dv( (GLdouble *) v );
}

void fglVertex2fv( f90glfloat v )
{
   glVertex2fv( (GLfloat *) v );
}

void fglVertex2iv( f90glint v )
{
   glVertex2iv( (GLint *) v );
}

void fglVertex2sv( f90glshort v )
{
   glVertex2sv( (GLshort *) v );
}

void fglVertex3dv( f90gldouble v )
{
   glVertex3dv( (GLdouble *) v );
}

void fglVertex3fv( f90glfloat v )
{
   glVertex3fv( (GLfloat *) v );
}

void fglVertex3iv( f90glint v )
{
   glVertex3iv( (GLint *) v );
}

void fglVertex3sv( f90glshort v )
{
   glVertex3sv( (GLshort *) v );
}

void fglVertex4dv( f90gldouble v )
{
   glVertex4dv( (GLdouble *) v );
}

void fglVertex4fv( f90glfloat v )
{
   glVertex4fv( (GLfloat *) v );
}

void fglVertex4iv( f90glint v )
{
   glVertex4iv( (GLint *) v );
}

void fglVertex4sv( f90glshort v )
{
   glVertex4sv( (GLshort *) v );
}

void fglNormal3b( f90glbyte nx, f90glbyte ny, f90glbyte nz )
{
   glNormal3b( (GLbyte) *nx, (GLbyte) *ny, (GLbyte) *nz );
}

void fglNormal3d( f90gldouble nx, f90gldouble ny, f90gldouble nz )
{
   glNormal3d( (GLdouble) *nx, (GLdouble) *ny, (GLdouble) *nz );
}

void fglNormal3f( f90glfloat nx, f90glfloat ny, f90glfloat nz )
{
   glNormal3f( (GLfloat) *nx, (GLfloat) *ny, (GLfloat) *nz );
}

void fglNormal3i( f90glint nx, f90glint ny, f90glint nz )
{
   glNormal3i( (GLint) *nx, (GLint) *ny, (GLint) *nz );
}

void fglNormal3s( f90glshort nx, f90glshort ny, f90glshort nz )
{
   glNormal3s( (GLshort) *nx, (GLshort) *ny, (GLshort) *nz );
}

void fglNormal3bv( f90glbyte v )
{
   glNormal3bv( (GLbyte *) v );
}

void fglNormal3dv( f90gldouble v )
{
   glNormal3dv( (GLdouble *) v );
}

void fglNormal3fv( f90glfloat v )
{
   glNormal3fv( (GLfloat *) v );
}

void fglNormal3iv( f90glint v )
{
   glNormal3iv( (GLint *) v );
}

void fglNormal3sv( f90glshort v )
{
   glNormal3sv( (GLshort *) v );
}

void fglIndexd( f90gldouble c )
{
   glIndexd( (GLdouble) *c );
}

void fglIndexf( f90glfloat c )
{
   glIndexf( (GLfloat) *c );
}

void fglIndexi( f90glint c )
{
   glIndexi( (GLint) *c );
}

void fglIndexs( f90glshort c )
{
   glIndexs( (GLshort) *c );
}

void fglIndexdv( f90gldouble c )
{
   glIndexdv( (GLdouble *) c );
}

void fglIndexfv( f90glfloat c )
{
   glIndexfv( (GLfloat *) c );
}

void fglIndexiv( f90glint c )
{
   glIndexiv( (GLint *) c );
}

void fglIndexsv( f90glshort c )
{
   glIndexsv( (GLshort *) c );
}

void fglColor3b( f90glbyte red, f90glbyte green, f90glbyte blue )
{
   glColor3b( (GLbyte) *red, (GLbyte) *green, (GLbyte) *blue );
}

void fglColor3d( f90gldouble red, f90gldouble green, f90gldouble blue )
{
   glColor3d( (GLdouble) *red, (GLdouble) *green, (GLdouble) *blue );
}

void fglColor3f( f90glfloat red, f90glfloat green, f90glfloat blue )
{
   glColor3f( (GLfloat) *red, (GLfloat) *green, (GLfloat) *blue );
}

void fglColor3i( f90glint red, f90glint green, f90glint blue )
{
   glColor3i( (GLint) *red, (GLint) *green, (GLint) *blue );
}

void fglColor3s( f90glshort red, f90glshort green, f90glshort blue )
{
   glColor3s( (GLshort) *red, (GLshort) *green, (GLshort) *blue );
}

void fglColor3ub( f90glubyte red, f90glubyte green, f90glubyte blue )
{
   glColor3ub( (GLubyte) *red, (GLubyte) *green, (GLubyte) *blue );
}

void fglColor3ui( f90gluint red, f90gluint green, f90gluint blue )
{
   glColor3ui( (GLuint) *red, (GLuint) *green, (GLuint) *blue );
}

void fglColor3us( f90glushort red, f90glushort green, f90glushort blue )
{
   glColor3us( (GLushort) *red, (GLushort) *green, (GLushort) *blue );
}

void fglColor4b( f90glbyte red, f90glbyte green, f90glbyte blue,
    f90glbyte alpha )
{
   glColor4b( (GLbyte) *red, (GLbyte) *green, (GLbyte) *blue,
    (GLbyte) *alpha );
}

void fglColor4d( f90gldouble red, f90gldouble green, f90gldouble blue,
    f90gldouble alpha )
{
   glColor4d( (GLdouble) *red, (GLdouble) *green, (GLdouble) *blue,
    (GLdouble) *alpha );
}

void fglColor4f( f90glfloat red, f90glfloat green, f90glfloat blue,
    f90glfloat alpha )
{
   glColor4f( (GLfloat) *red, (GLfloat) *green, (GLfloat) *blue,
    (GLfloat) *alpha );
}

void fglColor4i( f90glint red, f90glint green, f90glint blue,
    f90glint alpha )
{
   glColor4i( (GLint) *red, (GLint) *green, (GLint) *blue, (GLint) *alpha );
}

void fglColor4s( f90glshort red, f90glshort green, f90glshort blue,
    f90glshort alpha )
{
   glColor4s( (GLshort) *red, (GLshort) *green, (GLshort) *blue,
    (GLshort) *alpha );
}

void fglColor4ub( f90glubyte red, f90glubyte green, f90glubyte blue,
    f90glubyte alpha )
{
   glColor4ub( (GLubyte) *red, (GLubyte) *green, (GLubyte) *blue,
    (GLubyte) *alpha );
}

void fglColor4ui( f90gluint red, f90gluint green, f90gluint blue,
    f90gluint alpha )
{
   glColor4ui( (GLuint) *red, (GLuint) *green, (GLuint) *blue,
    (GLuint) *alpha );
}

void fglColor4us( f90glushort red, f90glushort green, f90glushort blue,
    f90glushort alpha )
{
   glColor4us( (GLushort) *red, (GLushort) *green, (GLushort) *blue,
    (GLushort) *alpha );
}

void fglColor3bv( f90glbyte v )
{
   glColor3bv( (GLbyte *) v );
}

void fglColor3dv( f90gldouble v )
{
   glColor3dv( (GLdouble *) v );
}

void fglColor3fv( f90glfloat v )
{
   glColor3fv( (GLfloat *) v );
}

void fglColor3iv( f90glint v )
{
   glColor3iv( (GLint *) v );
}

void fglColor3sv( f90glshort v )
{
   glColor3sv( (GLshort *) v );
}

void fglColor3ubv( f90glubyte v )
{
   glColor3ubv( (GLubyte *) v );
}

void fglColor3uiv( f90gluint v )
{
   glColor3uiv( (GLuint *) v );
}

void fglColor3usv( f90glushort v )
{
   glColor3usv( (GLushort *) v );
}

void fglColor4bv( f90glbyte v )
{
   glColor4bv( (GLbyte *) v );
}

void fglColor4dv( f90gldouble v )
{
   glColor4dv( (GLdouble *) v );
}

void fglColor4fv( f90glfloat v )
{
   glColor4fv( (GLfloat *) v );
}

void fglColor4iv( f90glint v )
{
   glColor4iv( (GLint *) v );
}

void fglColor4sv( f90glshort v )
{
   glColor4sv( (GLshort *) v );
}

void fglColor4ubv( f90glubyte v )
{
   glColor4ubv( (GLubyte *) v );
}

void fglColor4uiv( f90gluint v )
{
   glColor4uiv( (GLuint *) v );
}

void fglColor4usv( f90glushort v )
{
   glColor4usv( (GLushort *) v );
}

void fglTexCoord1d( f90gldouble s )
{
   glTexCoord1d( (GLdouble) *s );
}

void fglTexCoord1f( f90glfloat s )
{
   glTexCoord1f( (GLfloat) *s );
}

void fglTexCoord1i( f90glint s )
{
   glTexCoord1i( (GLint) *s );
}

void fglTexCoord1s( f90glshort s )
{
   glTexCoord1s( (GLshort) *s );
}

void fglTexCoord2d( f90gldouble s, f90gldouble t )
{
   glTexCoord2d( (GLdouble) *s, (GLdouble) *t );
}

void fglTexCoord2f( f90glfloat s, f90glfloat t )
{
   glTexCoord2f( (GLfloat) *s, (GLfloat) *t );
}

void fglTexCoord2i( f90glint s, f90glint t )
{
   glTexCoord2i( (GLint) *s, (GLint) *t );
}

void fglTexCoord2s( f90glshort s, f90glshort t )
{
   glTexCoord2s( (GLshort) *s, (GLshort) *t );
}

void fglTexCoord3d( f90gldouble s, f90gldouble t, f90gldouble r )
{
   glTexCoord3d( (GLdouble) *s, (GLdouble) *t, (GLdouble) *r );
}

void fglTexCoord3f( f90glfloat s, f90glfloat t, f90glfloat r )
{
   glTexCoord3f( (GLfloat) *s, (GLfloat) *t, (GLfloat) *r );
}

void fglTexCoord3i( f90glint s, f90glint t, f90glint r )
{
   glTexCoord3i( (GLint) *s, (GLint) *t, (GLint) *r );
}

void fglTexCoord3s( f90glshort s, f90glshort t, f90glshort r )
{
   glTexCoord3s( (GLshort) *s, (GLshort) *t, (GLshort) *r );
}

void fglTexCoord4d( f90gldouble s, f90gldouble t, f90gldouble r,
    f90gldouble q )
{
   glTexCoord4d( (GLdouble) *s, (GLdouble) *t, (GLdouble) *r,
    (GLdouble) *q );
}

void fglTexCoord4f( f90glfloat s, f90glfloat t, f90glfloat r, f90glfloat q )
{
   glTexCoord4f( (GLfloat) *s, (GLfloat) *t, (GLfloat) *r, (GLfloat) *q );
}

void fglTexCoord4i( f90glint s, f90glint t, f90glint r, f90glint q )
{
   glTexCoord4i( (GLint) *s, (GLint) *t, (GLint) *r, (GLint) *q );
}

void fglTexCoord4s( f90glshort s, f90glshort t, f90glshort r, f90glshort q )
{
   glTexCoord4s( (GLshort) *s, (GLshort) *t, (GLshort) *r, (GLshort) *q );
}

void fglTexCoord1dv( f90gldouble v )
{
   glTexCoord1dv( (GLdouble *) v );
}

void fglTexCoord1fv( f90glfloat v )
{
   glTexCoord1fv( (GLfloat *) v );
}

void fglTexCoord1iv( f90glint v )
{
   glTexCoord1iv( (GLint *) v );
}

void fglTexCoord1sv( f90glshort v )
{
   glTexCoord1sv( (GLshort *) v );
}

void fglTexCoord2dv( f90gldouble v )
{
   glTexCoord2dv( (GLdouble *) v );
}

void fglTexCoord2fv( f90glfloat v )
{
   glTexCoord2fv( (GLfloat *) v );
}

void fglTexCoord2iv( f90glint v )
{
   glTexCoord2iv( (GLint *) v );
}

void fglTexCoord2sv( f90glshort v )
{
   glTexCoord2sv( (GLshort *) v );
}

void fglTexCoord3dv( f90gldouble v )
{
   glTexCoord3dv( (GLdouble *) v );
}

void fglTexCoord3fv( f90glfloat v )
{
   glTexCoord3fv( (GLfloat *) v );
}

void fglTexCoord3iv( f90glint v )
{
   glTexCoord3iv( (GLint *) v );
}

void fglTexCoord3sv( f90glshort v )
{
   glTexCoord3sv( (GLshort *) v );
}

void fglTexCoord4dv( f90gldouble v )
{
   glTexCoord4dv( (GLdouble *) v );
}

void fglTexCoord4fv( f90glfloat v )
{
   glTexCoord4fv( (GLfloat *) v );
}

void fglTexCoord4iv( f90glint v )
{
   glTexCoord4iv( (GLint *) v );
}

void fglTexCoord4sv( f90glshort v )
{
   glTexCoord4sv( (GLshort *) v );
}

void fglRasterPos2d( f90gldouble x, f90gldouble y )
{
   glRasterPos2d( (GLdouble) *x, (GLdouble) *y );
}

void fglRasterPos2f( f90glfloat x, f90glfloat y )
{
   glRasterPos2f( (GLfloat) *x, (GLfloat) *y );
}

void fglRasterPos2i( f90glint x, f90glint y )
{
   glRasterPos2i( (GLint) *x, (GLint) *y );
}

void fglRasterPos2s( f90glshort x, f90glshort y )
{
   glRasterPos2s( (GLshort) *x, (GLshort) *y );
}

void fglRasterPos3d( f90gldouble x, f90gldouble y, f90gldouble z )
{
   glRasterPos3d( (GLdouble) *x, (GLdouble) *y, (GLdouble) *z );
}

void fglRasterPos3f( f90glfloat x, f90glfloat y, f90glfloat z )
{
   glRasterPos3f( (GLfloat) *x, (GLfloat) *y, (GLfloat) *z );
}

void fglRasterPos3i( f90glint x, f90glint y, f90glint z )
{
   glRasterPos3i( (GLint) *x, (GLint) *y, (GLint) *z );
}

void fglRasterPos3s( f90glshort x, f90glshort y, f90glshort z )
{
   glRasterPos3s( (GLshort) *x, (GLshort) *y, (GLshort) *z );
}

void fglRasterPos4d( f90gldouble x, f90gldouble y, f90gldouble z,
    f90gldouble w )
{
   glRasterPos4d( (GLdouble) *x, (GLdouble) *y, (GLdouble) *z,
    (GLdouble) *w );
}

void fglRasterPos4f( f90glfloat x, f90glfloat y, f90glfloat z, f90glfloat w )
{
   glRasterPos4f( (GLfloat) *x, (GLfloat) *y, (GLfloat) *z, (GLfloat) *w );
}

void fglRasterPos4i( f90glint x, f90glint y, f90glint z, f90glint w )
{
   glRasterPos4i( (GLint) *x, (GLint) *y, (GLint) *z, (GLint) *w );
}

void fglRasterPos4s( f90glshort x, f90glshort y, f90glshort z, f90glshort w )
{
   glRasterPos4s( (GLshort) *x, (GLshort) *y, (GLshort) *z, (GLshort) *w );
}

void fglRasterPos2dv( f90gldouble v )
{
   glRasterPos2dv( (GLdouble *) v );
}

void fglRasterPos2fv( f90glfloat v )
{
   glRasterPos2fv( (GLfloat *) v );
}

void fglRasterPos2iv( f90glint v )
{
   glRasterPos2iv( (GLint *) v );
}

void fglRasterPos2sv( f90glshort v )
{
   glRasterPos2sv( (GLshort *) v );
}

void fglRasterPos3dv( f90gldouble v )
{
   glRasterPos3dv( (GLdouble *) v );
}

void fglRasterPos3fv( f90glfloat v )
{
   glRasterPos3fv( (GLfloat *) v );
}

void fglRasterPos3iv( f90glint v )
{
   glRasterPos3iv( (GLint *) v );
}

void fglRasterPos3sv( f90glshort v )
{
   glRasterPos3sv( (GLshort *) v );
}

void fglRasterPos4dv( f90gldouble v )
{
   glRasterPos4dv( (GLdouble *) v );
}

void fglRasterPos4fv( f90glfloat v )
{
   glRasterPos4fv( (GLfloat *) v );
}

void fglRasterPos4iv( f90glint v )
{
   glRasterPos4iv( (GLint *) v );
}

void fglRasterPos4sv( f90glshort v )
{
   glRasterPos4sv( (GLshort *) v );
}

void fglRectd( f90gldouble x1, f90gldouble y1, f90gldouble x2,
    f90gldouble y2 )
{
   glRectd( (GLdouble) *x1, (GLdouble) *y1, (GLdouble) *x2, (GLdouble) *y2 );
}

void fglRectf( f90glfloat x1, f90glfloat y1, f90glfloat x2, f90glfloat y2 )
{
   glRectf( (GLfloat) *x1, (GLfloat) *y1, (GLfloat) *x2, (GLfloat) *y2 );
}

void fglRecti( f90glint x1, f90glint y1, f90glint x2, f90glint y2 )
{
   glRecti( (GLint) *x1, (GLint) *y1, (GLint) *x2, (GLint) *y2 );
}

void fglRects( f90glshort x1, f90glshort y1, f90glshort x2, f90glshort y2 )
{
   glRects( (GLshort) *x1, (GLshort) *y1, (GLshort) *x2, (GLshort) *y2 );
}

void fglRectdv( f90gldouble v1, f90gldouble v2 )
{
   glRectdv( (GLdouble *) v1, (GLdouble *) v2 );
}

void fglRectfv( f90glfloat v1, f90glfloat v2 )
{
   glRectfv( (GLfloat *) v1, (GLfloat *) v2 );
}

void fglRectiv( f90glint v1, f90glint v2 )
{
   glRectiv( (GLint *) v1, (GLint *) v2 );
}

void fglRectsv( f90glshort v1, f90glshort v2 )
{
   glRectsv( (GLshort *) v1, (GLshort *) v2 );
}

void fglShadeModel( f90glenum mode )
{
   glShadeModel( (GLenum) *mode );
}

void fglLightf( f90glenum light, f90glenum pname, f90glfloat param )
{
   glLightf( (GLenum) *light, (GLenum) *pname, (GLfloat) *param );
}

void fglLighti( f90glenum light, f90glenum pname, f90glint param )
{
   glLighti( (GLenum) *light, (GLenum) *pname, (GLint) *param );
}

void fglLightfv( f90glenum light, f90glenum pname, f90glfloat params )
{
   glLightfv( (GLenum) *light, (GLenum) *pname, (GLfloat *) params );
}

void fglLightiv( f90glenum light, f90glenum pname, f90glint params )
{
   glLightiv( (GLenum) *light, (GLenum) *pname, (GLint *) params );
}

void fglGetLightfv( f90glenum light, f90glenum pname, f90glfloat params )
{
   glGetLightfv( (GLenum) *light, (GLenum) *pname, (GLfloat *) params );
}

void fglGetLightiv( f90glenum light, f90glenum pname, f90glint params )
{
   glGetLightiv( (GLenum) *light, (GLenum) *pname, (GLint *) params );
}

void fglLightModelf( f90glenum pname, f90glfloat param )
{
   glLightModelf( (GLenum) *pname, (GLfloat) *param );
}

void fglLightModeli( f90glenum pname, f90glint param )
{
   glLightModeli( (GLenum) *pname, (GLint) *param );
}

void fglLightModelfv( f90glenum pname, f90glfloat params )
{
   glLightModelfv( (GLenum) *pname, (GLfloat *) params );
}

void fglLightModeliv( f90glenum pname, f90glint params )
{
   glLightModeliv( (GLenum) *pname, (GLint *) params );
}

void fglMaterialf( f90glenum face, f90glenum pname, f90glfloat param )
{
   glMaterialf( (GLenum) *face, (GLenum) *pname, (GLfloat) *param );
}

void fglMateriali( f90glenum face, f90glenum pname, f90glint param )
{
   glMateriali( (GLenum) *face, (GLenum) *pname, (GLint) *param );
}

void fglMaterialfv( f90glenum face, f90glenum pname, f90glfloat params )
{
   glMaterialfv( (GLenum) *face, (GLenum) *pname, (GLfloat *) params );
}

void fglMaterialiv( f90glenum face, f90glenum pname, f90glint params )
{
   glMaterialiv( (GLenum) *face, (GLenum) *pname, (GLint *) params );
}

void fglGetMaterialfv( f90glenum face, f90glenum pname, f90glfloat params )
{
   glGetMaterialfv( (GLenum) *face, (GLenum) *pname, (GLfloat *) params );
}

void fglGetMaterialiv( f90glenum face, f90glenum pname, f90glint params )
{
   glGetMaterialiv( (GLenum) *face, (GLenum) *pname, (GLint *) params );
}

void fglColorMaterial( f90glenum face, f90glenum mode )
{
   glColorMaterial( (GLenum) *face, (GLenum) *mode );
}

void fglPixelZoom( f90glfloat xfactor, f90glfloat yfactor )
{
   glPixelZoom( (GLfloat) *xfactor, (GLfloat) *yfactor );
}

void fglPixelStoref( f90glenum pname, f90glfloat param )
{
   glPixelStoref( (GLenum) *pname, (GLfloat) *param );
}

void fglPixelStorei( f90glenum pname, f90glint param )
{
   glPixelStorei( (GLenum) *pname, (GLint) *param );
}

void fglPixelTransferf( f90glenum pname, f90glfloat param )
{
   glPixelTransferf( (GLenum) *pname, (GLfloat) *param );
}

void fglPixelTransferi( f90glenum pname, f90glint param )
{
   glPixelTransferi( (GLenum) *pname, (GLint) *param );
}

void fglPixelMapfv( f90glenum map, f90glint mapsize, f90glfloat values )
{
   glPixelMapfv( (GLenum) *map, (GLint) *mapsize, (GLfloat *) values );
}

void fglPixelMapuiv( f90glenum map, f90glint mapsize, f90gluint values )
{
   glPixelMapuiv( (GLenum) *map, (GLint) *mapsize, (GLuint *) values );
}

void fglPixelMapusv( f90glenum map, f90glint mapsize, f90glushort values )
{
   glPixelMapusv( (GLenum) *map, (GLint) *mapsize, (GLushort *) values );
}

void fglGetPixelMapfv( f90glenum map, f90glfloat values )
{
   glGetPixelMapfv( (GLenum) *map, (GLfloat *) values );
}

void fglGetPixelMapuiv( f90glenum map, f90gluint values )
{
   glGetPixelMapuiv( (GLenum) *map, (GLuint *) values );
}

void fglGetPixelMapusv( f90glenum map, f90glushort values )
{
   glGetPixelMapusv( (GLenum) *map, (GLushort *) values );
}

void fglBitmap( f90glsizei width, f90glsizei height, f90glfloat xorig,
    f90glfloat yorig, f90glfloat xmove, f90glfloat ymove, f90glubyte bitmap )
{
   glBitmap( (GLsizei) *width, (GLsizei) *height, (GLfloat) *xorig,
    (GLfloat) *yorig, (GLfloat) *xmove, (GLfloat) *ymove,
    (GLubyte *) bitmap );
}

void fglReadPixels( f90glint x, f90glint y, f90glsizei width,
    f90glsizei height, f90glenum format, f90glenum type, f90glvoid pixels )
{
   glReadPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *format, (GLenum) *type, (GLvoid *) pixels );
}

void fglDrawPixels( f90glsizei width, f90glsizei height, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glDrawPixels( (GLsizei) *width, (GLsizei) *height, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void fglCopyPixels( f90glint x, f90glint y, f90glsizei width,
    f90glsizei height, f90glenum type )
{
   glCopyPixels( (GLint) *x, (GLint) *y, (GLsizei) *width, (GLsizei) *height,
    (GLenum) *type );
}

void fglStencilFunc( f90glenum func, f90glint ref, f90gluint mask )
{
   glStencilFunc( (GLenum) *func, (GLint) *ref, (GLuint) *mask );
}

void fglStencilMask( f90gluint mask )
{
   glStencilMask( (GLuint) *mask );
}

void fglStencilOp( f90glenum fail, f90glenum zfail, f90glenum zpass )
{
   glStencilOp( (GLenum) *fail, (GLenum) *zfail, (GLenum) *zpass );
}

void fglClearStencil( f90glint s )
{
   glClearStencil( (GLint) *s );
}

void fglTexGend( f90glenum coord, f90glenum pname, f90gldouble param )
{
   glTexGend( (GLenum) *coord, (GLenum) *pname, (GLdouble) *param );
}

void fglTexGenf( f90glenum coord, f90glenum pname, f90glfloat param )
{
   glTexGenf( (GLenum) *coord, (GLenum) *pname, (GLfloat) *param );
}

void fglTexGeni( f90glenum coord, f90glenum pname, f90glint param )
{
   glTexGeni( (GLenum) *coord, (GLenum) *pname, (GLint) *param );
}

void fglTexGendv( f90glenum coord, f90glenum pname, f90gldouble params )
{
   glTexGendv( (GLenum) *coord, (GLenum) *pname, (GLdouble *) params );
}

void fglTexGenfv( f90glenum coord, f90glenum pname, f90glfloat params )
{
   glTexGenfv( (GLenum) *coord, (GLenum) *pname, (GLfloat *) params );
}

void fglTexGeniv( f90glenum coord, f90glenum pname, f90glint params )
{
   glTexGeniv( (GLenum) *coord, (GLenum) *pname, (GLint *) params );
}

void fglGetTexGendv( f90glenum coord, f90glenum pname, f90gldouble params )
{
   glGetTexGendv( (GLenum) *coord, (GLenum) *pname, (GLdouble *) params );
}

void fglGetTexGenfv( f90glenum coord, f90glenum pname, f90glfloat params )
{
   glGetTexGenfv( (GLenum) *coord, (GLenum) *pname, (GLfloat *) params );
}

void fglGetTexGeniv( f90glenum coord, f90glenum pname, f90glint params )
{
   glGetTexGeniv( (GLenum) *coord, (GLenum) *pname, (GLint *) params );
}

void fglTexEnvf( f90glenum target, f90glenum pname, f90glfloat param )
{
   glTexEnvf( (GLenum) *target, (GLenum) *pname, (GLfloat) *param );
}

void fglTexEnvi( f90glenum target, f90glenum pname, f90glint param )
{
   glTexEnvi( (GLenum) *target, (GLenum) *pname, (GLint) *param );
}

void fglTexEnvfv( f90glenum target, f90glenum pname, f90glfloat params )
{
   glTexEnvfv( (GLenum) *target, (GLenum) *pname, (GLfloat *) params );
}

void fglTexEnviv( f90glenum target, f90glenum pname, f90glint params )
{
   glTexEnviv( (GLenum) *target, (GLenum) *pname, (GLint *) params );
}

void fglGetTexEnvfv( f90glenum target, f90glenum pname, f90glfloat params )
{
   glGetTexEnvfv( (GLenum) *target, (GLenum) *pname, (GLfloat *) params );
}

void fglGetTexEnviv( f90glenum target, f90glenum pname, f90glint params )
{
   glGetTexEnviv( (GLenum) *target, (GLenum) *pname, (GLint *) params );
}

void fglTexParameterf( f90glenum target, f90glenum pname, f90glfloat param )
{
   glTexParameterf( (GLenum) *target, (GLenum) *pname, (GLfloat) *param );
}

void fglTexParameteri( f90glenum target, f90glenum pname, f90glint param )
{
   glTexParameteri( (GLenum) *target, (GLenum) *pname, (GLint) *param );
}

void fglTexParameterfv( f90glenum target, f90glenum pname,
    f90glfloat params )
{
   glTexParameterfv( (GLenum) *target, (GLenum) *pname, (GLfloat *) params );
}

void fglTexParameteriv( f90glenum target, f90glenum pname, f90glint params )
{
   glTexParameteriv( (GLenum) *target, (GLenum) *pname, (GLint *) params );
}

void fglGetTexParameterfv( f90glenum target, f90glenum pname,
    f90glfloat params )
{
   glGetTexParameterfv( (GLenum) *target, (GLenum) *pname,
    (GLfloat *) params );
}

void fglGetTexParameteriv( f90glenum target, f90glenum pname,
    f90glint params )
{
   glGetTexParameteriv( (GLenum) *target, (GLenum) *pname,
    (GLint *) params );
}

void fglGetTexLevelParameterfv( f90glenum target, f90glint level,
    f90glenum pname, f90glfloat params )
{
   glGetTexLevelParameterfv( (GLenum) *target, (GLint) *level,
    (GLenum) *pname, (GLfloat *) params );
}

void fglGetTexLevelParameteriv( f90glenum target, f90glint level,
    f90glenum pname, f90glint params )
{
   glGetTexLevelParameteriv( (GLenum) *target, (GLint) *level,
    (GLenum) *pname, (GLint *) params );
}

void fglTexImage1D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glint border, f90glenum format, f90glenum type,
    f90glvoid pixels )
{
   glTexImage1D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLint) *border, (GLenum) *format, (GLenum) *type,
    (GLvoid *) pixels );
}

void fglTexImage2D( f90glenum target, f90glint level, f90glint components,
    f90glsizei width, f90glsizei height, f90glint border, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glTexImage2D( (GLenum) *target, (GLint) *level, (GLint) *components,
    (GLsizei) *width, (GLsizei) *height, (GLint) *border, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void fglGetTexImage( f90glenum target, f90glint level, f90glenum format,
    f90glenum type, f90glvoid pixels )
{
   glGetTexImage( (GLenum) *target, (GLint) *level, (GLenum) *format,
    (GLenum) *type, (GLvoid *) pixels );
}

void fglMap1d( f90glenum target, f90gldouble u1, f90gldouble u2,
    f90glint stride, f90glint order, f90gldouble points )
{
   glMap1d( (GLenum) *target, (GLdouble) *u1, (GLdouble) *u2, (GLint) *stride,
    (GLint) *order, (GLdouble *) points );
}

void fglMap1f( f90glenum target, f90glfloat u1, f90glfloat u2,
    f90glint stride, f90glint order, f90glfloat points )
{
   glMap1f( (GLenum) *target, (GLfloat) *u1, (GLfloat) *u2, (GLint) *stride,
    (GLint) *order, (GLfloat *) points );
}

void fglMap2d( f90glenum target, f90gldouble u1, f90gldouble u2,
    f90glint ustride, f90glint uorder, f90gldouble v1, f90gldouble v2,
    f90glint vstride, f90glint vorder, f90gldouble points )
{
   glMap2d( (GLenum) *target, (GLdouble) *u1, (GLdouble) *u2,
    (GLint) *ustride, (GLint) *uorder, (GLdouble) *v1, (GLdouble) *v2,
    (GLint) *vstride, (GLint) *vorder, (GLdouble *) points );
}

void fglMap2f( f90glenum target, f90glfloat u1, f90glfloat u2,
    f90glint ustride, f90glint uorder, f90glfloat v1, f90glfloat v2,
    f90glint vstride, f90glint vorder, f90glfloat points )
{
   glMap2f( (GLenum) *target, (GLfloat) *u1, (GLfloat) *u2, (GLint) *ustride,
    (GLint) *uorder, (GLfloat) *v1, (GLfloat) *v2, (GLint) *vstride,
    (GLint) *vorder, (GLfloat *) points );
}

void fglGetMapdv( f90glenum target, f90glenum query, f90gldouble v )
{
   glGetMapdv( (GLenum) *target, (GLenum) *query, (GLdouble *) v );
}

void fglGetMapfv( f90glenum target, f90glenum query, f90glfloat v )
{
   glGetMapfv( (GLenum) *target, (GLenum) *query, (GLfloat *) v );
}

void fglGetMapiv( f90glenum target, f90glenum query, f90glint v )
{
   glGetMapiv( (GLenum) *target, (GLenum) *query, (GLint *) v );
}

void fglEvalCoord1d( f90gldouble u )
{
   glEvalCoord1d( (GLdouble) *u );
}

void fglEvalCoord1f( f90glfloat u )
{
   glEvalCoord1f( (GLfloat) *u );
}

void fglEvalCoord1dv( f90gldouble u )
{
   glEvalCoord1dv( (GLdouble *) u );
}

void fglEvalCoord1fv( f90glfloat u )
{
   glEvalCoord1fv( (GLfloat *) u );
}

void fglEvalCoord2d( f90gldouble u, f90gldouble v )
{
   glEvalCoord2d( (GLdouble) *u, (GLdouble) *v );
}

void fglEvalCoord2f( f90glfloat u, f90glfloat v )
{
   glEvalCoord2f( (GLfloat) *u, (GLfloat) *v );
}

void fglEvalCoord2dv( f90gldouble u )
{
   glEvalCoord2dv( (GLdouble *) u );
}

void fglEvalCoord2fv( f90glfloat u )
{
   glEvalCoord2fv( (GLfloat *) u );
}

void fglMapGrid1d( f90glint un, f90gldouble u1, f90gldouble u2 )
{
   glMapGrid1d( (GLint) *un, (GLdouble) *u1, (GLdouble) *u2 );
}

void fglMapGrid1f( f90glint un, f90glfloat u1, f90glfloat u2 )
{
   glMapGrid1f( (GLint) *un, (GLfloat) *u1, (GLfloat) *u2 );
}

void fglMapGrid2d( f90glint un, f90gldouble u1, f90gldouble u2, f90glint vn,
    f90gldouble v1, f90gldouble v2 )
{
   glMapGrid2d( (GLint) *un, (GLdouble) *u1, (GLdouble) *u2, (GLint) *vn,
    (GLdouble) *v1, (GLdouble) *v2 );
}

void fglMapGrid2f( f90glint un, f90glfloat u1, f90glfloat u2, f90glint vn,
    f90glfloat v1, f90glfloat v2 )
{
   glMapGrid2f( (GLint) *un, (GLfloat) *u1, (GLfloat) *u2, (GLint) *vn,
    (GLfloat) *v1, (GLfloat) *v2 );
}

void fglEvalPoint1( f90glint i )
{
   glEvalPoint1( (GLint) *i );
}

void fglEvalPoint2( f90glint i, f90glint j )
{
   glEvalPoint2( (GLint) *i, (GLint) *j );
}

void fglEvalMesh1( f90glenum mode, f90glint i1, f90glint i2 )
{
   glEvalMesh1( (GLenum) *mode, (GLint) *i1, (GLint) *i2 );
}

void fglEvalMesh2( f90glenum mode, f90glint i1, f90glint i2, f90glint j1,
    f90glint j2 )
{
   glEvalMesh2( (GLenum) *mode, (GLint) *i1, (GLint) *i2, (GLint) *j1,
    (GLint) *j2 );
}

void fglFogf( f90glenum pname, f90glfloat param )
{
   glFogf( (GLenum) *pname, (GLfloat) *param );
}

void fglFogi( f90glenum pname, f90glint param )
{
   glFogi( (GLenum) *pname, (GLint) *param );
}

void fglFogfv( f90glenum pname, f90glfloat params )
{
   glFogfv( (GLenum) *pname, (GLfloat *) params );
}

void fglFogiv( f90glenum pname, f90glint params )
{
   glFogiv( (GLenum) *pname, (GLint *) params );
}

void fglFeedbackBuffer( f90glsizei size, f90glenum type, f90glfloat buffer )
{
   glFeedbackBuffer( (GLsizei) *size, (GLenum) *type, (GLfloat *) buffer );
}

void fglPassThrough( f90glfloat token )
{
   glPassThrough( (GLfloat) *token );
}

void fglSelectBuffer( f90glsizei size, f90gluint buffer )
{
   glSelectBuffer( (GLsizei) *size, (GLuint *) buffer );
}

void fglInitNames( void )
{
   glInitNames();
}

void fglLoadName( f90gluint name )
{
   glLoadName( (GLuint) *name );
}

void fglPushName( f90gluint name )
{
   glPushName( (GLuint) *name );
}

void fglPopName( void )
{
   glPopName();
}

void fglBlendEquationEXT( f90glenum mode )
{
   glBlendEquationEXT( (GLenum) *mode );
}

void fglBlendColorEXT( f90glclampf red, f90glclampf green, f90glclampf blue,
    f90glclampf alpha )
{
   glBlendColorEXT( (GLclampf) *red, (GLclampf) *green, (GLclampf) *blue,
    (GLclampf) *alpha );
}

/*
void fglPolygonOffsetEXT( f90glfloat factor, f90glfloat bias )
{
   glPolygonOffsetEXT( (GLfloat) *factor, (GLfloat) *bias );
}
*/

void fglWindowPos2iMESA( f90glint x, f90glint y )
{
   glWindowPos2iMESA( (GLint) *x, (GLint) *y );
}
 
void fglWindowPos2sMESA( f90glshort x, f90glshort y )
{
   glWindowPos2sMESA( (GLshort) *x, (GLshort) *y );
}

void fglWindowPos2fMESA( f90glfloat x, f90glfloat y )
{
   glWindowPos2fMESA( (GLfloat) *x, (GLfloat) *y );
}

void fglWindowPos2dMESA( f90gldouble x, f90gldouble y )
{
   glWindowPos2dMESA( (GLdouble) *x, (GLdouble) *y );
}

void fglWindowPos2ivMESA( f90glint p )
{
   glWindowPos2ivMESA( (GLint *) p );
}

void fglWindowPos2svMESA( f90glshort p )
{
   glWindowPos2svMESA( (GLshort *) p );
}

void fglWindowPos2fvMESA( f90glfloat p )
{
   glWindowPos2fvMESA( (GLfloat *) p );
}

void fglWindowPos2dvMESA( f90gldouble p )
{
   glWindowPos2dvMESA( (GLdouble *) p );
}

void fglWindowPos3iMESA( f90glint x, f90glint y, f90glint z )
{
   glWindowPos3iMESA( (GLint) *x, (GLint) *y, (GLint) *z );
}

void fglWindowPos3sMESA( f90glshort x, f90glshort y, f90glshort z )
{
   glWindowPos3sMESA( (GLshort) *x, (GLshort) *y, (GLshort) *z );
}

void fglWindowPos3fMESA( f90glfloat x, f90glfloat y, f90glfloat z )
{
   glWindowPos3fMESA( (GLfloat) *x, (GLfloat) *y, (GLfloat) *z );
}

void fglWindowPos3dMESA( f90gldouble x, f90gldouble y, f90gldouble z ){
   glWindowPos3dMESA( (GLdouble) *x, (GLdouble) *y, (GLdouble) *z );
}

void fglWindowPos3ivMESA( f90glint p )
{
   glWindowPos3ivMESA( (GLint *) p );
}

void fglWindowPos3svMESA( f90glshort p )
{
   glWindowPos3svMESA( (GLshort *) p );
}

void fglWindowPos3fvMESA( f90glfloat p )
{
   glWindowPos3fvMESA( (GLfloat *) p );
}

void fglWindowPos3dvMESA( f90gldouble p )
{
   glWindowPos3dvMESA( (GLdouble *) p );
}

void fglWindowPos4iMESA( f90glint x, f90glint y, f90glint z, f90glint
w )
{
   glWindowPos4iMESA( (GLint) *x, (GLint) *y, (GLint) *z, (GLint) *w );
}

void fglWindowPos4sMESA( f90glshort x, f90glshort y, f90glshort z,
    f90glshort w )
{
   glWindowPos4sMESA( (GLshort) *x, (GLshort) *y, (GLshort) *z,
    (GLshort) *w );
}

void fglWindowPos4fMESA( f90glfloat x, f90glfloat y, f90glfloat z,
    f90glfloat w )
{
   glWindowPos4fMESA( (GLfloat) *x, (GLfloat) *y, (GLfloat) *z,
    (GLfloat) *w );
}

void fglWindowPos4dMESA( f90gldouble x, f90gldouble y, f90gldouble z,
    f90gldouble w )
{
   glWindowPos4dMESA( (GLdouble) *x, (GLdouble) *y, (GLdouble) *z,
    (GLdouble) *w );
}

void fglWindowPos4ivMESA( f90glint p )
{
   glWindowPos4ivMESA( (GLint *) p );
}

void fglWindowPos4svMESA( f90glshort p )
{
   glWindowPos4svMESA( (GLshort *) p );
}

void fglWindowPos4fvMESA( f90glfloat p )
{
   glWindowPos4fvMESA( (GLfloat *) p );
}

void fglWindowPos4dvMESA( f90gldouble p )
{
   glWindowPos4dvMESA( (GLdouble *) p );
}

#else /*ifdef FBIND*/



/* If FBIND is not defined, Fortran bindings aren't made.  Need this
 * dummy function for some picky compilers.
 */
static void dummy()
{
   return;
}

 
 
#endif /*ifdef FBIND*/
