/*-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for Mesa software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------*/

#ifdef FBIND


#include <string.h>
#include <GL/gl.h>
#include <GL/glu.h>
#define MIN2( A, B )   ( (A)<(B) ? (A) : (B) )

/* equalence of types

 OpenGL          description              C     extended fortan 77

GLboolean   8-bit unsigned integer  unsigned char  logical*1
GLbyte      8-bit integer           signed char    integer*1
GLubyte     8-bit unsigned integer  unsigned char  integer*1
GLshort    16-bit integer           short          integer*2
GLushort   16-bit unsigned integer  unsigned short integer*2
GLint      32-bit integer           long           integer*4
GLuint     32-bit unsigned integer  unsigned long  integer*4
GLenum     32-bit unsigned integer  unsigned long  integer*4
GLbitfield 32-bit unsigned integer  unsigned long  integer*4
GLsizei    32-bit integer           long           integer*4
GLfloat    32-bit floating point    float          real*4
GLclampf   32-bit floating point    float          real*4
GLdouble   64-bit floating point    double         real*8
GLclampd   64-bit floating point    double         real*8
GLvoid     generic pointer GLvoid*  void           any array


   f90gl            fortran 90

f90glboolean    logical(kind=k) where k gives a 1 byte logical, if possible
f90glbyte       selected_int_kind(2)
f90glubyte      selected_int_kind(2)
f90glshort      selected_int_kind(4)
f90glushort     selected_int_kind(4)
f90glint        selected_int_kind(9)
f90gluint       selected_int_kind(9)
f90glenum       selected_int_kind(9)
f90glbitfield   selected_int_kind(9)
f90glsizei      selected_int_kind(9)
f90glfloat      selected_real_kind(6)
f90glclampf     selected_real_kind(6)
f90gldouble     selected_real_kind(15)
f90glclampd     selected_real_kind(15)
f90glvoid       any array

*/

/*
 * Mapping of Fortran types to C types:
 */

#define f90glboolean  unsigned char *
#define f90glbyte     signed char *
#define f90glubyte    unsigned char *
#define f90glshort    short *
#define f90glushort   unsigned short *
#define f90glint      long *
#define f90gluint     unsigned long *
#define f90glenum     unsigned long *
#define f90glbitfield unsigned long *
#define f90glsizei    long *
#define f90glfloat    float *
#define f90glclampf   float *
#define f90gldouble   double *
#define f90glclampd   double *
#define f90glvoid     long *

#define f90gluquadricobj      long **
#define f90glunurbsobj        long **
#define f90glutriangulatorobj long **

/* procedure name mangling */

#if FBIND==1
#define fgluLookAt                     fglulookat
#define fgluOrtho2D                    fgluortho2d
#define fgluPerspective                fgluperspective
#define fgluPickMatrix                 fglupickmatrix
#define fgluProject                    fgluproject
#define fgluUnProject                  fgluunproject
#define fgluErrorString                fgluerrorstring
#define fgluScaleImage                 fgluscaleimage
#define fgluBuild1DMipmaps             fglubuild1dmipmaps
#define fgluBuild2DMipmaps             fglubuild2dmipmaps
#define fgluNewQuadric                 fglunewquadric
#define fgluDeleteQuadric              fgludeletequadric
#define fgluQuadricDrawStyle           fgluquadricdrawstyle
#define fgluQuadricOrientation         fgluquadricorientation
#define fgluQuadricNormals             fgluquadricnormals
#define fgluQuadricTexture             fgluquadrictexture
#define fgluQuadricCallback            fgluquadriccallback
#define fgluCylinder                   fglucylinder
#define fgluSphere                     fglusphere
#define fgluDisk                       fgludisk
#define fgluPartialDisk                fglupartialdisk
#define fgluNewNurbsRenderer           fglunewnurbsrenderer
#define fgluDeleteNurbsRenderer        fgludeletenurbsrenderer
#define fgluLoadSamplingMatrices       fgluloadsamplingmatrices
#define fgluNurbsProperty              fglunurbsproperty
#define fgluGetNurbsProperty           fglugetnurbsproperty
#define fgluBeginCurve                 fglubegincurve
#define fgluEndCurve                   fgluendcurve
#define fgluNurbsCurve                 fglunurbscurve
#define fgluBeginSurface               fglubeginsurface
#define fgluEndSurface                 fgluendsurface
#define fgluNurbsSurface               fglunurbssurface
#define fgluBeginTrim                  fglubegintrim
#define fgluEndTrim                    fgluendtrim
#define fgluPwlCurve                   fglupwlcurve
#define fgluNurbsCallback              fglunurbscallback
#define fgluNewTess                    fglunewtess
#define fgluTessCallback               fglutesscallback
#define fgluDeleteTess                 fgludeletetess
#define fgluBeginPolygon               fglubeginpolygon
#define fgluEndPolygon                 fgluendpolygon
#define fgluNextContour                fglunextcontour
#define fgluTessVertex                 fglutessvertex
#define fgluGetString                  fglugetstring
#elif FBIND==2
#define fgluLookAt                     fglulookat_
#define fgluOrtho2D                    fgluortho2d_
#define fgluPerspective                fgluperspective_
#define fgluPickMatrix                 fglupickmatrix_
#define fgluProject                    fgluproject_
#define fgluUnProject                  fgluunproject_
#define fgluErrorString                fgluerrorstring_
#define fgluScaleImage                 fgluscaleimage_
#define fgluBuild1DMipmaps             fglubuild1dmipmaps_
#define fgluBuild2DMipmaps             fglubuild2dmipmaps_
#define fgluNewQuadric                 fglunewquadric_
#define fgluDeleteQuadric              fgludeletequadric_
#define fgluQuadricDrawStyle           fgluquadricdrawstyle_
#define fgluQuadricOrientation         fgluquadricorientation_
#define fgluQuadricNormals             fgluquadricnormals_
#define fgluQuadricTexture             fgluquadrictexture_
#define fgluQuadricCallback            fgluquadriccallback_
#define fgluCylinder                   fglucylinder_
#define fgluSphere                     fglusphere_
#define fgluDisk                       fgludisk_
#define fgluPartialDisk                fglupartialdisk_
#define fgluNewNurbsRenderer           fglunewnurbsrenderer_
#define fgluDeleteNurbsRenderer        fgludeletenurbsrenderer_
#define fgluLoadSamplingMatrices       fgluloadsamplingmatrices_
#define fgluNurbsProperty              fglunurbsproperty_
#define fgluGetNurbsProperty           fglugetnurbsproperty_
#define fgluBeginCurve                 fglubegincurve_
#define fgluEndCurve                   fgluendcurve_
#define fgluNurbsCurve                 fglunurbscurve_
#define fgluBeginSurface               fglubeginsurface_
#define fgluEndSurface                 fgluendsurface_
#define fgluNurbsSurface               fglunurbssurface_
#define fgluBeginTrim                  fglubegintrim_
#define fgluEndTrim                    fgluendtrim_
#define fgluPwlCurve                   fglupwlcurve_
#define fgluNurbsCallback              fglunurbscallback_
#define fgluNewTess                    fglunewtess_
#define fgluTessCallback               fglutesscallback_
#define fgluDeleteTess                 fgludeletetess_
#define fgluBeginPolygon               fglubeginpolygon_
#define fgluEndPolygon                 fgluendpolygon_
#define fgluNextContour                fglunextcontour_
#define fgluTessVertex                 fglutessvertex_
#define fgluGetString                  fglugetstring_
#elif FBIND==3
#define fgluLookAt                     FGLULOOKAT
#define fgluOrtho2D                    FGLUORTHO2D
#define fgluPerspective                FGLUPERSPECTIVE
#define fgluPickMatrix                 FGLUPICKMATRIX
#define fgluProject                    FGLUPROJECT
#define fgluUnProject                  FGLUUNPROJECT
#define fgluErrorString                FGLUERRORSTRING
#define fgluScaleImage                 FGLUSCALEIMAGE
#define fgluBuild1DMipmaps             FGLUBUILD1DMIPMAPS
#define fgluBuild2DMipmaps             FGLUBUILD2DMIPMAPS
#define fgluNewQuadric                 FGLUNEWQUADRIC
#define fgluDeleteQuadric              FGLUDELETEQUADRIC
#define fgluQuadricDrawStyle           FGLUQUADRICDRAWSTYLE
#define fgluQuadricOrientation         FGLUQUADRICORIENTATION
#define fgluQuadricNormals             FGLUQUADRICNORMALS
#define fgluQuadricTexture             FGLUQUADRICTEXTURE
#define fgluQuadricCallback            FGLUQUADRICCALLBACK
#define fgluCylinder                   FGLUCYLINDER
#define fgluSphere                     FGLUSPHERE
#define fgluDisk                       FGLUDISK
#define fgluPartialDisk                FGLUPARTIALDISK
#define fgluNewNurbsRenderer           FGLUNEWNURBSRENDERER
#define fgluDeleteNurbsRenderer        FGLUDELETENURBSRENDERER
#define fgluLoadSamplingMatrices       FGLULOADSAMPLINGMATRICES
#define fgluNurbsProperty              FGLUNURBSPROPERTY
#define fgluGetNurbsProperty           FGLUGETNURBSPROPERTY
#define fgluBeginCurve                 FGLUBEGINCURVE
#define fgluEndCurve                   FGLUENDCURVE
#define fgluNurbsCurve                 FGLUNURBSCURVE
#define fgluBeginSurface               FGLUBEGINSURFACE
#define fgluEndSurface                 FGLUENDSURFACE
#define fgluNurbsSurface               FGLUNURBSSURFACE
#define fgluBeginTrim                  FGLUBEGINTRIM
#define fgluEndTrim                    FGLUENDTRIM
#define fgluPwlCurve                   FGLUPWLCURVE
#define fgluNurbsCallback              FGLUNURBSCALLBACK
#define fgluNewTess                    FGLUNEWTESS
#define fgluTessCallback               FGLUTESSCALLBACK
#define fgluDeleteTess                 FGLUDELETETESS
#define fgluBeginPolygon               FGLUBEGINPOLYGON
#define fgluEndPolygon                 FGLUENDPOLYGON
#define fgluNextContour                FGLUNEXTCONTOUR
#define fgluTessVertex                 FGLUTESSVERTEX
#define fgluGetString                  FGLUGETSTRING
#endif

#ifndef MESA

const GLubyte* gluGetString( GLenum name ) {return NULL;}

#endif

/* wrapper functions */

void fgluLookAt( f90gldouble eyex, f90gldouble eyey, f90gldouble eyez,
    f90gldouble centerx, f90gldouble centery, f90gldouble centerz,
    f90gldouble upx, f90gldouble upy, f90gldouble upz )
{
   gluLookAt( (GLdouble) *eyex, (GLdouble) *eyey, (GLdouble) *eyez,
    (GLdouble) *centerx, (GLdouble) *centery, (GLdouble) *centerz,
    (GLdouble) *upx, (GLdouble) *upy, (GLdouble) *upz );
}

void fgluOrtho2D( f90gldouble left, f90gldouble right, f90gldouble bottom,
    f90gldouble top )
{
   gluOrtho2D( (GLdouble) *left, (GLdouble) *right, (GLdouble) *bottom,
    (GLdouble) *top );
}

void fgluPerspective( f90gldouble fovy, f90gldouble aspect, f90gldouble zNear,
    f90gldouble zFar )
{
   gluPerspective( (GLdouble) *fovy, (GLdouble) *aspect, (GLdouble) *zNear,
    (GLdouble) *zFar );
}

void fgluPickMatrix( f90gldouble x, f90gldouble y, f90gldouble width,
    f90gldouble height, f90glint viewport )
{
   gluPickMatrix( (GLdouble) *x, (GLdouble) *y, (GLdouble) *width,
    (GLdouble) *height, (GLint *) viewport );
}

GLint fgluProject( f90gldouble objx, f90gldouble objy, f90gldouble objz,
    f90gldouble modelMatrix, f90gldouble projMatrix, f90glint viewport,
    f90gldouble winx, f90gldouble winy, f90gldouble winz )
{
   return (GLint) gluProject( (GLdouble) *objx, (GLdouble) *objy,
    (GLdouble) *objz, (GLdouble *) modelMatrix, (GLdouble *) projMatrix,
    (GLint *) viewport, (GLdouble *) winx, (GLdouble *) winy,
    (GLdouble *) winz );
}

GLint fgluUnProject( f90gldouble winx, f90gldouble winy, f90gldouble winz,
    f90gldouble modelMatrix, f90gldouble projMatrix, f90glint viewport,
    f90gldouble objx, f90gldouble objy, f90gldouble objz )
{
   return (GLint) gluUnProject( (GLdouble) *winx, (GLdouble) *winy,
    (GLdouble) *winz, (GLdouble *) modelMatrix, (GLdouble *) projMatrix,
    (GLint *) viewport, (GLdouble *) objx, (GLdouble *) objy,
    (GLdouble *) objz );
}

/*
 * Implementing a C function which returns a characters string via a
 * Fortran invokation is tricky.  This solution works on IRIX according
   to Brian Paul.
 */
void fgluErrorString( char result[], int length, f90glenum errorCode )
{
   int i;
   char *str;

   for (i=0;i<length;i++) {
      result[i] = ' ';
   }
   str = (char *) gluErrorString( (GLenum) *errorCode );
   if (str) {
      int len = strlen(str);
      if (len>0) {
         strncpy( result, str, MIN2(len,length) );
      }  
   }
}

GLint fgluScaleImage( f90glenum format, f90glint widthin, f90glint heightin,
    f90glenum typein, f90glvoid datain, f90glint widthout,
    f90glint heightout, f90glenum typeout, f90glvoid dataout )
{
   return (GLint) gluScaleImage( (GLenum) *format, (GLint) *widthin,
    (GLint) *heightin, (GLenum) *typein, (GLvoid *) datain,
    (GLint) *widthout, (GLint) *heightout, (GLenum) *typeout,
    (GLvoid *) dataout );
}

GLint fgluBuild1DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glenum format, f90glenum type, f90glvoid data )
{
   return (GLint) gluBuild1DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLenum) *format, (GLenum) *type, (GLvoid *) data );
}

GLint fgluBuild2DMipmaps( f90glenum target, f90glint components,
    f90glint width, f90glint height, f90glenum format, f90glenum type,
    f90glvoid data )
{
   return (GLint) gluBuild2DMipmaps( (GLenum) *target, (GLint) *components,
    (GLint) *width, (GLint) *height, (GLenum) *format, (GLenum) *type,
    (GLvoid *) data );
}

GLUquadricObj * fgluNewQuadric( void )
{
   return (GLUquadricObj *) gluNewQuadric();
}

void fgluDeleteQuadric( f90gluquadricobj state )
{
   gluDeleteQuadric( (GLUquadricObj *) *state );
}

void fgluQuadricDrawStyle( f90gluquadricobj quadObject, f90glenum drawStyle )
{
   gluQuadricDrawStyle( (GLUquadricObj *) *quadObject, (GLenum) *drawStyle );
}

void fgluQuadricOrientation( f90gluquadricobj quadObject,
    f90glenum orientation )
{
   gluQuadricOrientation( (GLUquadricObj *) *quadObject,
    (GLenum) *orientation );
}

void fgluQuadricNormals( f90gluquadricobj quadObject, f90glenum normals )
{
   gluQuadricNormals( (GLUquadricObj *) *quadObject, (GLenum) *normals );
}

void fgluQuadricTexture( f90gluquadricobj quadObject,
    f90glboolean textureCoords )
{
   gluQuadricTexture( (GLUquadricObj *) *quadObject,
    (GLboolean) *textureCoords );
}

void fgluQuadricCallback( f90gluquadricobj qobj, f90glenum which,
    void (*fn)() )
{
   gluQuadricCallback( (GLUquadricObj *) *qobj, (GLenum) *which, fn );
}

void fgluCylinder( f90gluquadricobj qobj, f90gldouble baseRadius,
    f90gldouble topRadius, f90gldouble height, f90glint slices,
    f90glint stacks )
{
   gluCylinder( (GLUquadricObj *) *qobj, (GLdouble) *baseRadius,
    (GLdouble) *topRadius, (GLdouble) *height, (GLint) *slices,
    (GLint) *stacks );
}

void fgluSphere( f90gluquadricobj qobj, f90gldouble radius, f90glint slices,
    f90glint stacks )
{
   gluSphere( (GLUquadricObj *) *qobj, (GLdouble) *radius, (GLint) *slices,
    (GLint) *stacks );
}

void fgluDisk( f90gluquadricobj qobj, f90gldouble innerRadius,
    f90gldouble outerRadius, f90glint slices, f90glint loops )
{
   gluDisk( (GLUquadricObj *) *qobj, (GLdouble) *innerRadius,
    (GLdouble) *outerRadius, (GLint) *slices, (GLint) *loops );
}

void fgluPartialDisk( f90gluquadricobj qobj, f90gldouble innerRadius,
    f90gldouble outerRadius, f90glint slices, f90glint loops,
    f90gldouble startAngle, f90gldouble sweepAngle )
{
   gluPartialDisk( (GLUquadricObj *) *qobj, (GLdouble) *innerRadius,
    (GLdouble) *outerRadius, (GLint) *slices, (GLint) *loops,
    (GLdouble) *startAngle, (GLdouble) *sweepAngle );
}

GLUnurbsObj * fgluNewNurbsRenderer( void )
{
   return (GLUnurbsObj *) gluNewNurbsRenderer();
}

void fgluDeleteNurbsRenderer( f90glunurbsobj nobj )
{
   gluDeleteNurbsRenderer( (GLUnurbsObj *) *nobj );
}

void fgluLoadSamplingMatrices( f90glunurbsobj nobj, f90glfloat modelMatrix,
    f90glfloat projMatrix, f90glint viewport )
{
   gluLoadSamplingMatrices( (GLUnurbsObj *) *nobj, (GLfloat *) modelMatrix,
    (GLfloat *) projMatrix, (GLint *) viewport );
}

void fgluNurbsProperty( f90glunurbsobj nobj, f90glenum property,
    f90glfloat value )
{
   gluNurbsProperty( (GLUnurbsObj *) *nobj, (GLenum) *property,
    (GLfloat) *value );
}

void fgluGetNurbsProperty( f90glunurbsobj nobj, f90glenum property,
    f90glfloat value )
{
   gluGetNurbsProperty( (GLUnurbsObj *) *nobj, (GLenum) *property,
    (GLfloat *) value );
}

void fgluBeginCurve( f90glunurbsobj nobj )
{
   gluBeginCurve( (GLUnurbsObj *) *nobj );
}

void fgluEndCurve( f90glunurbsobj nobj )
{
   gluEndCurve( (GLUnurbsObj *) *nobj );
}

void fgluNurbsCurve( f90glunurbsobj nobj, f90glint nknots, f90glfloat knot,
    f90glint stride, f90glfloat ctlarray, f90glint order, f90glenum type )
{
   gluNurbsCurve( (GLUnurbsObj *) *nobj, (GLint) *nknots, (GLfloat *) knot,
    (GLint) *stride, (GLfloat *) ctlarray, (GLint) *order, (GLenum) *type );
}

void fgluBeginSurface( f90glunurbsobj nobj )
{
   gluBeginSurface( (GLUnurbsObj *) *nobj );
}

void fgluEndSurface( f90glunurbsobj nobj )
{
   gluEndSurface( (GLUnurbsObj *) *nobj );
}

void fgluNurbsSurface( f90glunurbsobj nobj, f90glint sknot_count,
    f90glfloat sknot, f90glint tknot_count, f90glfloat tknot,
    f90glint s_stride, f90glint t_stride, f90glfloat ctlarray, f90glint sorder,
    f90glint torder, f90glenum type )
{
   gluNurbsSurface( (GLUnurbsObj *) *nobj, (GLint) *sknot_count,
    (GLfloat *) sknot, (GLint) *tknot_count, (GLfloat *) tknot,
    (GLint) *s_stride, (GLint) *t_stride, (GLfloat *) ctlarray,
    (GLint) *sorder, (GLint) *torder, (GLenum) *type );
}

void fgluBeginTrim( f90glunurbsobj nobj )
{
   gluBeginTrim( (GLUnurbsObj *) *nobj );
}

void fgluEndTrim( f90glunurbsobj nobj )
{
   gluEndTrim( (GLUnurbsObj *) *nobj );
}

void fgluPwlCurve( f90glunurbsobj nobj, f90glint count, f90glfloat array,
    f90glint stride, f90glenum type )
{
   gluPwlCurve( (GLUnurbsObj *) *nobj, (GLint) *count, (GLfloat *) array,
    (GLint) *stride, (GLenum) *type );
}

void fgluNurbsCallback( f90glunurbsobj nobj, f90glenum which, void (*fn)() )
{
   gluNurbsCallback( (GLUnurbsObj *) *nobj, (GLenum) *which, fn );
}

GLUtriangulatorObj* fgluNewTess( void )
{
   return (GLUtriangulatorObj*) gluNewTess();
}

void fgluTessCallback( f90glutriangulatorobj tobj, f90glenum which,
    void (*fn)() )
{
   gluTessCallback( (GLUtriangulatorObj *) *tobj, (GLenum) *which, fn );
}

void fgluDeleteTess( f90glutriangulatorobj tobj )
{
   gluDeleteTess( (GLUtriangulatorObj *) *tobj );
}

void fgluBeginPolygon( f90glutriangulatorobj tobj )
{
   gluBeginPolygon( (GLUtriangulatorObj *) *tobj );
}

void fgluEndPolygon( f90glutriangulatorobj tobj )
{
   gluEndPolygon( (GLUtriangulatorObj *) *tobj );
}

void fgluNextContour( f90glutriangulatorobj tobj, f90glenum type )
{
   gluNextContour( (GLUtriangulatorObj *) *tobj, (GLenum) *type );
}

void fgluTessVertex( f90glutriangulatorobj tobj, f90gldouble v, f90glvoid data )
{
   gluTessVertex( (GLUtriangulatorObj *) *tobj, (GLdouble *) v,
    (GLvoid *) data );
}

/*
 * Implementing a C function which returns a characters string via a
 * Fortran invokation is tricky.  This solution works on IRIX according
   to Brian Paul.
 */
void fgluGetString( char result[], int length, f90glenum name ){
   int i;
   char *str;
 
   for (i=0;i<length;i++) {
      result[i] = ' ';
   }
   str = (char *) gluGetString( (GLenum) *name );
   if (str) {
      int len = strlen(str);
      if (len>0) {
         strncpy( result, str, MIN2(len,length) );
      }
   }
}


#else /*ifdef FBIND*/



/* If FBIND is not defined, Fortran bindings aren't made.  Need this
 * dummy function for some picky compilers.
 */
static void dummy()
{
   return;
}

 
 
#endif /*ifdef FBIND*/
