/*-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for Mesa software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------*/

#ifdef FBIND


#include <string.h>
#include <GL/gl.h>
#include <gltk.h>
#define MIN2( A, B )   ( (A)<(B) ? (A) : (B) )

/* equalence of types

 OpenGL          description              C     extended fortan 77

GLboolean   8-bit unsigned integer  unsigned char  logical*1
GLbyte      8-bit integer           signed char    integer*1
GLubyte     8-bit unsigned integer  unsigned char  integer*1
GLshort    16-bit integer           short          integer*2
GLushort   16-bit unsigned integer  unsigned short integer*2
GLint      32-bit integer           long           integer*4
GLuint     32-bit unsigned integer  unsigned long  integer*4
GLenum     32-bit unsigned integer  unsigned long  integer*4
GLbitfield 32-bit unsigned integer  unsigned long  integer*4
GLsizei    32-bit integer           long           integer*4
GLfloat    32-bit floating point    float          real*4
GLclampf   32-bit floating point    float          real*4
GLdouble   64-bit floating point    double         real*8
GLclampd   64-bit floating point    double         real*8
GLvoid     generic pointer GLvoid*  void           any array


   f90gl            fortran 90

f90glboolean    logical(kind=k) where k gives a 1 byte logical, if possible
f90glbyte       selected_int_kind(2)
f90glubyte      selected_int_kind(2)
f90glshort      selected_int_kind(4)
f90glushort     selected_int_kind(4)
f90glint        selected_int_kind(9)
f90gluint       selected_int_kind(9)
f90glenum       selected_int_kind(9)
f90glbitfield   selected_int_kind(9)
f90glsizei      selected_int_kind(9)
f90glfloat      selected_real_kind(6)
f90glclampf     selected_real_kind(6)
f90gldouble     selected_real_kind(15)
f90glclampd     selected_real_kind(15)
f90glvoid       any array

*/

/*
 * Mapping of Fortran types to C types:
 */

#define f90glboolean  unsigned char *
#define f90glbyte     signed char *
#define f90glubyte    unsigned char *
#define f90glshort    short *
#define f90glushort   unsigned short *
#define f90glint      long *
#define f90gluint     unsigned long *
#define f90glenum     unsigned long *
#define f90glbitfield unsigned long *
#define f90glsizei    long *
#define f90glfloat    float *
#define f90glclampf   float *
#define f90gldouble   double *
#define f90glclampd   double *
#define f90glvoid     long *
#define f90glcint     int *
#define f90glcfloat   float *

#define end_of_string '\0'
/* procedure name mangling */

#if FBIND==1
#define ftkInitDisplayMode              ftkinitdisplaymode
#define ftkInitPosition                 ftkinitposition
#define ftkInitWindow                   ftkinitwindow
#define ftkCloseWindow                  ftkclosewindow
#define ftkQuit                         ftkquit
#define ftkSetWindowLevel               ftksetwindowlevel
#define ftkSwapBuffers                  ftkswapbuffers
#define ftkExec                         ftkexec
#define ftkGetColorMapSize              ftkgetcolormapsize
#define ftkGetMouseLoc                  ftkgetmouseloc
#define ftkGetSystem                    ftkgetsystem
#define ftkSetOneColor                  ftksetonecolor
#define ftkSetFogRamp                   ftksetfogramp
#define ftkSetGreyRamp                  ftksetgreyramp
#define ftkSetRGBMap                    ftksetrgbmap
#define ftkSetOverlayMap                ftksetoverlaymap
#define ftkNewCursor                    ftknewcursor
#define ftkSetCursor                    ftksetcursor
#define ftkRGBImageLoad                 ftkrgbimageload
#define ftkCreateStrokeFont             ftkcreatestrokefont
#define ftkCreateOutlineFont            ftkcreateoutlinefont
#define ftkCreateFilledFont             ftkcreatefilledfont
#define ftkCreateBitmapFont             ftkcreatebitmapfont
#define ftkDrawStr                      ftkdrawstr
#define ftkWireSphere                   ftkwiresphere
#define ftkSolidSphere                  ftksolidsphere
#define ftkWireCube                     ftkwirecube
#define ftkSolidCube                    ftksolidcube
#define ftkWireBox                      ftkwirebox
#define ftkSolidBox                     ftksolidbox
#define ftkWireTorus                    ftkwiretorus
#define ftkSolidTorus                   ftksolidtorus
#define ftkWireCylinder                 ftkwirecylinder
#define ftkSolidCylinder                ftksolidcylinder
#define ftkWireCone                     ftkwirecone
#define ftkSolidCone                    ftksolidcone
#elif FBIND==2
#define ftkInitDisplayMode              ftkinitdisplaymode_
#define ftkInitPosition                 ftkinitposition_
#define ftkInitWindow                   ftkinitwindow_
#define ftkCloseWindow                  ftkclosewindow_
#define ftkQuit                         ftkquit_
#define ftkSetWindowLevel               ftksetwindowlevel_
#define ftkSwapBuffers                  ftkswapbuffers_
#define ftkExec                         ftkexec_
#define ftkGetColorMapSize              ftkgetcolormapsize_
#define ftkGetMouseLoc                  ftkgetmouseloc_
#define ftkGetSystem                    ftkgetsystem_
#define ftkSetOneColor                  ftksetonecolor_
#define ftkSetFogRamp                   ftksetfogramp_
#define ftkSetGreyRamp                  ftksetgreyramp_
#define ftkSetRGBMap                    ftksetrgbmap_
#define ftkSetOverlayMap                ftksetoverlaymap_
#define ftkNewCursor                    ftknewcursor_
#define ftkSetCursor                    ftksetcursor_
#define ftkRGBImageLoad                 ftkrgbimageload_
#define ftkCreateStrokeFont             ftkcreatestrokefont_
#define ftkCreateOutlineFont            ftkcreateoutlinefont_
#define ftkCreateFilledFont             ftkcreatefilledfont_
#define ftkCreateBitmapFont             ftkcreatebitmapfont_
#define ftkDrawStr                      ftkdrawstr_
#define ftkWireSphere                   ftkwiresphere_
#define ftkSolidSphere                  ftksolidsphere_
#define ftkWireCube                     ftkwirecube_
#define ftkSolidCube                    ftksolidcube_
#define ftkWireBox                      ftkwirebox_
#define ftkSolidBox                     ftksolidbox_
#define ftkWireTorus                    ftkwiretorus_
#define ftkSolidTorus                   ftksolidtorus_
#define ftkWireCylinder                 ftkwirecylinder_
#define ftkSolidCylinder                ftksolidcylinder_
#define ftkWireCone                     ftkwirecone_
#define ftkSolidCone                    ftksolidcone_
#elif FBIND==3
#define ftkInitDisplayMode              FTKINITDISPLAYMODE
#define ftkInitPosition                 FTKINITPOSITION
#define ftkInitWindow                   FTKINITWINDOW
#define ftkCloseWindow                  FTKCLOSEWINDOW
#define ftkQuit                         FTKQUIT
#define ftkSetWindowLevel               FTKSETWINDOWLEVEL
#define ftkSwapBuffers                  FTKSWAPBUFFERS
#define ftkExec                         FTKEXEC
#define ftkGetColorMapSize              FTKGETCOLORMAPSIZE
#define ftkGetMouseLoc                  FTKGETMOUSELOC
#define ftkGetSystem                    FTKGETSYSTEM
#define ftkSetOneColor                  FTKSETONECOLOR
#define ftkSetFogRamp                   FTKSETFOGRAMP
#define ftkSetGreyRamp                  FTKSETGREYRAMP
#define ftkSetRGBMap                    FTKSETRGBMAP
#define ftkSetOverlayMap                FTKSETOVERLAYMAP
#define ftkNewCursor                    FTKNEWCURSOR
#define ftkSetCursor                    FTKSETCURSOR
#define ftkRGBImageLoad                 FTKRGBIMAGELOAD
#define ftkCreateStrokeFont             FTKCREATESTROKEFONT
#define ftkCreateOutlineFont            FTKCREATEOUTLINEFONT
#define ftkCreateFilledFont             FTKCREATEFILLEDFONT
#define ftkCreateBitmapFont             FTKCREATEBITMAPFONT
#define ftkDrawStr                      FTKDRAWSTR
#define ftkWireSphere                   FTKWIRESPHERE
#define ftkSolidSphere                  FTKSOLIDSPHERE
#define ftkWireCube                     FTKWIRECUBE
#define ftkSolidCube                    FTKSOLIDCUBE
#define ftkWireBox                      FTKWIREBOX
#define ftkSolidBox                     FTKSOLIDBOX
#define ftkWireTorus                    FTKWIRETORUS
#define ftkSolidTorus                   FTKSOLIDTORUS
#define ftkWireCylinder                 FTKWIRECYLINDER
#define ftkSolidCylinder                FTKSOLIDCYLINDER
#define ftkWireCone                     FTKWIRECONE
#define ftkSolidCone                    FTKSOLIDCONE
#endif
#if FBIND==1
#define ftkTkNull          ftknull
#define ftkExposeFunc      ftkexposefunc
#define ftkReshapeFunc     ftkreshapefunc
#define ftkDisplayFunc     ftkdisplayfunc
#define ftkKeyDownFunc     ftkkeydownfunc
#define ftkMouseDownFunc   ftkmousedownfunc
#define ftkMouseUpFunc     ftkmouseupfunc
#define ftkMouseMoveFunc   ftkmousemovefunc
#define ftkIdleFunc        ftkidlefunc
#define fTK_IS_RGB         ftk_is_rgb
#define fTK_IS_INDEX       ftk_is_index
#define fTK_IS_SINGLE      ftk_is_single
#define fTK_IS_DOUBLE      ftk_is_double
#define fTK_IS_DIRECT      ftk_is_direct
#define fTK_IS_INDIRECT    ftk_is_indirect
#define fTK_HAS_ACCUM      ftk_has_accum
#define fTK_HAS_ALPHA      ftk_has_alpha
#define fTK_HAS_DEPTH      ftk_has_depth
#define fTK_HAS_OVERLAY    ftk_has_overlay
#define fTK_HAS_UNDERLAY   ftk_has_underlay
#define fTK_HAS_STENCIL    ftk_has_stencil
#define fTK_SETCOLOR       ftk_setcolor
#elif FBIND==2
#define ftkTkNull          ftknull_
#define ftkExposeFunc      ftkexposefunc_
#define ftkReshapeFunc     ftkreshapefunc_
#define ftkDisplayFunc     ftkdisplayfunc_
#define ftkKeyDownFunc     ftkkeydownfunc_
#define ftkMouseDownFunc   ftkmousedownfunc_
#define ftkMouseUpFunc     ftkmouseupfunc_
#define ftkMouseMoveFunc   ftkmousemovefunc_
#define ftkIdleFunc        ftkidlefunc_
#define fTK_IS_RGB         ftk_is_rgb_
#define fTK_IS_INDEX       ftk_is_index_
#define fTK_IS_SINGLE      ftk_is_single_
#define fTK_IS_DOUBLE      ftk_is_double_
#define fTK_IS_DIRECT      ftk_is_direct_
#define fTK_IS_INDIRECT    ftk_is_indirect_
#define fTK_HAS_ACCUM      ftk_has_accum_
#define fTK_HAS_ALPHA      ftk_has_alpha_
#define fTK_HAS_DEPTH      ftk_has_depth_
#define fTK_HAS_OVERLAY    ftk_has_overlay_
#define fTK_HAS_UNDERLAY   ftk_has_underlay_
#define fTK_HAS_STENCIL    ftk_has_stencil_
#define fTK_SETCOLOR       ftk_setcolor_
#elif FBIND==3
#define ftkTkNull          FTKNULL
#define ftkExposeFunc      FTKEXPOSEFUNC
#define ftkReshapeFunc     FTKRESHAPEFUNC
#define ftkDisplayFunc     FTKDISPLAYFUNC
#define ftkKeyDownFunc     FTKKEYDOWNFUNC
#define ftkMouseDownFunc   FTKMOUSEDOWNFUNC
#define ftkMouseUpFunc     FTKMOUSEUPFUNC
#define ftkMouseMoveFunc   FTKMOUSEMOVEFUNC
#define ftkIdleFunc        FTKIDLEFUNC
#define fTK_IS_RGB         FTK_IS_RGB
#define fTK_IS_INDEX       FTK_IS_INDEX
#define fTK_IS_SINGLE      FTK_IS_SINGLE
#define fTK_IS_DOUBLE      FTK_IS_DOUBLE
#define fTK_IS_DIRECT      FTK_IS_DIRECT
#define fTK_IS_INDIRECT    FTK_IS_INDIRECT
#define fTK_HAS_ACCUM      FTK_HAS_ACCUM
#define fTK_HAS_ALPHA      FTK_HAS_ALPHA
#define fTK_HAS_DEPTH      FTK_HAS_DEPTH
#define fTK_HAS_OVERLAY    FTK_HAS_OVERLAY
#define fTK_HAS_UNDERLAY   FTK_HAS_UNDERLAY
#define fTK_HAS_STENCIL    FTK_HAS_STENCIL
#define fTK_SETCOLOR       FTK_SETCOLOR
#endif

typedef void (*ftkexposeFCB)(int *, int *);
typedef void (*ftkreshapeFCB)(int *, int *);
typedef void (*ftkdisplayFCB)(void);
typedef GLenum (*ftkkeydownFCB)(int *, GLenum *);
typedef GLenum (*ftkmousedownFCB)(int *, int *, GLenum *);
typedef GLenum (*ftkmouseupFCB)(int *, int *, GLenum *);
typedef GLenum (*ftkmousemoveFCB)(int *, int *, GLenum *);
typedef void (*ftkidleFCB)(void);

ftkexposeFCB fexpose;
ftkreshapeFCB freshape;
ftkdisplayFCB fdisplay;
ftkkeydownFCB fkeydown;
ftkmousedownFCB fmousedown;
ftkmouseupFCB fmouseup;
ftkmousemoveFCB fmousemove;
ftkidleFCB fidle;

/* wrapper functions */

void ftkInitDisplayMode( f90glenum type )
{
   tkInitDisplayMode( (GLenum) *type );
}

void ftkInitPosition( f90glcint x, f90glcint y, f90glcint width,
    f90glcint height )
{
   tkInitPosition( (int) *x, (int) *y, (int) *width, (int) *height );
}

GLenum ftkInitWindow( char *title, int len )
{
   title[len] = end_of_string;
   return (GLenum) tkInitWindow( (char *) title );
}

void ftkCloseWindow( void )
{
   tkCloseWindow();
}

void ftkQuit( void )
{
   tkQuit();
}

GLenum ftkSetWindowLevel( f90glenum level )
{
   return (GLenum) tkSetWindowLevel( (GLenum) *level );
}

void ftkSwapBuffers( void )
{
   tkSwapBuffers();
}

void ftkExec( void )
{
   tkExec();
}

int ftkGetColorMapSize( void )
{
   return (int) tkGetColorMapSize();
}

void ftkGetMouseLoc( f90glcint x, f90glcint y )
{
   tkGetMouseLoc( (int *) x, (int *) y );
}

void ftkGetSystem( f90glenum type, void * ptr )
{
   tkGetSystem( (GLenum) *type, ptr );
}

void ftkSetOneColor( f90glcint index, f90glcfloat r, f90glcfloat g,
    f90glcfloat b )
{
   tkSetOneColor( (int) *index, (float) *r, (float) *g, (float) *b );
}

void ftkSetFogRamp( f90glcint density, f90glcint startIndex )
{
   tkSetFogRamp( (int) *density, (int) *startIndex );
}

void ftkSetGreyRamp( void )
{
   tkSetGreyRamp();
}

void ftkSetRGBMap( f90glcint size, f90glcfloat rbg )
{
   tkSetRGBMap( (int) *size, (float *) rbg );
}

void ftkSetOverlayMap( f90glcint size, f90glcfloat rgb )
{
   tkSetOverlayMap( (int) *size, (float *) rgb );
}

void ftkNewCursor( f90glint id, f90glubyte shapeBuf, f90glubyte maskBuf,
    f90glenum fgColor, f90glenum bgColor, f90glint hotX, f90glint hotY )
{
   tkNewCursor( (GLint) *id, (GLubyte *) shapeBuf, (GLubyte *) maskBuf,
    (GLenum) *fgColor, (GLenum) *bgColor, (GLint) *hotX, (GLint) *hotY );
}

void ftkSetCursor( f90glint id )
{
   tkSetCursor( (GLint) *id );
}

TK_RGBImageRec * ftkRGBImageLoad( char *fileName, int len )
{
   fileName[len] = end_of_string;
   return (TK_RGBImageRec *) tkRGBImageLoad( (char *) fileName );
}

GLenum ftkCreateStrokeFont( f90gluint fontBase )
{
   return (GLenum) tkCreateStrokeFont( (GLuint) *fontBase );
}

GLenum ftkCreateOutlineFont( f90gluint fontBase )
{
   return (GLenum) tkCreateOutlineFont( (GLuint) *fontBase );
}

GLenum ftkCreateFilledFont( f90gluint fontBase )
{
   return (GLenum) tkCreateFilledFont( (GLuint) *fontBase );
}

GLenum ftkCreateBitmapFont( f90gluint fontBase )
{
   return (GLenum) tkCreateBitmapFont( (GLuint) *fontBase );
}

void ftkDrawStr( f90gluint base, char *str, int len )
{
   str[len] = end_of_string;
   tkDrawStr( (GLuint) *base, (char *) str );
}

void ftkWireSphere( f90gluint base, f90glcfloat radius )
{
   tkWireSphere( (GLuint) *base, (float) *radius );
}

void ftkSolidSphere( f90gluint base, f90glcfloat radius )
{
   tkSolidSphere( (GLuint) *base, (float) *radius );
}

void ftkWireCube( f90gluint base, f90glcfloat size )
{
   tkWireCube( (GLuint) *base, (float) *size );
}

void ftkSolidCube( f90gluint base, f90glcfloat size )
{
   tkSolidCube( (GLuint) *base, (float) *size );
}

void ftkWireBox( f90gluint base, f90glcfloat width, f90glcfloat height,
    f90glcfloat depth )
{
   tkWireBox( (GLuint) *base, (float) *width, (float) *height,
    (float) *depth );
}

void ftkSolidBox( f90gluint base, f90glcfloat width, f90glcfloat height,
    f90glcfloat depth )
{
   tkSolidBox( (GLuint) *base, (float) *width, (float) *height,
    (float) *depth );
}

void ftkWireTorus( f90gluint base, f90glcfloat innerRadius,
    f90glcfloat outerRadius )
{
   tkWireTorus( (GLuint) *base, (float) *innerRadius, (float) *outerRadius );
}

void ftkSolidTorus( f90gluint base, f90glcfloat innerRadius,
    f90glcfloat outerRadius )
{
   tkSolidTorus( (GLuint) *base, (float) *innerRadius,
    (float) *outerRadius );
}

void ftkWireCylinder( f90gluint base, f90glcfloat radius,
    f90glcfloat height )
{
   tkWireCylinder( (GLuint) *base, (float) *radius, (float) *height );
}

void ftkSolidCylinder( f90gluint base, f90glcfloat radius,
    f90glcfloat height )
{
   tkSolidCylinder( (GLuint) *base, (float) *radius, (float) *height );
}

void ftkWireCone( f90gluint base, f90glcfloat b, f90glcfloat h )
{
   tkWireCone( (GLuint) *base, (float) *b, (float) *h );
}

void ftkSolidCone( f90gluint base, f90glcfloat b, f90glcfloat h )
{
   tkSolidCone( (GLuint) *base, (float) *b, (float) *h );
}

void
ftkTkNull(void)
{
}

static void
ftkExposeWrapper(int w, int h)
{
  (*fexpose) (&w, &h);
}

static void
ftkReshapeWrapper(int w, int h)
{
  (*freshape) (&w, &h);
}

static void
ftkDisplayWrapper(void)
{
  (*fdisplay) ();
}

GLenum ftkKeyDownWrapper(int key, GLenum mask)
{
  return (*fkeydown) (&key, &mask);
}

GLenum ftkMouseDownWrapper(int x, int y, GLenum mask)
{
  return (*fmousedown) (&x, &y, &mask);
}

GLenum ftkMouseUpWrapper(int x, int y, GLenum mask)
{
  return (*fmouseup) (&x, &y, &mask);
}

GLenum ftkMouseMoveWrapper(int x, int y, GLenum mask)
{
  return (*fmousemove) (&x, &y, &mask);
}

static void
ftkIdleWrapper(void)
{
  (*fidle) ();
}

void
ftkExposeFunc(ftkexposeFCB expose)
{
  if (expose == (ftkexposeFCB) ftkTkNull) {
    tkExposeFunc(NULL);
  } else {
    tkExposeFunc(ftkExposeWrapper);
    fexpose = expose;
  }
}

void
ftkReshapeFunc(ftkreshapeFCB reshape)
{
  if (reshape == (ftkreshapeFCB) ftkTkNull) {
    tkReshapeFunc(NULL);
  } else {
    tkReshapeFunc(ftkReshapeWrapper);
    freshape = reshape;
  }
}

void
ftkDisplayFunc(ftkdisplayFCB display)
{
  if (display == (ftkdisplayFCB) ftkTkNull) {
    tkDisplayFunc(NULL);
  } else {
    tkDisplayFunc(ftkDisplayWrapper);
    fdisplay = display;
  }
}

void
ftkKeyDownFunc(ftkkeydownFCB keydown)
{
  if (keydown == (ftkkeydownFCB) ftkTkNull) {
    tkKeyDownFunc(NULL);
  } else {
    tkKeyDownFunc(ftkKeyDownWrapper);
    fkeydown = keydown;
  }
}

void
ftkMouseDownFunc(ftkmousedownFCB mousedown)
{
  if (mousedown == (ftkmousedownFCB) ftkTkNull) {
    tkMouseDownFunc(NULL);
  } else {
    tkMouseDownFunc(ftkMouseDownWrapper);
    fmousedown = mousedown;
  }
}

void
ftkMouseUpFunc(ftkmouseupFCB mouseup)
{
  if (mouseup == (ftkmouseupFCB) ftkTkNull) {
    tkMouseUpFunc(NULL);
  } else {
    tkMouseUpFunc(ftkMouseUpWrapper);
    fmouseup = mouseup;
  }
}

void
ftkMouseMoveFunc(ftkmousemoveFCB mousemove)
{
  if (mousemove == (ftkmousemoveFCB) ftkTkNull) {
    tkMouseMoveFunc(NULL);
  } else {
    tkMouseMoveFunc(ftkMouseMoveWrapper);
    fmousemove = mousemove;
  }
}

void
ftkIdleFunc(ftkidleFCB idle)
{
  if (idle == (ftkidleFCB) ftkTkNull) {
    tkIdleFunc(NULL);
  } else {
    tkIdleFunc(ftkIdleWrapper);
    fidle = idle;
  }
}

int fTK_IS_RGB(f90glcint x)
{
  return (int) (((*x) & TK_INDEX) == 0);
}

int fTK_IS_INDEX(f90glcint x)
{
  return (int) (((*x) & TK_INDEX) != 0);
}

int fTK_IS_SINGLE(f90glcint x)
{
  return (int) (((*x) & TK_DOUBLE) == 0);
}

int fTK_IS_DOUBLE(f90glcint x) 
{ 
  return (int) (((*x) & TK_DOUBLE) != 0);
}

int fTK_IS_DIRECT(f90glcint x) 
{ 
  return (int) (((*x) & TK_INDIRECT) == 0); 
} 
 
int fTK_IS_INDIRECT(f90glcint x)  
{  
  return (int) (((*x) & TK_INDIRECT) != 0);  
}  
 
int fTK_HAS_ACCUM(f90glcint x)  
{  
  return (int) (((*x) & TK_ACCUM) != 0);  
}   
  
int fTK_HAS_ALPHA(f90glcint x)   
{   
  return (int) (((*x) & TK_ALPHA) != 0);   
}    
   
int fTK_HAS_DEPTH(f90glcint x)    
{    
  return (int) (((*x) & TK_DEPTH) != 0);    
}     
    
int fTK_HAS_OVERLAY(f90glcint x)     
{     
  return (int) (((*x) & TK_OVERLAY) != 0);     
}      
     
int fTK_HAS_UNDERLAY(f90glcint x)      
{      
  return (int) (((*x) & TK_UNDERLAY) != 0);      
}       
      
int fTK_HAS_STENCIL(f90glcint x)       
{       
  return (int) (((*x) & TK_STENCIL) != 0);       
}

void fTK_SETCOLOR(f90glcint x, f90glcint y)
{
  (TK_IS_RGB((*x)) ? glColor3fv(tkRGBMap[(*y)]) : glIndexi((*y)));
}

#else /*ifdef FBIND*/



/* If FBIND is not defined, Fortran bindings aren't made.  Need this
 * dummy function for some picky compilers.
 */
static void dummy()
{
   return;
}

 
 
#endif /*ifdef FBIND*/
